(* -----------------------------------------------------------------------------
  AddText              : 1.0
  Copyright  2016     : Copyright Adirondack Software & Graphics
  Last Modification    : 05-20-2016
  Source File          : uAddText.pas
  ImageEn              : 6.3.0
  Compiler             : Delphi10Seattle
  PlatForm             : VCL Windows 64-Bit
  Operating System     : Windows 10
  This file is copyright  W W Miller, 1986-2016
  It may be used without restriction. This code distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
  --------------------------------------------------------------------------- *)
unit uAddText;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ComCtrls, ExtCtrls, Contnrs, hyieutils, iexBitmaps,
  hyiedefs, iesettings, ieview, imageenview, iexHelperFunctions, iexLayers, iexRulers;

type
  TFormAddText = class(TForm)
    cxGroupBox1: TGroupBox;
    cxGroupBox2: TGroupBox;
    cxLabel1: TLabel;
    cxLabel2: TLabel;
    Ok1: TButton;
    Cancel1: TButton;
    cxLabel4: TLabel;
    AddShadow1: TCheckBox;
    cxGroupBox3: TGroupBox;
    Bold1: TCheckBox;
    Italic1: TCheckBox;
    Underline1: TCheckBox;
    Strikeout1: TCheckBox;
    cxGroupBox4: TGroupBox;
    ImageEnView1: TImageEnView;
    LayerText1: TEdit;
    cxLabel3: TLabel;
    Antialias1: TCheckBox;
    FontColor1: TColorBox;
    Size1: TEdit;
    FontSize1: TUpDown;
    Rotate1: TEdit;
    Angle1: TUpDown;
    FontName1: TComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    BlurRadius1: TUpDown;
    Label2: TLabel;
    Edit2: TEdit;
    ShadowRadius1: TUpDown;
    procedure FontName1PropertiesChange(Sender: TObject);
    procedure FontSize1PropertiesChange(Sender: TObject);
    procedure FontColor1PropertiesChange(Sender: TObject);
    procedure AddShadow1PropertiesChange(Sender: TObject);
    procedure Bold1PropertiesChange(Sender: TObject);
    procedure Italic1PropertiesChange(Sender: TObject);
    procedure Underline1PropertiesChange(Sender: TObject);
    procedure Strikeout1PropertiesChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LayerText1PropertiesChange(Sender: TObject);
    procedure LayerText1PropertiesEditValueChanged(Sender: TObject);
    procedure Angle1PropertiesChange(Sender: TObject);
    procedure Antialias1PropertiesChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FontName1Change(Sender: TObject);
    procedure Size1Change(Sender: TObject);
    procedure FontColor1Change(Sender: TObject);
    procedure AddShadow1Click(Sender: TObject);
    procedure Bold1Click(Sender: TObject);
    procedure Italic1Click(Sender: TObject);
    procedure Underline1Click(Sender: TObject);
    procedure Strikeout1Click(Sender: TObject);
    procedure Rotate1Change(Sender: TObject);
    procedure Antialias1Click(Sender: TObject);
    procedure LayerText1Change(Sender: TObject);
    procedure BlurRadius1Click(Sender: TObject; Button: TUDBtnType);
    procedure ShadowRadius1Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
    procedure Preview;
  public
    { Public declarations }
  end;

var
  FormAddText: TFormAddText;

implementation

{$R *.dfm}

uses unit1;

procedure TFormAddText.Preview;
var
  iInputText: string;
  iFontStyles: TFontStyles;
  iFontName: string;
  iFontSize: integer;
  iFontColor: TColor;
  iAddShadow: boolean;
  iBlurRadius: integer;
  iShadowOffset: integer;
  iAngle: integer;
  iAntialias: boolean;
begin
  if Assigned(Form1.PageControl1.ActivePage) then
  begin
    Form1.ImageEnView := TImageEnView(Form1.PageControl1.ActivePage.Controls[0]);
    if Assigned(Form1.ImageEnView ) then
    begin
      ImageEnView1.Assign(Form1.ImageEnView );
      ImageEnView1.Update;
      iInputText := LayerText1.Text;
      iFontName := FontName1.Items[FontName1.ItemIndex];
      iFontSize := FontSize1.Position;
      iFontColor := FontColor1.Selected;
      if Bold1.Checked then
        iFontStyles := [fsBold];
      if Italic1.Checked then
        iFontStyles := iFontStyles + [fsItalic];
      if Underline1.Checked then
        iFontStyles := iFontStyles + [fsUnderline];
      if Strikeout1.Checked then
        iFontStyles := iFontStyles + [fsStrikeout];
      iAddShadow := AddShadow1.Checked;
      iAngle := Angle1.Position;
      iAngle := -Abs(iAngle);
      iAntialias := Antialias1.Checked;
      iBlurRadius := BlurRadius1.Position;
      iShadowOffset := ShadowRadius1.Position;
      ImageEnView1.LayersCreateFromText(iInputText, iFontName, iFontSize,
        iFontColor, iFontStyles, iAddShadow, iBlurRadius, iShadowOffset, iAngle,
        iAntialias);
    end;
  end;
end;

procedure TFormAddText.Rotate1Change(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.ShadowRadius1Click(Sender: TObject; Button: TUDBtnType);
begin
  Preview;
end;

procedure TFormAddText.Size1Change(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.Strikeout1Click(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.Strikeout1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.Underline1Click(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.Underline1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.AddShadow1Click(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.AddShadow1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.Angle1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.Antialias1Click(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.Antialias1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.BlurRadius1Click(Sender: TObject; Button: TUDBtnType);
begin
  Preview;
end;

procedure TFormAddText.Bold1Click(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.Bold1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.FontColor1Change(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.FontColor1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.FontName1Change(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.FontName1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.FontSize1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.FormCreate(Sender: TObject);
var
  i: integer;
begin
  { Set the chessboard style }
  ImageEnView1.SetChessboardStyle(4);
  for i := 0 to Screen.Fonts.Count - 1 do
    FontName1.Items.Add(Screen.Fonts.Strings[i]);
end;

procedure TFormAddText.FormShow(Sender: TObject);
var
  iIndex: integer;
begin
  iIndex := FontName1.Items.IndexOf('Arial');
  FontName1.ItemIndex := iIndex;
end;

procedure TFormAddText.Italic1Click(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.Italic1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.LayerText1Change(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.LayerText1PropertiesChange(Sender: TObject);
begin
  Preview;
end;

procedure TFormAddText.LayerText1PropertiesEditValueChanged(Sender: TObject);
begin
  Preview;
end;

end.
