(* -----------------------------------------------------------------------------
  ImageEn 7.0 MultiFrame Editor With Frames, Layers and Brush Paint With IEBitmap Canvas And Alpha Channel Demo : 1.0
  Copyright  2017     : Copyright Adirondack Software & Graphics
  Last Modification    : 04-20-2017
  ImageEn              : 7.0
  Compiler             : Delphi Seattle
  Platform             : VCL Windows Win32/Win64
  Operating System     : Windows 10
  Note: Legacy Bitmap is disabled in this demo
  This buid supports multiframes, ImageEn version 7.0 image, text and shape layers, brush, line,
  rectangle and round rectaangle painting with IEBitmap, AlphaChannel and GDICanvas, PDF images with
  optional support for the WPCubed PDF PlugIn, printing, scanning, deskew and crop, resample, resize,
  croptool, curves, filling IEColorPalette with custiom palettes, and VCL Themeing and Styles.
  To support PDF images, obtain the WPCubed PDF PlugIn and uncomment the pdf code where indicated.
  This file is copyright  W W Miller, 1986-2017
  It may be used without restriction. This code distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
  --------------------------------------------------------------------------- *)

unit Unit1;
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms,
  System.Types, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.Imaging.jpeg, Vcl.Imaging.pngimage, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls,
  Vcl.Buttons, System.UITypes, System.Contnrs, Vcl.Menus, System.ImageList, Vcl.ImgList, System.Notification,
  hyieutils, iexBitmaps, hyiedefs, iesettings, ieview, ImageEnView, ieopensavedlg, iexHelperFunctions, iexWindowsFunctions,
  imageenproc, iegdiplus, iemview, iexRulers, iexColorPalette, iexLayers;
{ To add PDF file IO  support install wpcubedPDF and unremark the following }
{ wpcubed_pdf_plugin }

const
  WM_AFTER_SHOW = WM_USER + 300; { custom message }

const
  MAXPRINTERBUFFER = 8000;
  MAXPRINTERNAME = 500;
  MAXPRINTERINFO = 50;

type
  TPrinterBuffer = array [0 .. MAXPRINTERBUFFER - 1] of char;

type
  TPrinterDevice = class { type definition NOT interfaced by Printers.pas }
    Driver, Device, Port: string;
  end;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    OpenPictureDialog1: TOpenPictureDialog;
    ColorDialog1: TColorDialog;
    SavePictureDialog1: TSavePictureDialog;
    Panel3: TPanel;
    Exit2: TButton;
    Fit1: TSpeedButton;
    Undo1: TButton;
    PageControl2: TPageControl;
    TabSheet1: TTabSheet;
    New1: TButton;
    Clear1: TButton;
    Open1: TButton;
    LoadLayers1: TButton;
    SaveLayers1: TButton;
    Save1: TButton;
    SaveAs1: TButton;
    TabSheet2: TTabSheet;
    PaintBrush1: TSpeedButton;
    Line1: TSpeedButton;
    Rectangle1: TSpeedButton;
    RoundRectangle1: TSpeedButton;
    Ellipse1: TSpeedButton;
    TabSheet3: TTabSheet;
    ConvertTo32Bit1: TButton;
    ConvertTo24Bit1: TButton;
    TabSheet4: TTabSheet;
    AddLayer1: TButton;
    AddTextLayer1: TButton;
    AddImageLayer1: TButton;
    TabSheet5: TTabSheet;
    SelectNone1: TSpeedButton;
    SelectLayers1: TSpeedButton;
    RotateLayers1: TSpeedButton;
    MergeLayers1: TButton;
    AlignLayers1: TButton;
    RemoveLayer1: TButton;
    Crop1: TButton;
    Selection1: TSpeedButton;
    CloseAll1: TButton;
    TaskDialog1: TTaskDialog;
    TabSheet7: TTabSheet;
    Curves1: TButton;
    ScrollBox1: TScrollBox;
    GroupBox1: TGroupBox;
    LabelX1: TLabel;
    LabelY1: TLabel;
    OpacityUnderCursor1: TLabel;
    Label4: TLabel;
    LabelRGB1: TLabel;
    LabelColor1: TLabel;
    ColorUnderCursor1: TShape;
    AlphaUnderCursor1: TLabel;
    UseCurrentLayer1: TCheckBox;
    GroupBox4: TGroupBox;
    Label6: TLabel;
    Label12: TLabel;
    Label16: TLabel;
    PenColor: TPanel;
    PenOpacity1: TEdit;
    UpDown3: TUpDown;
    PenSize1: TEdit;
    UpDown9: TUpDown;
    TrackBarPenSize1: TTrackBar;
    TrackBarPenOpacity1: TTrackBar;
    PenColor1: TColorBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    BrushColor: TPanel;
    BrushOpacity1: TEdit;
    UpDown1: TUpDown;
    TrackBarBrushOpacity1: TTrackBar;
    BrushColor1: TColorBox;
    GroupBox5: TGroupBox;
    Layers1: TListView;
    PopupMenuLayers1: TPopupMenu;
    PopupMenuImageEnView1: TPopupMenu;
    AddLayer2: TMenuItem;
    AddTextLayer2: TMenuItem;
    AddImageLayer2: TMenuItem;
    MergeLayers2: TMenuItem;
    AlignLayers2: TMenuItem;
    RemoveLayer2: TMenuItem;
    New2: TMenuItem;
    Clear2: TMenuItem;
    ClearAll2: TMenuItem;
    Open2: TMenuItem;
    LoadLayers2: TMenuItem;
    SaveLayers2: TMenuItem;
    Save2: TMenuItem;
    SaveAs2: TMenuItem;
    PaintBrush2: TMenuItem;
    Line2: TMenuItem;
    Rectangle2: TMenuItem;
    RoundRectangle2: TMenuItem;
    Ellipse2: TMenuItem;
    AddLayer3: TMenuItem;
    AddTextLayer3: TMenuItem;
    AddImageLayer3: TMenuItem;
    MergeLayers3: TMenuItem;
    AlignLayers3: TMenuItem;
    RemoveLayer3: TMenuItem;
    SelectNone2: TMenuItem;
    SelectLayers2: TMenuItem;
    RotateLayers2: TMenuItem;
    Selection2: TMenuItem;
    Crop2: TMenuItem;
    ConvertTo32Bit2: TMenuItem;
    ConvertTo24Bit2: TMenuItem;
    RotateAndCrop2: TMenuItem;
    Curves2: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    Print1: TButton;
    Panel2: TPanel;
    cxScrollBox2: TScrollBox;
    cxGroupBox5: TGroupBox;
    ImageEnMView1: TImageEnMView;
    TabSheet8: TTabSheet;
    NewFrame1: TButton;
    AddFrame1: TButton;
    DeleteFrame1: TButton;
    PopupMenuFrames1: TPopupMenu;
    NewFrame2: TMenuItem;
    AddFrame2: TMenuItem;
    DeleteFrame2: TMenuItem;
    PopupMenuMRF1: TPopupMenu;
    Printers1: TComboBox;
    MultipleLayerSelection1: TCheckBox;
    ResizeAllLayers1: TButton;
    RotateSelectedLayers1: TButton;
    ResizeSelectedLayers1: TButton;
    ConvertTo8Bit1: TButton;
    ConvertTo4Bit1: TButton;
    Cut1: TButton;
    Copy1: TButton;
    Paste1: TButton;
    Setup1: TButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    Exit1: TButton;
    Exit3: TButton;
    Exit10: TButton;
    Exit4: TButton;
    Exit5: TButton;
    Exit6: TButton;
    Exit7: TButton;
    GroupLayers2: TMenuItem;
    UseGDIPlus1: TCheckBox;
    Antialias1: TCheckBox;
    DrawFilled1: TCheckBox;
    PageControl1: TPageControl;
    CloseActivePage1: TButton;
    DisplayGrid1: TCheckBox;
    MoveUp1: TButton;
    MoveDown1: TButton;
    Tint1: TButton;
    Polygon1: TSpeedButton;
    IncreaseBrightness1: TButton;
    DecreaseBrightness1: TButton;
    SelectEllipse1: TSpeedButton;
    cxGroupBoxPen1: TGroupBox;
    GroupBoxBrush1: TGroupBox;
    IEColorPalettePen1: TIEColorPalette;
    ComboBoxPenPalette1: TComboBox;
    IEColorPaletteBrush1: TIEColorPalette;
    ComboBoxBrushPalette1: TComboBox;
    Panel4: TPanel;
    MoveUp2: TMenuItem;
    MoveDown2: TMenuItem;
    imlDevices: TImageList;
    TabSheet6: TTabSheet;
    Styles1: TComboBox;
    Label19: TLabel;
    GetPrinterNames1: TButton;
    Acquire1: TButton;
    TrackBarZoom1: TTrackBar;
    LabelZoom1: TLabel;
    Resample1: TButton;
    Resize1: TButton;
    TabSheet9: TTabSheet;
    Label25: TLabel;
    TextFont1: TComboBox;
    Label26: TLabel;
    LayerFontSize1: TEdit;
    TextFontSize1: TUpDown;
    Label27: TLabel;
    TextFontColorBox1: TColorBox;
    AutoSize1: TCheckBox;
    LayerPreviewQuality1: TComboBox;
    lblPreviewQuality: TLabel;
    LayerCaching1: TCheckBox;
    FontDialog1: TFontDialog;
    Font1: TButton;
    PencilSketch1: TButton;
    Grayscale1: TCheckBox;
    ShowRulers1: TCheckBox;
    Exit9: TButton;
    Exit11: TButton;
    DeselectLayers1: TButton;
    UnGroupLayers1: TButton;
    GroupLayers1: TButton;
    ScrollBox2: TScrollBox;
    GroupBox6: TGroupBox;
    Label18: TLabel;
    Sources1: TComboBox;
    DCIM1: TCheckBox;
    WIA1: TCheckBox;
    Twain1: TCheckBox;
    Abort1: TButton;
    GetScannerNames1: TButton;
    SelectCrop1: TButton;
    GroupBox8: TGroupBox;
    Label3: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label32: TLabel;
    ResY1: TEdit;
    ResX1: TEdit;
    Colors1: TComboBox;
    Orientation1: TComboBox;
    Rotation1: TComboBox;
    FeederEnabled1: TCheckBox;
    AutoFeed1: TCheckBox;
    DuplexEnabled1: TCheckBox;
    LoadDevicesAtStartup1: TCheckBox;
    VisibleDialog1: TCheckBox;
    EnableLogging1: TCheckBox;
    grpFrame: TGroupBox;
    Label24: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    FrameEnabled1: TCheckBox;
    Left1: TEdit;
    Right1: TEdit;
    Top1: TEdit;
    Bottom1: TEdit;
    SaveParameters1: TButton;
    UnGroupLayers2: TMenuItem;
    PopupMenuImage1: TPopupMenu;
    IncreaseBrightness2: TMenuItem;
    DecreaseBrightness2: TMenuItem;
    Tint2: TMenuItem;
    PencilSketch2: TMenuItem;
    DeSkew1: TButton;
    RemoveRedEyes1: TButton;
    N1: TMenuItem;
    RemoveLayer4: TMenuItem;
    MergeLayers4: TMenuItem;
    ConverttoRGBA32Bit1: TMenuItem;
    ConvertTo24Bit3: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    DeSkewAndCrop1: TMenuItem;
    DeskewAndCrop2: TMenuItem;
    ImageList1: TImageList;
    ExportFrame2: TMenuItem;
    ExportFrame1: TButton;
    NotificationCenter1: TNotificationCenter;
    EnableAlphaChannel1: TCheckBox;
    Cast1: TSpeedButton;
    CastColor1: TSpeedButton;
    CastAlpha1: TSpeedButton;
    Label31: TLabel;
    FillTolerance1: TEdit;
    UpDown4: TUpDown;
    Pick1: TSpeedButton;
    PickColor1: TSpeedButton;
    PickAlpha1: TSpeedButton;
    ConvertToImageLayer1: TButton;
    Label35: TLabel;
    Shape1: TComboBox;
    AddShapeLayer1: TButton;
    TabSheet10: TTabSheet;
    Label9: TLabel;
    BorderColorBox1: TColorBox;
    Label10: TLabel;
    FillColorBox1: TColorBox;
    Label11: TLabel;
    GradientColorBox1: TColorBox;
    Label13: TLabel;
    BorderWidth1: TEdit;
    Width1: TUpDown;
    Label14: TLabel;
    RoundRectangleRadius1: TEdit;
    UpDown2: TUpDown;
    Exit8: TButton;
    procedure ConvertTo32Bit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure PenColorClick(Sender: TObject);
    procedure AddLayer1Click(Sender: TObject);
    procedure RemoveLayer1Click(Sender: TObject);
    procedure TrackBarPenSize1Change(Sender: TObject);
    procedure TrackBarPenOpacity1Change(Sender: TObject);
    procedure PenSize1Change(Sender: TObject);
    procedure PenOpacity1Change(Sender: TObject);
    procedure PenColor1Change(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure MergeLayers1Click(Sender: TObject);
    procedure LoadLayers1Click(Sender: TObject);
    procedure SaveLayers1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Fit1Click(Sender: TObject);
    procedure PaintBrush1Click(Sender: TObject);
    procedure AddTextLayer1Click(Sender: TObject);
    procedure SelectNone1Click(Sender: TObject);
    procedure SelectLayers1Click(Sender: TObject);
    procedure AddImageLayer1Click(Sender: TObject);
    procedure RotateLayers1Click(Sender: TObject);
    procedure AlignLayers1Click(Sender: TObject);
    procedure BrushColorClick(Sender: TObject);
    procedure BrushColor1Change(Sender: TObject);
    procedure BrushOpacity1Change(Sender: TObject);
    procedure TrackBarBrushOpacity1Change(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure ConvertTo24Bit1Click(Sender: TObject);
    procedure Crop1Click(Sender: TObject);
    procedure Selection1Click(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure SelectCrop1Click(Sender: TObject);
    procedure Curves1Click(Sender: TObject);
    procedure Layers1SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure Line1Click(Sender: TObject);
    procedure Rectangle1Click(Sender: TObject);
    procedure RoundRectangle1Click(Sender: TObject);
    procedure Ellipse1Click(Sender: TObject);
    procedure PopupMenuLayers1Popup(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure ImageEnMView1ImageSelect(Sender: TObject; idx: Integer);
    procedure NewFrame1Click(Sender: TObject);
    procedure AddFrame1Click(Sender: TObject);
    procedure DeleteFrame1Click(Sender: TObject);
    procedure PopupMenuFrames1Popup(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PopupMenuMRF1Popup(Sender: TObject);
    procedure Printers1Change(Sender: TObject);
    procedure MultipleLayerSelection1Click(Sender: TObject);
    procedure GroupLayers1Click(Sender: TObject);
    procedure ResizeAllLayers1Click(Sender: TObject);
    procedure RotateSelectedLayers1Click(Sender: TObject);
    procedure ResizeSelectedLayers1Click(Sender: TObject);
    procedure ConvertTo8Bit1Click(Sender: TObject);
    procedure ConvertTo4Bit1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Setup1Click(Sender: TObject);
    procedure GroupLayers2Click(Sender: TObject);
    procedure CloseActivePage1Click(Sender: TObject);
    procedure CloseAllPages1Click(Sender: TObject);
    procedure PageControl1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure IEColorPalettePen1SelectedColorChange(Sender: TObject);
    procedure IEColorPaletteBrush1SelectedColorChange(Sender: TObject);
    procedure IEColorPalettePen1GetHintText(AColor: TColor; Index: Integer; var HintStr: string);
    procedure IEColorPaletteBrush1GetHintText(AColor: TColor; Index: Integer; var HintStr: string);
    procedure DisplayGrid1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure MoveUp1Click(Sender: TObject);
    procedure MoveDown1Click(Sender: TObject);
    procedure Tint1Click(Sender: TObject);
    procedure Polygon1Click(Sender: TObject);
    procedure IncreaseBrightness1Click(Sender: TObject);
    procedure DecreaseBrightness1Click(Sender: TObject);
    procedure SelectEllipse1Click(Sender: TObject);
    procedure ComboBoxPenPalette1Change(Sender: TObject);
    procedure Acquire1Click(Sender: TObject);
    procedure Sources1Change(Sender: TObject);
    procedure Sources1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure Styles1Click(Sender: TObject);
    procedure GetPrinterNames1Click(Sender: TObject);
    procedure GetScannerNames1Click(Sender: TObject);
    procedure TrackBarZoom1Change(Sender: TObject);
    procedure Resample1Click(Sender: TObject);
    procedure Resize1Click(Sender: TObject);
    procedure BorderColorBox1Change(Sender: TObject);
    procedure FillColorBox1Change(Sender: TObject);
    procedure GradientColorBox1Change(Sender: TObject);
    procedure Width1Click(Sender: TObject; Button: TUDBtnType);
    procedure TextFont1Change(Sender: TObject);
    procedure TextFontSize1Click(Sender: TObject; Button: TUDBtnType);
    procedure TextFontColorBox1Change(Sender: TObject);
    procedure AutoSize1Click(Sender: TObject);
    procedure LayerPreviewQuality1Change(Sender: TObject);
    procedure LayerCaching1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure PencilSketch1Click(Sender: TObject);
    procedure ShowRulers1Click(Sender: TObject);
    procedure DeselectLayers1Click(Sender: TObject);
    procedure UnGroupLayers1Click(Sender: TObject);
    procedure CheckParameters1Click(Sender: TObject);
    procedure FeederEnabled1Click(Sender: TObject);
    procedure DuplexEnabled1Click(Sender: TObject);
    procedure AutoFeed1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Colors1Change(Sender: TObject);
    procedure Orientation1Change(Sender: TObject);
    procedure Rotation1Change(Sender: TObject);
    procedure XRes1Change(Sender: TObject);
    procedure YRes1Change(Sender: TObject);
    procedure Left1Change(Sender: TObject);
    procedure Top1Change(Sender: TObject);
    procedure Right1Change(Sender: TObject);
    procedure Bottom1Change(Sender: TObject);
    procedure SaveParameters1Click(Sender: TObject);
    procedure DeSkew1Click(Sender: TObject);
    procedure RemoveRedEyes1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ExportFrame1Click(Sender: TObject);
    procedure EnableAlphaChannel1Click(Sender: TObject);
    procedure Cast1Click(Sender: TObject);
    procedure CastColor1Click(Sender: TObject);
    procedure CastAlpha1Click(Sender: TObject);
    procedure Pick1Click(Sender: TObject);
    procedure PickColor1Click(Sender: TObject);
    procedure PickAlpha1Click(Sender: TObject);
    procedure ConvertToImageLayer1Click(Sender: TObject);
    procedure Shape1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure AddShapeLayer1Click(Sender: TObject);
    procedure Shape1Change(Sender: TObject);
    procedure PageControl2Change(Sender: TObject);
  private
    { Private declarations }
    AIniFilename: string;
    AFilename: string;
    ALayerFileName: string;
    AMostRecentFiles: TStringlist;
    TabSheet: TTabSheet;
    ABX: Integer;
    ABY: Integer;
    AStartX: Integer;
    AStartY: Integer;
    ALastX: Integer;
    ALastY: Integer;
    procedure AddTabsheet;
    procedure MyUndo(AImageEnView: TImageEnView);
    procedure PaintBrush(AX, AY: Integer);
    procedure DrawLine;
    procedure DrawFilledRectangle;
    procedure DrawFilledRoundRectangle;
    procedure DrawRectangle;
    procedure DrawRoundRectangle;
    procedure DrawEllipse;
    procedure DrawFilledEllipse;
    procedure UpdateFrames;
    procedure ConvertTo24Bit;
    procedure ConvertTo32Bit;
    procedure ConvertTo4Bit;
    procedure ConvertTo8Bit;
    procedure ClearStatusBar;
    procedure ClearRecentFiles(Sender: TObject);
    procedure LoadRecentFiles(const AIniFilename: string; ASection: string);
    procedure SaveRecentFiles(const AIniFilename: string; ASection: string);
    procedure LoadRecentFile(Sender: TObject);
    procedure ReadIni(IniFilename: string);
    procedure WriteIni(IniFilename: string);
    procedure GetPrinterNames;
    function ParseNames(const ANameBuffer: TPrinterBuffer; var AStartPos: Integer): string;
    function SetPrinter(const APrinterName: String): Boolean;
    procedure ImageEnViewDrawBackBuffer(Sender: TObject);
    procedure ImageEnViewMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ImageEnViewMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ImageEnViewMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ImageEnViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    // procedure ImageEnViewDrawLayer(Sender: TObject; dest: TIEBitmap; LayerIndex: Integer);
    // procedure ImageEnViewLayerSelectionChange(Sender: TObject);
    procedure ImageEnViewLayerNotify(Sender: TObject; layer: Integer; Event: TIELayerEvent);
    procedure ImageEnViewSelectionChange(Sender: TObject);
    procedure ImageEnViewSelectionChanging(Sender: TObject);
    procedure ImageEnViewSpecialKey(Sender: TObject; CharCode: Word; Shift: TShiftState; var Handled: Boolean);
    procedure ImageEnViewImageChange(Sender: TObject);
    procedure ImageEnViewViewChange(Sender: TObject; Change: Integer);
    procedure ImageEnViewNewLayer(Sender: TObject; LayerIdx: Integer; LayerKind: TIELayerKind);
    procedure ImageEnViewDrawLayerBox(Sender: TObject; ABitmap: TBitmap; layer: Integer);
    procedure UpdatePageControl;
    function IsMultiFrameImage: Boolean;
    procedure UpdateTabSheets;
    procedure DxColorMap;
    procedure GeneratePalette(ABaseColor: TColor);
    procedure JascColorMap;
    procedure SaveProperties;
    procedure UpdateControlStatus(ASelectDevice: Boolean = False);
    procedure LoadStyles;
    procedure GetLayerTextParameters;
    procedure SetLayerTextParameters;
    procedure SetLayerShapeParameters;
    procedure GetLayerShapeParameters;
    procedure PickAlpha(X, Y: Integer);
    procedure PickColor(X, Y: Integer);
  public
    { Public declarations }
    AInternalChange: Boolean;
    ImageEnView: TImageEnView;
    procedure UpdateStatusBar;
    procedure UpdateGUI;
    procedure UpdateLayers;
    procedure UpdateFrame;
  protected
    { Protected declsrstions }
    procedure WmAfterShow(var Msg: TMessage); message WM_AFTER_SHOW;
  end;

var
  Form1: TForm1;
  APrinterNames: TStringlist;
  ADefaultPrinter: Integer;

implementation

{$R *.dfm}

uses Vcl.FileCtrl, Winapi.ShlObj, System.AnsiStrings, System.Inifiles, Vcl.Printers, System.Math, PalUtils, iexAcquire,
  iexCanvasUtils, IOUtils, Vcl.Styles, Vcl.Themes, uNewImage, uAddText, uCurves, uResample, uResize;

const
  Acquire_Orientation: array [ieaoPortrait .. ieaoRotate180] of string = ('Portrait', 'Landscape', 'Rotate 90',
    'Rotate 180');
  Acquire_Rotation: array [iearNone .. iear270CW] of string = ('None', '90 deg. clockwise', '180 deg. clockwise',
    '270 deg. clockwise');
  Acquire_PixelType: array [ieapMonochrome .. ieapOther] of string = ('Monochrome', '8 bit GrayScale', '16 bit GrayScale',
    'Full Color', '16 bit Full Color', 'Other');

function AppDataFolder: string;
{ Find AppData folder location. }
var
  iResult: bool;
  iPath: array [0 .. MAX_PATH] of char;
begin
  iResult := Winapi.ShlObj.ShGetSpecialFolderPath(0, iPath, CSIDL_LOCAL_APPDATA, False);
  if not iResult then
    raise Exception.Create('Could not find LocalAppData folder location.');
  Result := IncludeTrailingPathDelimiter(iPath);
end;

function DocumentsFolder: string;
{ Find Documents folder location. }
var
  iResult: bool;
  iPath: array [0 .. MAX_PATH] of char;
begin
  iResult := Winapi.ShlObj.ShGetSpecialFolderPath(0, iPath, CSIDL_PERSONAL, False);
  if not iResult then
    raise Exception.Create('Could not find Documents folder location.');
  Result := IncludeTrailingPathDelimiter(iPath);
end;

function DesktopFolder: string;
{ Find Desktop folder location. }
var
  iResult: bool;
  iPath: array [0 .. MAX_PATH] of char;
begin
  iResult := Winapi.ShlObj.ShGetSpecialFolderPath(0, iPath, CSIDL_DESKTOPDIRECTORY, False);
  if not iResult then
    raise Exception.Create('Could not find Documents folder location.');
  Result := IncludeTrailingPathDelimiter(iPath);
end;

function AddThousandSeparator(const AString: string; const AChar: char): string;
{ Add a specified thousand separator in the correct location in a string. }
var
  i: Integer; { Loop through separator position }
begin
  Result := AString;
  i := Length(AString) - 2;
  while i > 1 do
  begin
    Insert(AChar, Result, i);
    i := i - 3;
  end;
end;

function AddDefThousandSeparator(const AString: string): string;
{ Add the local default thousand separator in the correct location in a string. }
begin
  Result := AddThousandSeparator(AString, System.SysUtils.FormatSettings.ThousandSeparator);
end;

function IntegerToString(const i: Int64): string;
{ Add the local default thousand separator in the correct location in a number and return a string. }
begin
  Result := AddThousandSeparator(IntToStr(i), System.SysUtils.FormatSettings.ThousandSeparator);
end;

function AddThousandSeparatorToInt(const AInteger: Integer; const AChar: char): string;
{ Add a thousand separator to an integer and return a string }
var
  i: Integer;
  iString: string;
begin
  iString := IntToStr(AInteger);
  Result := iString;
  i := Length(iString) - 2;
  while i > 1 do
  begin
    Insert(AChar, Result, i);
    i := i - 3;
  end;
end;

function AddDefThousandSeparatorToInt(const AInteger: Integer): string;
{ Adds the thousands separator to an integer from the default locale in the correct location
  and returns a string }
begin
  Result := AddThousandSeparatorToInt(AInteger, System.SysUtils.FormatSettings.ThousandSeparator);
end;

function FilterIndex(const AFilter, AFilename: string): Integer;
{ Get the Filter index for the filename. }
var
  i: Integer;
  iList: TStringlist;
  iBuffer: TStringlist;
  iKey: string;
  iExt: string;
begin
  Result := -1;
  i := 0;
  iList := TStringlist.Create;
  iList.LineBreak := '|';
  iList.Text := AFilter;
  iBuffer := TStringlist.Create;
  iBuffer.Sorted := False;
  try
    while i < iList.Count do
    begin
      Inc(i);
      iKey := AnsiLowerCase(iList[i]);
      Inc(i);
      iBuffer.Add(iKey);
    end;
    iExt := AnsiLowerCase(ExtractFileExt(AFilename));
    for i := 0 to iBuffer.Count - 1 do
      if iBuffer[i] = '*' + iExt then
      begin
        Result := i + 1;
        exit;
      end;
  finally
    FreeAndNil(iBuffer);
    FreeAndNil(iList);
  end;
end;

function ColorToPrettyName(const AColor: TColor): string;
{ Return a string of a TColor from AColor. }
var
  iColor: string;
begin
  Result := '';
  iColor := ColorToString(AColor);
  if AnsiContainsText(AnsiString(iColor), 'cl') then
    Delete(iColor, 1, 2);
  Result := iColor;
end;

function DitherColor(AColor: TColor; AAlpha: Integer): TColor;
{ Dither a 32-bit color (with alpha value) to TColor. }
var
  iRGB: TRGB;
begin
  iRGB := TColor2TRGB(AColor);
  if (iRGB.r = 255) and (iRGB.g = 255) and (iRGB.b = 255) then
  begin
    iRGB.r := AAlpha;
    iRGB.g := AAlpha;
    iRGB.b := AAlpha;
  end
  else
  begin
    iRGB.r := Trunc(AAlpha / 255 * iRGB.r) + (255 - AAlpha);
    iRGB.g := Trunc(AAlpha / 255 * iRGB.g) + (255 - AAlpha);
    iRGB.b := Trunc(AAlpha / 255 * iRGB.b) + (255 - AAlpha);
  end;
  Result := TRGB2TColor(iRGB);
end;

function GetHPPrinterIndex: Integer;
{ Get the index of a HP printer. }
var
  i: Integer;
begin
  for i := 0 to Printer.Printers.Count - 1 do
    if Pos('HP', Printer.Printers[i]) > 0 then
    begin
      exit(i);
    end;
  Result := -1;
end;

function GetDefaultPrinterName: String;
var
  iIndex: Integer;
  iList: TStrings;
begin
  Result := '';
  iIndex := Printer.PrinterIndex;
  iList := Printer.Printers;
  if (iIndex > -1) and (iIndex < iList.Count) then
  begin
    if (iList.Objects[iIndex] <> nil) then
      Result := TPrinterDevice(iList.Objects[iIndex]).Device
    else
      Result := iList[iIndex];
  end;
end;

function GetDefaultPrinterIndex: Integer;
var
  i: Integer;
begin
  for i := 0 to Printer.Printers.Count - 1 do
    if Pos(GetDefaultPrinterName, Printer.Printers[i]) > 0 then
    begin
      exit(i);
    end;
  Result := -1;
end;

function IsImageLayer(AImageEnView: TImageEnView): Boolean;
begin
  Result := AImageEnView.CurrentLayer is TIEImageLayer;
end;

function IsShapeLayer(AImageEnView: TImageEnView): Boolean;
begin
  Result := AImageEnView.CurrentLayer is TIEShapeLayer;
end;

function IsLineLayer(AImageEnView: TImageEnView): Boolean;
begin
  Result := AImageEnView.CurrentLayer is TIELineLayer;
end;

function IsPolylineLayer(AImageEnView: TImageEnView): Boolean;
begin
  Result := AImageEnView.CurrentLayer is TIEPolylineLayer;
end;

function IsTextLayer(AImageEnView: TImageEnView): Boolean;
begin
  Result := AImageEnView.CurrentLayer is TIETextLayer;
end;

function GetLayerKind(AImageEnView: TImageEnView): TIELayerKind;
begin
  Result := AImageEnView.CurrentLayer.Kind;
end;

function GetLayerKindStr(AImageEnView: TImageEnView): string;
var
  iIELayerKind: TIELayerKind;
begin
  iIELayerKind := AImageEnView.CurrentLayer.Kind;
  case ord(iIELayerKind) of
    0:
      Result := 'Image';
    1:
      Result := 'Shape';
    2:
      Result := 'Line';
    3:
      Result := 'Polyline';
    4:
      Result := 'Text';
  end;
end;

function EllipsifyText(const AsPath: Boolean; const AText: string; const ACanvas: Vcl.Graphics.TCanvas;
  const AMaxWidth: Integer): string;
{ Shortens text if necessary to fit within a specified number of pixels on a
  given canvas. If AsPath is True text is shortened path-wise by inserting an
  ellipsis in the text body, otherwise it is trunctated and an ellipsis is
  appended. }
var
  iPChar: PChar; { Temp buffer to hold text }
  iRect: TRect; { Temp rectangle hold max width of text }
  iParams: UINT; { Flags passed to DraeTextEx API function }
begin
  if AText <> '' then
  begin
    Result := AText;
    if AText = '' then
      exit;
    { Alocate mem for PChar }
    GetMem(iPChar, Length(AText) * SizeOf(AText) + 1);
    try
      { Copy Text into PChar }
      iPChar := System.SysUtils.StrPCopy(iPChar, AText);
      { Create Rectangle to Store PChar }
      iRect := System.Classes.Rect(0, 0, AMaxWidth, high(Integer));
      { Set Params depending whether it's a path or not }
      if AsPath then
        iParams := Winapi.Windows.DT_PATH_ELLIPSIS
      else
        iParams := Winapi.Windows.DT_END_ELLIPSIS;
      { Tell it to Modify the PChar, and do not draw to the canvas }
      iParams := iParams + Winapi.Windows.DT_MODIFYSTRING + Winapi.Windows.DT_CALCRECT;
      { Ellipsify the string based on availble space to draw in }
      Winapi.Windows.DrawTextEx(ACanvas.Handle, iPChar, -1, iRect, iParams, nil);
      { Copy the modified PChar into the result }
      Result := System.SysUtils.StrPas(iPChar);
    finally
      { Free Memory from PChar }
      FreeMem(iPChar, Length(AText) * SizeOf(AText) + 1);
    end;
  end;
end;

procedure EnableControls(AControl: TWinControl; AEnable: Boolean);
var
  i: Integer;
begin
  AControl.Enabled := AEnable;
  for i := 0 to AControl.ControlCount - 1 do
  begin
    AControl.Controls[i].Enabled := AEnable;
  end;
  Form1.Exit1.Enabled := True;
  Form1.Exit2.Enabled := True;
  Form1.Exit3.Enabled := True;
  Form1.Exit4.Enabled := True;
  Form1.Exit5.Enabled := True;
  Form1.Exit6.Enabled := True;
  Form1.Exit7.Enabled := True;
  Form1.Exit8.Enabled := True;
  Form1.Exit9.Enabled := True;
  Form1.Exit10.Enabled := True;
  Form1.Exit11.Enabled := True;
end;

procedure TForm1.GetPrinterNames;
var
  iBuffer: TPrinterBuffer;
  iPos: Integer;
  iPrinterName: string;
begin
  APrinterNames.Free;
  APrinterNames := TStringlist.Create;
  if GetProfileString(PChar('PrinterPorts'), nil, '', iBuffer, MAXPRINTERBUFFER) > 0 then
  begin
    iPos := 0;
    while (True) do
    begin
      iPrinterName := ParseNames(iBuffer, iPos);
      if iPrinterName <> '' then
        APrinterNames.Add(iPrinterName)
      else
        break;
    end;
  end;
end;

procedure TForm1.GeneratePalette(ABaseColor: TColor);
{ 238 colors. }
begin
  if ComboBoxPenPalette1.Focused then
    IEColorPalettePen1.Colors.Text := MakePalette(ABaseColor, soAscending);
  if ComboBoxBrushPalette1.Focused then
    IEColorPaletteBrush1.Colors.Text := MakePalette(ABaseColor, soAscending);
end;

procedure TForm1.JascColorMap;
var
  iStringList: TStringlist;
begin
  iStringList := TStringlist.Create;
  try
    iStringList.Clear;
    iStringList.BeginUpdate;
    iStringList.Add('clBlack');
    iStringList.Add('clWhite');
    iStringList.Add('clMaroon');
    iStringList.Add('clGreen');
    iStringList.Add('clOlive');
    iStringList.Add('clNavy');
    iStringList.Add('clPurple');
    iStringList.Add('clTeal');
    iStringList.Add('clGray');
    iStringList.Add('clSilver');
    iStringList.Add('clRed');
    iStringList.Add('clLime');
    iStringList.Add('clYellow');
    iStringList.Add('clBlue');
    iStringList.Add('clFuchsia');
    iStringList.Add('clAqua');
    iStringList.Add('$F2F2F2');
    iStringList.Add('$E6E6E6');
    iStringList.Add('$DADADA');
    iStringList.Add('$CECECE');
    iStringList.Add('$C2C2C2');
    iStringList.Add('$B6B6B6');
    iStringList.Add('$AAAAAA');
    iStringList.Add('$9E9E9E');
    iStringList.Add('$929292');
    iStringList.Add('$868686');
    iStringList.Add('$7A7A7A');
    iStringList.Add('$6E6E6E');
    iStringList.Add('$626262');
    iStringList.Add('$565656');
    iStringList.Add('$4A4A4A');
    iStringList.Add('$3E3E3E');
    iStringList.Add('$D4F0FF');
    iStringList.Add('$B1E2FF');
    iStringList.Add('$8ED4FF');
    iStringList.Add('$6BC6FF');
    iStringList.Add('$48B8FF');
    iStringList.Add('$25AAFF');
    iStringList.Add('$00AAFF');
    iStringList.Add('$0092DC');
    iStringList.Add('$003E75');
    iStringList.Add('$003F77');
    iStringList.Add('$004079');
    iStringList.Add('$00417B');
    iStringList.Add('$00427D');
    iStringList.Add('$004380');
    iStringList.Add('$007AB9');
    iStringList.Add('$006296');
    iStringList.Add('$004A73');
    iStringList.Add('$003250');
    iStringList.Add('$D4E3FF');
    iStringList.Add('$B1C7FF');
    iStringList.Add('$8EABFF');
    iStringList.Add('$6B8FFF');
    iStringList.Add('$4873FF');
    iStringList.Add('$2557FF');
    iStringList.Add('$0055FF');
    iStringList.Add('$0049DC');
    iStringList.Add('$003DB9');
    iStringList.Add('$003196');
    iStringList.Add('$002573');
    iStringList.Add('$001950');
    iStringList.Add('$D4D4FF');
    iStringList.Add('$B1B1FF');
    iStringList.Add('$8E8EFF');
    iStringList.Add('$6B6BFF');
    iStringList.Add('$4848FF');
    iStringList.Add('$2525FF');
    iStringList.Add('$0000FE');
    iStringList.Add('$0000DC');
    iStringList.Add('$0000B9');
    iStringList.Add('$000096');
    iStringList.Add('$000073');
    iStringList.Add('$000050');
    iStringList.Add('$E3D4FF');
    iStringList.Add('$C7B1FF');
    iStringList.Add('$AB8EFF');
    iStringList.Add('$8F6BFF');
    iStringList.Add('$7348FF');
    iStringList.Add('$5725FF');
    iStringList.Add('$5500FF');
    iStringList.Add('$4900DC');
    iStringList.Add('$3D00B9');
    iStringList.Add('$310096');
    iStringList.Add('$250073');
    iStringList.Add('$190050');
    iStringList.Add('$F0D4FF');
    iStringList.Add('$E2B1FF');
    iStringList.Add('$D48EFF');
    iStringList.Add('$C66BFF');
    iStringList.Add('$B848FF');
    iStringList.Add('$AA25FF');
    iStringList.Add('$AA00FF');
    iStringList.Add('$9200DC');
    iStringList.Add('$7A00B9');
    iStringList.Add('$620096');
    iStringList.Add('$4A0073');
    iStringList.Add('$320050');
    iStringList.Add('$FFD4FF');
    iStringList.Add('$FFB1FF');
    iStringList.Add('$FF8EFF');
    iStringList.Add('$FF6BFF');
    iStringList.Add('$FF48FF');
    iStringList.Add('$FF25FF');
    iStringList.Add('$FE00FE');
    iStringList.Add('$DC00DC');
    iStringList.Add('$B900B9');
    iStringList.Add('$960096');
    iStringList.Add('$730073');
    iStringList.Add('$500050');
    iStringList.Add('$FFD4F0');
    iStringList.Add('$FFB1E2');
    iStringList.Add('$FF8ED4');
    iStringList.Add('$FF6BC6');
    iStringList.Add('$FF48B8');
    iStringList.Add('$FF25AA');
    iStringList.Add('$FF00AA');
    iStringList.Add('$DC0092');
    iStringList.Add('$B9007A');
    iStringList.Add('$960062');
    iStringList.Add('$73004A');
    iStringList.Add('$500032');
    iStringList.Add('$FFD4E3');
    iStringList.Add('$FFB1C7');
    iStringList.Add('$FF8EAB');
    iStringList.Add('$FF6B8F');
    iStringList.Add('$FF4873');
    iStringList.Add('$FF2557');
    iStringList.Add('$FF0055');
    iStringList.Add('$DC0049');
    iStringList.Add('$B9003D');
    iStringList.Add('$960031');
    iStringList.Add('$730025');
    iStringList.Add('$500019');
    iStringList.Add('$FFD4D4');
    iStringList.Add('$FFB1B1');
    iStringList.Add('$FF8E8E');
    iStringList.Add('$FF6B6B');
    iStringList.Add('$FF4848');
    iStringList.Add('$FF2525');
    iStringList.Add('$FE0000');
    iStringList.Add('$DC0000');
    iStringList.Add('$B90000');
    iStringList.Add('$960000');
    iStringList.Add('$730000');
    iStringList.Add('$500000');
    iStringList.Add('$FFE3D4');
    iStringList.Add('$FFC7B1');
    iStringList.Add('$FFAB8E');
    iStringList.Add('$FF8F6B');
    iStringList.Add('$FF7348');
    iStringList.Add('$FF5725');
    iStringList.Add('$FF5500');
    iStringList.Add('$DC4900');
    iStringList.Add('$B93D00');
    iStringList.Add('$963100');
    iStringList.Add('$732500');
    iStringList.Add('$501900');
    iStringList.Add('$FFF0D4');
    iStringList.Add('$FFE2B1');
    iStringList.Add('$FFD48E');
    iStringList.Add('$FFC66B');
    iStringList.Add('$FFB848');
    iStringList.Add('$FFAA25');
    iStringList.Add('$FFAA00');
    iStringList.Add('$DC9200');
    iStringList.Add('$B97A00');
    iStringList.Add('$966200');
    iStringList.Add('$734A00');
    iStringList.Add('$503200');
    iStringList.Add('$FFFFD4');
    iStringList.Add('$FFFFB1');
    iStringList.Add('$FFFF8E');
    iStringList.Add('$FFFF6B');
    iStringList.Add('$FFFF48');
    iStringList.Add('$FFFF25');
    iStringList.Add('$FEFE00');
    iStringList.Add('$DCDC00');
    iStringList.Add('$B9B900');
    iStringList.Add('$969600');
    iStringList.Add('$737300');
    iStringList.Add('$505000');
    iStringList.Add('$F0FFD4');
    iStringList.Add('$E2FFB1');
    iStringList.Add('$D4FF8E');
    iStringList.Add('$C6FF6B');
    iStringList.Add('$B8FF48');
    iStringList.Add('$AAFF25');
    iStringList.Add('$AAFF00');
    iStringList.Add('$92DC00');
    iStringList.Add('$7AB900');
    iStringList.Add('$629600');
    iStringList.Add('$4A7300');
    iStringList.Add('$325000');
    iStringList.Add('$E3FFD4');
    iStringList.Add('$C7FFB1');
    iStringList.Add('$ABFF8E');
    iStringList.Add('$8FFF6B');
    iStringList.Add('$57FF25');
    iStringList.Add('$55FF00');
    iStringList.Add('$49DC00');
    iStringList.Add('$3DB900');
    iStringList.Add('$319600');
    iStringList.Add('$257300');
    iStringList.Add('$195000');
    iStringList.Add('$D4FFD4');
    iStringList.Add('$B1FFB1');
    iStringList.Add('$8EFF8E');
    iStringList.Add('$6BFF6B');
    iStringList.Add('$48FF48');
    iStringList.Add('$25FF25');
    iStringList.Add('$00FE00');
    iStringList.Add('$00DC00');
    iStringList.Add('$00B900');
    iStringList.Add('$009600');
    iStringList.Add('$007300');
    iStringList.Add('$005000');
    iStringList.Add('$D4FFE3');
    iStringList.Add('$B1FFC7');
    iStringList.Add('$8EFFAB');
    iStringList.Add('$6BFF8F');
    iStringList.Add('$48FF73');
    iStringList.Add('$25FF57');
    iStringList.Add('$00FF55');
    iStringList.Add('$00DC49');
    iStringList.Add('$00B93D');
    iStringList.Add('$009631');
    iStringList.Add('$007325');
    iStringList.Add('$005019');
    iStringList.Add('$D4FFF0');
    iStringList.Add('$B1FFE2');
    iStringList.Add('$8EFFD4');
    iStringList.Add('$6BFFC6');
    iStringList.Add('$48FFB8');
    iStringList.Add('$25FFAA');
    iStringList.Add('$00FFAA');
    iStringList.Add('$00DC92');
    iStringList.Add('$00B97A');
    iStringList.Add('$009662');
    iStringList.Add('$00734A');
    iStringList.Add('$005032');
    iStringList.Add('$E4FFFF');
    iStringList.Add('$D4FFFF');
    iStringList.Add('$C1FFFF');
    iStringList.Add('$B1FFFF');
    iStringList.Add('$9EFFFF');
    iStringList.Add('$8EFFFF');
    iStringList.Add('$6EFFFF');
    iStringList.Add('$6DFFFF');
    iStringList.Add('$6CFFFF');
    iStringList.Add('$57FFFF');
    iStringList.Add('$4AFFFF');
    iStringList.Add('$49FFFF');
    iStringList.Add('$48FFFF');
    iStringList.Add('$ACFFFF');
    iStringList.Add('$98FFFF');
    iStringList.Add('$84FFFF');
    iStringList.Add('$70FFFF');
    iStringList.Add('$66FFFF');
    iStringList.Add('$52FFFF');
    iStringList.Add('$3EFFFF');
    iStringList.Add('$2AFFFF');
    iStringList.Add('$16FFFF');
    iStringList.EndUpdate;
    if ComboBoxPenPalette1.Focused then
      IEColorPalettePen1.Colors.Assign(iStringList);
    if ComboBoxBrushPalette1.Focused then
      IEColorPaletteBrush1.Colors.Assign(iStringList);
  finally
    iStringList.Free;
  end;
end;

procedure TForm1.DxColorMap;
{ Create a dxcolormap and fill the cyColorGrid1 with 160 colors. }
var
  iStringList: TStringlist;
  iColornameList: TStringlist;
begin
  iStringList := TStringlist.Create;
  try
    iColornameList := TStringlist.Create;
    try
      iStringList.Clear;
      iStringList.BeginUpdate;
      iStringList.Add('clBlack');
      iStringList.Add('clMaroon');
      iStringList.Add('clGreen');
      iStringList.Add('clOlive');
      iStringList.Add('clNavy');
      iStringList.Add('clPurple');
      iStringList.Add('clTeal');
      iStringList.Add('clGray');
      iStringList.Add('clSilver');
      iStringList.Add('clRed');
      iStringList.Add('clLime');
      iStringList.Add('clYellow');
      iStringList.Add('clBlue');
      iStringList.Add('clFuchsia');
      iStringList.Add('clAqua');
      iStringList.Add('clWhite');
      iStringList.Add('$00FFF8F0');
      iStringList.Add('$00D7EBFA');
      iStringList.Add('$00D4FF7F');
      iStringList.Add('$00FFFFF0');
      iStringList.Add('$00DCF5F5');
      iStringList.Add('$00C4E4FF');
      iStringList.Add('$00CDFFFF');
      iStringList.Add('$00E22B8A');
      iStringList.Add('$002A2AA5');
      iStringList.Add('$0087B8DE');
      iStringList.Add('$00A09E5F');
      iStringList.Add('$0000FF7F');
      iStringList.Add('$001E69D2');
      iStringList.Add('$00507FFF');
      iStringList.Add('$00ED9564');
      iStringList.Add('$00DCF8FF');
      iStringList.Add('$003C14DC');
      iStringList.Add('$008B0000');
      iStringList.Add('$008B8B00');
      iStringList.Add('$000B86B8');
      iStringList.Add('$00A9A9A9');
      iStringList.Add('$00006400');
      iStringList.Add('$006BB7BD');
      iStringList.Add('$008B008B');
      iStringList.Add('$002F6B55');
      iStringList.Add('$00008CFF');
      iStringList.Add('$00CC3299');
      iStringList.Add('$0000008B');
      iStringList.Add('$007A96E9');
      iStringList.Add('$008FBC8F');
      iStringList.Add('$008B3D48');
      iStringList.Add('$004F4F2F');
      iStringList.Add('$00D1CE00');
      iStringList.Add('$00D30094');
      iStringList.Add('$009314FF');
      iStringList.Add('$00FFBF00');
      iStringList.Add('$00696969');
      iStringList.Add('$00FF901E');
      iStringList.Add('$002222B2');
      iStringList.Add('$00F0FAFF');
      iStringList.Add('$00228B22');
      iStringList.Add('$00DCDCDC');
      iStringList.Add('$00FFF8F8');
      iStringList.Add('$0000D7FF');
      iStringList.Add('$0020A5DA');
      iStringList.Add('$002FFFAD');
      iStringList.Add('$00F0FFF0');
      iStringList.Add('$00B469FF');
      iStringList.Add('$005C5CCD');
      iStringList.Add('$0082004B');
      iStringList.Add('$00F0F0FF');
      iStringList.Add('$008CE6F0');
      iStringList.Add('$00FAE6E6');
      iStringList.Add('$00F5F0FF');
      iStringList.Add('$0000FC7C');
      iStringList.Add('$00CDFAFF');
      iStringList.Add('$00E6D8AD');
      iStringList.Add('$008080F0');
      iStringList.Add('$00FFFFE0');
      iStringList.Add('$00D2FAFA');
      iStringList.Add('$0090EE90');
      iStringList.Add('$00D3D3D3');
      iStringList.Add('$00C1B6FF');
      iStringList.Add('$007AA0FF');
      iStringList.Add('$00AAB220');
      iStringList.Add('$00FACE87');
      iStringList.Add('$00998877');
      iStringList.Add('$00DEC4B0');
      iStringList.Add('$00E0FFFF');
      iStringList.Add('$0032CD32');
      iStringList.Add('$00E6F0FA');
      iStringList.Add('$00AACD66');
      iStringList.Add('$00CD0000');
      iStringList.Add('$00D355BA');
      iStringList.Add('$00DB7093');
      iStringList.Add('$00EE687B');
      iStringList.Add('$009AFA00');
      iStringList.Add('$00CCD148');
      iStringList.Add('$008515C7');
      iStringList.Add('$00701919');
      iStringList.Add('$00FAFFF5');
      iStringList.Add('$00E1E4FF');
      iStringList.Add('$00B5E4FF');
      iStringList.Add('$00E6F5FD');
      iStringList.Add('$00238E6B');
      iStringList.Add('$0000A5FF');
      iStringList.Add('$000045FF');
      iStringList.Add('$00D670DA');
      iStringList.Add('$00AAE8EE');
      iStringList.Add('$0098FB98');
      iStringList.Add('$00EEEEAF');
      iStringList.Add('$009370DB');
      iStringList.Add('$00D5EFFF');
      iStringList.Add('$00BDDBFF');
      iStringList.Add('$003F85CD');
      iStringList.Add('$00CBC0FF');
      iStringList.Add('$00DDA0DD');
      iStringList.Add('$00E6E0B0');
      iStringList.Add('$0013458B');
      iStringList.Add('$007280FA');
      iStringList.Add('$0060A4F4');
      iStringList.Add('$00578B2E');
      iStringList.Add('$00EEF5FF');
      iStringList.Add('$00CD5A6A');
      iStringList.Add('$00908070');
      iStringList.Add('$00FAFAFF');
      iStringList.Add('$007FFF00');
      iStringList.Add('$00B48246');
      iStringList.Add('$008CB4D2');
      iStringList.Add('$00D8BFD8');
      iStringList.Add('$004763FD');
      iStringList.Add('$00D0E040');
      iStringList.Add('$00EE82EE');
      iStringList.Add('$00B3DEF5');
      iStringList.Add('$00F5F5F5');
      iStringList.Add('$0032CD9A');
      iStringList.Add(ColorToString(clActiveBorder));
      iStringList.Add(ColorToString(clActiveCaption));
      iStringList.Add(ColorToString(clAppWorkSpace));
      iStringList.Add(ColorToString(clBackground));
      iStringList.Add(ColorToString(clBtnFace));
      iStringList.Add(ColorToString(clBtnHighlight));
      iStringList.Add(ColorToString(clBtnShadow));
      iStringList.Add(ColorToString(clBtnText));
      iStringList.Add(ColorToString(clCaptionText));
      iStringList.Add(ColorToString(clGrayText));
      iStringList.Add(ColorToString(clHighlight));
      iStringList.Add(ColorToString(clHighlightText));
      iStringList.Add(ColorToString(clInactiveBorder));
      iStringList.Add(ColorToString(clInactiveCaption));
      iStringList.Add(ColorToString(clInactiveCaptionText));
      iStringList.Add(ColorToString(clInfoBk));
      iStringList.Add(ColorToString(clInfoText));
      iStringList.Add(ColorToString(clMenu));
      iStringList.Add(ColorToString(clMenuText));
      iStringList.Add(ColorToString(clScrollBar));
      iStringList.Add(ColorToString(cl3DDkShadow));
      iStringList.Add(ColorToString(clBtnFace));
      iStringList.Add(ColorToString(clHighlightText));
      iStringList.Add(ColorToString(cl3DLight));
      iStringList.Add(ColorToString(clBtnShadow));
      iStringList.Add(ColorToString(clWindow));
      iStringList.Add(ColorToString(clWindowFrame));
      iStringList.Add(ColorToString(clWindowText));
      iStringList.EndUpdate;
      if ComboBoxPenPalette1.Focused then
        IEColorPalettePen1.Colors.Assign(iStringList);
      if ComboBoxBrushPalette1.Focused then
        IEColorPaletteBrush1.Colors.Assign(iStringList);
    finally
      iColornameList.Free;
    end;
  finally
    iStringList.Free;
  end;
end;

procedure TForm1.AddTabsheet;
{ Add a tabsheet to the pagecontrol. }
begin
  { create a new tabsheet }
  with PageControl1 do
    TabSheet := TTabSheet.Create(Self);
  { set the tabsheet.pagecontrol to PageControl1 }
  TabSheet.PageControl := PageControl1;
  { set the activepage to tabsheet }
  PageControl1.ActivePage := TabSheet;
  with TabSheet do
  begin
    ShowHint := True;
    ImageEnView := TImageEnView.Create(Self);
    ImageEnView.Parent := TabSheet;
    ImageEnView.Left := 0;
    ImageEnView.Top := 0;
    ImageEnView.Align := alClient;
    ImageEnView.Cursor := 1784;
    ImageEnView.AutoStretch := False;
    ImageEnView.AutoCursors := True;
    ImageEnView.BackGround := clWhite;
    ImageEnView.Visible := True;
    ImageEnView.ShowHint := True;
    ImageEnView.BorderStyle := bsNone;
    ImageEnView.IO.Params.BMP_HandleTransparency := True;
    ImageEnView.DisplayGrid := DisplayGrid1.Checked;
    ImageEnView.SetChessboardStyle(8);
    ImageEnView.IO.Params.FileType := ioJPEG;
    ImageEnView.PopupMenu := PopupMenuImageEnView1;
    ImageEnView.MouseInteract := [];
    ImageEnView.Proc.UndoLimit := 99;
    ImageEnView.Proc.AutoUndo := True;
    ImageEnView.SetChessboardStyle(8);
    ImageEnView.Gestures.Pan.Enabled := True;
    ImageEnView.Gestures.Zoom.Enabled := True;
    ImageEnView.SelectionOptions := ImageEnView.SelectionOptions + [iesoSelectTranspLayers];
    ImageEnView.Center := True;
    ImageEnView.ZoomFilter := rfNone;
    ImageEnView.DelayZoomFilter := False;
    ImageEnView.ZoomFilter := rfNone;
    ImageEnView.DelayZoomFilter := False;
    { Rotation anti-alias }
    ImageEnView.LayersRotationFilter := ierBicubic;
    ImageEnView.LayersRotationAntialias := True;
    ImageEnView.LayersRotationUseFilterOnPreview := False;
    { Fast drawing }
    ImageEnView.LayersFastDrawing := iefFast;
    if LayerCaching1.Checked then
      ImageEnView.LayersCaching := -1;
    ImageEnView.LayersRotationFilter := ierBicubic;
    ImageEnView.LayersRotationAntialias := True;
    ImageEnView.LayersRotationUseFilterOnPreview := False;
    ImageEnView.LayerOptions := ImageEnView.LayerOptions + [loAllowMultiSelect, loAutoUndoChangesByCode];
    ImageEnView.SetLayersGripStyle(clBlack, clLime, bsSolid, 5, iegsCircle);
    ImageEnView.OnDrawBackBuffer := ImageEnViewDrawBackBuffer;
    ImageEnView.OnDrawLayerBox := ImageEnViewDrawLayerBox;
    ImageEnView.OnImageChange := ImageEnViewImageChange;
    ImageEnView.OnSelectionChange := ImageEnViewSelectionChange;
    ImageEnView.OnSelectionChanging := ImageEnViewSelectionChanging;
    ImageEnView.OnMouseDown := ImageEnViewMouseDown;
    ImageEnView.OnMouseMove := ImageEnViewMouseMove;
    ImageEnView.OnMouseUp := ImageEnViewMouseUp;
    ImageEnView.OnKeyDown := ImageEnViewKeyDown;
    ImageEnView.OnSpecialKey := ImageEnViewSpecialKey;
    ImageEnView.OnNewLayer := ImageEnViewNewLayer;
    ImageEnView.OnLayerNotify := ImageEnViewLayerNotify;
    ImageEnView.OnViewChange := ImageEnViewViewChange;
    // ImageEnView.OnLayerSelectionChange := ImageEnViewLayerSelectionChange;
    // ImageEnView.OnDrawLayer := ImageEnViewDrawLayer;
    // ImageEnView.Proc.OnProgress := ImageEnViewProgress;
    // ImageEnView.Proc.OnFinishWork := ImageEnViewFinishWork;
    // ImageEnView.OnProgress := ImageEnViewProgress;
    // ImageEnView.OnFinishWork := ImageEnViewFinishWork;
    // ImageEnView.OnMouseInSel := ImageEnViewMouseInSel;
  end;
end;

procedure TForm1.GradientColorBox1Change(Sender: TObject);
begin
  SetLayerTextParameters;
  SetLayerShapeParameters;
end;

procedure TForm1.GroupLayers1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      MultipleLayerSelection1.Checked := True;
      ImageEnView.LayerOptions := ImageEnView.LayerOptions + [loAllowMultiSelect];
      ImageEnView.LayersGroup(True);
      Layers1.ItemIndex := 0;
      UpdateGUI;
    end;
  end;
end;

procedure TForm1.GroupLayers2Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if GroupLayers2.Checked then
      begin
        ImageEnView.LayersGroup(True);
        ImageEnView.LayersDeselectAll;
        Layers1.ItemIndex := 0;
      end
      else
      begin
        ImageEnView.LayersUngroup();
        ImageEnView.LayersDeselectAll;
        Layers1.ItemIndex := 0;
      end;
    end;
  end;
end;

function TForm1.ParseNames(const ANameBuffer: TPrinterBuffer; var AStartPos: Integer): string;
var
  i: Integer;
  j: Integer;
  iNameLength: Integer;
  iString: string;
begin
  Result := '';
  if (AStartPos > High(ANameBuffer)) or (ANameBuffer[AStartPos] = Chr(0)) then
    exit;
  for i := AStartPos to High(ANameBuffer) do
  begin
    if ANameBuffer[i] = Chr(0) then
    begin
      iNameLength := i - AStartPos;
      SetLength(iString, iNameLength);
      for j := 0 to iNameLength - 1 do
        iString[j + 1] := ANameBuffer[AStartPos + j];
      Result := iString;
      AStartPos := i + 1;
      break;
    end;
  end;
end;

procedure TForm1.Paste1Click(Sender: TObject);
{ Paste To Selection. }
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.PasteFromClipboard(iecpAuto, True);
      ImageEnView.Proc.SaveUndo('Paste ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      ImageEnView.IEBitmap.Modified := ImageEnView.Proc.UndoCount > 0;
      ImageEnView.Update;
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
      ImageEnMView1.Update;
      UpdateGUI;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

function TForm1.SetPrinter(const APrinterName: String): Boolean;
var
  iString: string;
  iDum: PChar;
  iX, iQ: Integer;
const
  cs1: PChar = 'Windows';
  cs2: PChar = 'Device';
  cs3: PChar = 'Devices';
  cs4: PChar = #0;
begin
  iX := 254;
  GetMem(iDum, iX);
  Result := False;
  try
    iQ := GetProfileString(cs3, PChar(APrinterName), #0, iDum, iX);
    if (iQ > 0) and (Trim(StrPas(iDum)) <> '') then
    begin
      iString := APrinterName + ',' + StrPas(iDum);
      while GetProfileString(cs1, cs2, cs4, iDum, iX) > 0 do
        WriteProfileString(cs1, cs2, #0);
      WriteProfileString(cs1, cs2, PChar(iString));
      { case Win32Platform of
        VER_PLATFORM_WIN32_NT:
        SendMessage( HWND_BROADCAST, WM_WININICHANGE, 0, LongInt(cs1));
        VER_PLATFORM_WIN32_WINDOWS :
        SendMessage( HWND_BROADCAST, WM_SETTINGCHANGE, 0, LongInt(cs1));
        end; }
      Result := True;
    end;
  finally
    FreeMem(iDum);
  end;
end;

procedure TForm1.Setup1Click(Sender: TObject);
begin
  if Printers1.Enabled then
    if PrinterSetupDialog1.Execute then
      Printers1.ItemIndex := Printer.PrinterIndex;
end;

procedure TForm1.ShowRulers1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ShowRulers1.Checked then
        ImageEnView.ShowRulers := [rdHorizontal, rdVertical]
      else
        ImageEnView.ShowRulers := [];
    end;
  end;
end;

procedure TForm1.Sources1Change(Sender: TObject);
{ User selects scanner }
begin
  if AInternalChange then
    exit;
  if Sources1.ItemIndex > -1 then
  begin
    ImageEnMView1.MIO.AcquireParams.SetSourceByStr(Sources1.Items[Sources1.ItemIndex]);
    UpdateControlStatus;
  end;
end;

procedure TForm1.Sources1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
const
  Scanner_Glyph_Index = 0;
  Camera_Glyph_Index = 1;
  Drive_Glyph_Index = 2;
  Device_Glyph_Index = 3;
  Unknown_Glyph_Index = Scanner_Glyph_Index; { Just assume it is a scanner }
begin
  { Convert values in cmbSources (which are a coded string) to something human-readable }
  DrawAcquireComboListBoxItem(Control, Rect, Sources1.Items[Index], imlDevices, Scanner_Glyph_Index, Camera_Glyph_Index,
    Drive_Glyph_Index, Device_Glyph_Index, Unknown_Glyph_Index);
end;

procedure TForm1.Styles1Click(Sender: TObject);
var
  iStyleName: String;
begin
  if Styles1.ItemIndex >= 0 then
  begin
    iStyleName := Styles1.Items[Styles1.ItemIndex];
    TStyleManager.TrySetStyle(iStyleName, True);
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        ImageEnView.BackGround := Panel1.Color;
      end;
    end;
  end;
end;

procedure TForm1.UpdateGUI;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Clear1.Enabled := ImageEnMView1.ImageCount > 0;
      Save1.Enabled := ImageEnMView1.IEBitmap.Modified;
      SaveAs1.Enabled := ImageEnMView1.ImageCount > 0;
      SaveLayers1.Enabled := ImageEnView.LayersCount > 1;
      CloseActivePage1.Enabled := ImageEnMView1.ImageCount > 1;
      Cut1.Enabled := ImageEnView.Proc.CanCutToClipboard;
      Copy1.Enabled := ImageEnView.Proc.CanCopyToClipboard;
      Paste1.Enabled := ImageEnView.Proc.CanPasteFromClipboard;
      Resample1.Enabled := ImageEnMView1.ImageCount > 0;
      Resize1.Enabled := ImageEnMView1.ImageCount > 0;
      Curves1.Enabled := ImageEnMView1.ImageCount > 0;
      Tint1.Enabled := ImageEnMView1.ImageCount > 0;
      IncreaseBrightness1.Enabled := ImageEnMView1.ImageCount > 0;
      DecreaseBrightness1.Enabled := ImageEnMView1.ImageCount > 0;
      PencilSketch1.Enabled := ImageEnMView1.ImageCount > 0;
      Grayscale1.Enabled := ImageEnMView1.ImageCount > 0;
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      SelectLayers1.Enabled := ImageEnView.LayersCount > 2;
      RotateLayers1.Enabled := ImageEnView.LayersCount > 2;
      RotateSelectedLayers1.Enabled := (ImageEnView.LayersCount > 2) and (ImageEnView.LayersSelCount(False) > 0);
      ResizeSelectedLayers1.Enabled := (ImageEnView.LayersCount > 2) and (ImageEnView.LayersSelCount(False) > 0);
      DeleteFrame1.Enabled := ImageEnMView1.ImageCount > 0;
      AddLayer1.Enabled := ImageEnMView1.ImageCount > 0;
      AddLayer2.Enabled := ImageEnMView1.ImageCount > 0;
      AddLayer3.Enabled := ImageEnMView1.ImageCount > 0;
      AddTextLayer1.Enabled := ImageEnMView1.ImageCount > 0;
      AddImageLayer1.Enabled := ImageEnMView1.ImageCount > 0;
      AddShapeLayer1.Enabled := ImageEnMView1.ImageCount > 0;
      RemoveLayer1.Enabled := ImageEnMView1.ImageCount > 0;
      RemoveLayer2.Enabled := ImageEnMView1.ImageCount > 0;
      RemoveLayer3.Enabled := ImageEnMView1.ImageCount > 0;
      RemoveLayer4.Enabled := ImageEnMView1.ImageCount > 0;
      Label35.Enabled := ImageEnMView1.ImageCount > 0;
      Shape1.Enabled := ImageEnMView1.ImageCount > 0;
      MergeLayers1.Enabled := ImageEnView.LayersCount > 1;
      MergeLayers2.Enabled := ImageEnView.LayersCount > 1;
      MergeLayers3.Enabled := ImageEnView.LayersCount > 1;
      AlignLayers1.Enabled := ImageEnView.LayersCount > 1;
      AlignLayers2.Enabled := ImageEnView.LayersCount > 1;
      AlignLayers3.Enabled := ImageEnView.LayersCount > 1;
      RemoveLayer1.Enabled := ImageEnView.LayersCount > 1;
      RemoveLayer2.Enabled := ImageEnView.LayersCount > 1;
      RemoveLayer3.Enabled := ImageEnView.LayersCount > 1;
      GroupLayers1.Enabled := ImageEnView.LayersCount > 1;
      GroupLayers2.Enabled := ImageEnView.LayersCount > 1;
      UnGroupLayers1.Enabled := ImageEnView.LayersCount > 1;
      DeselectLayers1.Enabled := ImageEnView.LayersCount > 1;
      Print1.Enabled := ImageEnMView1.ImageCount > 0;
      MultipleLayerSelection1.Enabled := ImageEnView.LayersCount > 0;
      ResizeAllLayers1.Enabled := ImageEnView.LayersCount > 2;
      ConvertToImageLayer1.Enabled := IsTextLayer(ImageEnView);
      ConvertTo32Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 32;
      ConvertTo24Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 24;
      ConvertTo8Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 8;
      ConvertTo4Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 4;
      Fit1.Enabled := True;
      Crop1.Enabled := ImageEnView.Selected;
      Curves1.Enabled := ImageEnMView1.ImageCount > 0;
      SelectNone1.Enabled := ImageEnMView1.ImageCount > 0;
      SelectLayers1.Enabled := ImageEnMView1.ImageCount > 0;
      RotateLayers1.Enabled := ImageEnMView1.ImageCount > 0;
      Selection1.Enabled := ImageEnMView1.ImageCount > 0;
      Polygon1.Enabled := ImageEnMView1.ImageCount > 0;
      SelectEllipse1.Enabled := ImageEnMView1.ImageCount > 0;
      SelectCrop1.Enabled := ImageEnMView1.ImageCount > 0;
      RotateSelectedLayers1.Enabled := ImageEnMView1.ImageCount > 0;
      ResizeSelectedLayers1.Enabled := ImageEnMView1.ImageCount > 0;
      PaintBrush1.Enabled := ImageEnMView1.ImageCount > 0;
      Line1.Enabled := ImageEnMView1.ImageCount > 0;
      Rectangle1.Enabled := ImageEnMView1.ImageCount > 0;
      RoundRectangle1.Enabled := ImageEnMView1.ImageCount > 0;
      Ellipse1.Enabled := ImageEnMView1.ImageCount > 0;
      NewFrame1.Enabled := True;
      AddFrame1.Enabled := ImageEnMView1.ImageCount > 0;
      AddLayer1.Enabled := ImageEnMView1.ImageCount > 0;
      AddTextLayer1.Enabled := ImageEnMView1.ImageCount > 0;
      AddImageLayer1.Enabled := ImageEnMView1.ImageCount > 0;
      MoveUp1.Enabled := ImageEnMView1.SelectedImage <> 0;
      MoveDown1.Enabled := ImageEnMView1.SelectedImage <> ImageEnMView1.ImageCount;
      UseGDIPlus1.Enabled := ImageEnMView1.ImageCount > 0;
      Antialias1.Enabled := ImageEnMView1.ImageCount > 0;
      DrawFilled1.Enabled := ImageEnMView1.ImageCount > 0;
      ShowRulers1.Enabled := ImageEnMView1.ImageCount > 0;
      DeSkew1.Enabled := (ImageEnMView1.ImageCount > 0) and (ImageEnView.LayersCurrent = 0);
      RemoveRedEyes1.Enabled := (ImageEnMView1.ImageCount > 0) and (ImageEnView.Selected);
      Form1.Exit1.Enabled := True;
      Form1.Exit2.Enabled := True;
      Form1.Exit3.Enabled := True;
      Form1.Exit4.Enabled := True;
      Form1.Exit5.Enabled := True;
      Form1.Exit6.Enabled := True;
      Form1.Exit7.Enabled := True;
      Form1.Exit8.Enabled := True;
      Form1.Exit9.Enabled := True;
      Form1.Exit10.Enabled := True;
      Form1.Exit11.Enabled := True;
    end;
  end
  else
  begin
    Clear1.Enabled := False;
    Save1.Enabled := False;
    SaveAs1.Enabled := False;
    SaveLayers1.Enabled := False;
    CloseActivePage1.Enabled := False;
    Cut1.Enabled := False;
    Copy1.Enabled := False;
    Paste1.Enabled := False;
    Resample1.Enabled := False;
    Resize1.Enabled := False;
    Curves1.Enabled := False;
    Tint1.Enabled := False;
    IncreaseBrightness1.Enabled := False;
    DecreaseBrightness1.Enabled := False;
    PencilSketch1.Enabled := False;
    Grayscale1.Enabled := False;
    Undo1.Enabled := False;
    SelectLayers1.Enabled := False;
    RotateLayers1.Enabled := False;
    RotateSelectedLayers1.Enabled := False;
    ResizeSelectedLayers1.Enabled := False;
    DeleteFrame1.Enabled := False;
    AddLayer1.Enabled := False;
    AddLayer2.Enabled := False;
    AddLayer3.Enabled := False;
    AddTextLayer1.Enabled := False;
    AddImageLayer1.Enabled := False;
    AddShapeLayer1.Enabled := False;
    MergeLayers1.Enabled := False;
    MergeLayers2.Enabled := False;
    MergeLayers3.Enabled := False;
    AlignLayers1.Enabled := False;
    AlignLayers2.Enabled := False;
    AlignLayers3.Enabled := False;
    RemoveLayer1.Enabled := False;
    RemoveLayer2.Enabled := False;
    RemoveLayer3.Enabled := False;
    GroupLayers1.Enabled := False;
    GroupLayers2.Enabled := False;
    UnGroupLayers1.Enabled := False;
    DeselectLayers1.Enabled := False;
    Print1.Enabled := False;
    MultipleLayerSelection1.Enabled := False;
    ResizeAllLayers1.Enabled := False;
    ConvertTo32Bit1.Enabled := False;
    ConvertTo24Bit1.Enabled := False;
    ConvertTo8Bit1.Enabled := False;
    ConvertTo4Bit1.Enabled := False;
    Fit1.Enabled := False;
    Crop1.Enabled := False;
    Curves1.Enabled := False;
    SelectNone1.Enabled := False;
    SelectLayers1.Enabled := False;
    RotateLayers1.Enabled := False;
    Selection1.Enabled := False;
    Polygon1.Enabled := False;
    SelectEllipse1.Enabled := False;
    SelectCrop1.Enabled := False;
    RotateSelectedLayers1.Enabled := False;
    ResizeSelectedLayers1.Enabled := False;
    PaintBrush1.Enabled := False;
    Line1.Enabled := False;
    Rectangle1.Enabled := False;
    RoundRectangle1.Enabled := False;
    Ellipse1.Enabled := False;
    NewFrame1.Enabled := False;
    AddFrame1.Enabled := False;
    AddLayer1.Enabled := False;
    AddTextLayer1.Enabled := False;
    AddImageLayer1.Enabled := False;
    UseGDIPlus1.Enabled := False;
    Antialias1.Enabled := False;
    DrawFilled1.Enabled := False;
    ShowRulers1.Enabled := False;
    TabSheet9.TabVisible := False;
    MoveUp1.Enabled := False;
    MoveDown1.Enabled := False;
    DeSkew1.Enabled := False;
    RemoveRedEyes1.Enabled := False;
    Form1.Exit1.Enabled := True;
    Form1.Exit2.Enabled := True;
    Form1.Exit3.Enabled := True;
    Form1.Exit4.Enabled := True;
    Form1.Exit5.Enabled := True;
    Form1.Exit6.Enabled := True;
    Form1.Exit7.Enabled := True;
    Form1.Exit8.Enabled := True;
    Form1.Exit9.Enabled := True;
    Form1.Exit10.Enabled := True;
    Form1.Exit11.Enabled := True;
  end;
  GetScannerNames1.Enabled := Sources1.Items.Count = 0;
end;

procedure TForm1.ConvertTo32Bit;
var
  iRGB: TRGB;
begin
  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := 8;
  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel := 4;
  iRGB := ImageEnMView1.IEBitmap.Pixels[0, ImageEnMView1.IEBitmap.Height - 1];
  ImageEnMView1.Proc.SetTransparentColors(iRGB, iRGB, 0);
end;

procedure TForm1.TextFont1Change(Sender: TObject);
begin
  SetLayerTextParameters;
  SetLayerShapeParameters;
end;

procedure TForm1.TextFontColorBox1Change(Sender: TObject);
begin
  SetLayerTextParameters;
  SetLayerShapeParameters;
end;

procedure TForm1.TextFontSize1Click(Sender: TObject; Button: TUDBtnType);
begin
  SetLayerTextParameters;
  SetLayerShapeParameters;
end;

procedure TForm1.Tint1Click(Sender: TObject);
var
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        iNotification := NotificationCenter1.CreateNotification;
        try
          iNotification.Name := 'Notification';
          iNotification.Title := 'Tint ';
          iNotification.AlertBody := 'Applying image tint...';
          NotificationCenter1.PresentNotification(iNotification);
        finally
          iNotification.Free;
        end;
        ImageEnView.Proc.SaveUndo('Tint ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
        Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
        ImageEnView.Proc.AdjustTint(25);
        ImageEnView.Update;
        ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage, ImageEnView.IEBitmap);
        ImageEnMView1.Update;
        ImageEnView.IEBitmap.Modified := True;
        ImageEnMView1.IEMBitmap.Modified := True;
        UpdateGUI;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.Top1Change(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.Colors1Change(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.ComboBoxPenPalette1Change(Sender: TObject);
var
  i: Integer;
  iColor: TColor;
  iColorname: string;
begin
  if ComboBoxPenPalette1.Items[ComboBoxPenPalette1.ItemIndex] = 'Default Palette' then
  begin
    { Load a default color palette. }
    IEColorPalettePen1.Clear;
    IEColorPalettePen1.Colors.Add(ColorToString(clBlack));
    IEColorPalettePen1.Colors.Add(ColorToString(clMaroon));
    IEColorPalettePen1.Colors.Add(ColorToString(clGreen));
    IEColorPalettePen1.Colors.Add(ColorToString(clOlive));
    IEColorPalettePen1.Colors.Add(ColorToString(clNavy));
    IEColorPalettePen1.Colors.Add(ColorToString(clPurple));
    IEColorPalettePen1.Colors.Add(ColorToString(clTeal));
    IEColorPalettePen1.Colors.Add(ColorToString(clSilver));
    IEColorPalettePen1.Colors.Add(ColorToString(clGray));
    IEColorPalettePen1.Colors.Add(ColorToString(clRed));
    IEColorPalettePen1.Colors.Add(ColorToString(clLime));
    IEColorPalettePen1.Colors.Add(ColorToString(clYellow));
    IEColorPalettePen1.Colors.Add(ColorToString(clBlue));
    IEColorPalettePen1.Colors.Add(ColorToString(clFuchsia));
    IEColorPalettePen1.Colors.Add(ColorToString(clAqua));
    IEColorPalettePen1.Colors.Add(ColorToString(clWhite));
    for i := 0 to 169 do
    begin
      iColor := StringToColor(IEColorPalettePen1.Colors[i]);
      cxNameByColor(iColor, iColorname);
      IEColorPalettePen1.Colors.Add(ColorToString(iColor));
    end;
    IEColorPalettePen1.SelectedIndex := 0;
    PenColor1.Color := IEColorPalettePen1.SelectedColor;
    cxGroupBoxPen1.Caption := 'Palette Colors: ' + IntToStr(IEColorPalettePen1.ColorCount);
  end;
  if ComboBoxPenPalette1.Items[ComboBoxPenPalette1.ItemIndex] = 'Jasc' then
  begin
    { Load a JASC color palette. }
    JascColorMap;
    cxGroupBoxPen1.Caption := 'Jasc Palette- ' + IntToStr(IEColorPalettePen1.ColorCount);
  end;
  if ComboBoxPenPalette1.Items[ComboBoxPenPalette1.ItemIndex] = 'Developers Express' then
  begin
    { Load a Dx color palette. }
    DxColorMap;
    cxGroupBoxPen1.Caption := 'Developers Express Palette- ' + IntToStr(IEColorPalettePen1.ColorCount);
  end;
  if ComboBoxPenPalette1.Items[ComboBoxPenPalette1.ItemIndex] = 'Gray' then
  begin
    { Gray Palette. 238 colors. }
    GeneratePalette(clGray);
    cxGroupBoxPen1.Caption := 'Gray Palette- ' + IntToStr(IEColorPalettePen1.ColorCount);
  end;
  if ComboBoxPenPalette1.Items[ComboBoxPenPalette1.ItemIndex] = 'Red' then
  begin
    { RedPalette 238 colors. }
    GeneratePalette(clRed);
    cxGroupBoxPen1.Caption := 'Red Palette- ' + IntToStr(IEColorPalettePen1.ColorCount);
  end;
  if ComboBoxPenPalette1.Items[ComboBoxPenPalette1.ItemIndex] = 'Green' then
  begin
    { GreenPalette. 238 colors. }
    GeneratePalette(clGreen);
    cxGroupBoxPen1.Caption := 'Green Palette- ' + IntToStr(IEColorPalettePen1.ColorCount);
  end;
  if ComboBoxPenPalette1.Items[ComboBoxPenPalette1.ItemIndex] = 'Blue' then
  begin
    { BluePalette1Click. 238 colors. }
    GeneratePalette(clBlue);
    cxGroupBoxPen1.Caption := 'Blue Palette- ' + IntToStr(IEColorPalettePen1.ColorCount);
  end;
  if ComboBoxPenPalette1.Items[ComboBoxPenPalette1.ItemIndex] = 'Brown' then
  begin
    { Brown Palette. 238 colors. }
    GeneratePalette($00003E75);
    cxGroupBoxPen1.Caption := 'Brown Palette- ' + IntToStr(IEColorPalettePen1.ColorCount);
  end;
  if ComboBoxPenPalette1.Items[ComboBoxPenPalette1.ItemIndex] = 'Yellow' then
  begin
    { Yellow Palette. 238 colors. }
    GeneratePalette(clYellow);
    cxGroupBoxPen1.Caption := 'Yellow Palette- ' + IntToStr(IEColorPalettePen1.ColorCount);
  end;
end;

procedure TForm1.ConvertTo24Bit;
begin
  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := 8;
  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel := 3;
  ImageEnMView1.RemoveAlphaChannel(False);
end;

procedure TForm1.ConvertTo8Bit;
begin
  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := 8;
  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel := 1;
  ImageEnMView1.RemoveAlphaChannel(False);
  ImageEnMView1.Proc.ConvertTo(256);
end;

procedure TForm1.ConvertTo8Bit1Click(Sender: TObject);
{ Convert to 8-bit. }
var
  iRGB: TRGB;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Convert to 8-Bit GrayScale' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      ImageEnView.IO.Params.BitsPerSample := 8;
      ImageEnView.IO.Params.SamplesPerPixel := 1;
      ImageEnView.RemoveAlphaChannel();
      ImageEnView.Proc.ConvertTo(256);
      ImageEnView.Proc.ConvertToGray();
      iRGB := ImageEnView.IEBitmap.Pixels[0, ImageEnView.IEBitmap.Height - 1];
      ImageEnView.BackGround := TRGB2TColor(iRGB);
      ImageEnView.BackgroundStyle := iebsSolid;
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := ImageEnView.Proc.CanUndo;
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Assign(ImageEnView.IO.Params);
      UpdateGUI;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.ConvertToImageLayer1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if IsTextLayer(ImageEnView) then
      begin
        { Convert the current layer to an image }
        ImageEnView.CurrentLayer.ConvertToImageLayer();
        ImageEnView.Update;
      end;
    end;
  end;
  UpdateGUI;
  UpdateLayers;
  UpdateStatusBar;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.CopyToClipboard(iecpSelection);
      ImageEnView.Update;
      UpdateGUI;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.ConvertTo4Bit;
begin
  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := 4;
  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel := 1;
  ImageEnMView1.RemoveAlphaChannel(False);
  ImageEnMView1.Proc.ConvertTo(4);
end;

procedure TForm1.ConvertTo4Bit1Click(Sender: TObject);
{ Convert to 4-bit. }
var
  iRGB: TRGB;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Convert to 4-Bit' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      ImageEnView.IO.Params.BitsPerSample := 4;
      ImageEnView.IO.Params.SamplesPerPixel := 1;
      ImageEnView.RemoveAlphaChannel();
      ImageEnView.Proc.ConvertTo(16);
      iRGB := ImageEnView.IEBitmap.Pixels[0, ImageEnView.IEBitmap.Height - 1];
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := ImageEnView.Proc.CanUndo;
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Assign(ImageEnView.IO.Params);
      UpdateGUI;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.MyUndo(AImageEnView: TImageEnView);
{ Undo the rect. }
var
  iRect: TRect;
begin
  iRect := Rect(0, 0, AImageEnView.IEBitmap.Width, AImageEnView.IEBitmap.Height);
  AImageEnView.Proc.UndoRect(iRect.Left, iRect.Top, iRect.Width, iRect.Height);
end;

procedure TForm1.PaintBrush(AX: Integer; AY: Integer);
var
  iPenWidth: Integer;
  iPenColor: Integer;
  iTransparency: Integer;
begin
  { Paint Brush }
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      with ImageEnView do
      begin
        iPenWidth := StrToIntDef(PenSize1.Text, 20);
        iPenColor := PenColor1.Selected;
        iTransparency := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
        IEBitmap.Canvas.Pen.Width := iPenWidth;
        IEBitmap.Canvas.Pen.Color := iPenColor;
        IEBitmap.IECanvas.SetCompositingMode(ieCompositingModeSourceOver, ieCompositingQualityHighQuality);
        IEBitmap.IECanvas.SmoothingMode := iesmAntialias;
        IEBitmap.Canvas.MoveTo(AX, AY);
        IEBitmap.Canvas.LineTo(ALastX, ALastY);
        IEBitmap.AlphaChannel.Canvas.Brush.Color := iPenColor or (iTransparency) or (iTransparency shl 8) or
          (iTransparency shl 16);
        IEBitmap.AlphaChannel.CanvasCurrentAlpha := iTransparency;
        IEBitmap.AlphaChannel.Canvas.Pen.Width := iPenWidth;
        IEBitmap.AlphaChannel.Canvas.MoveTo(AX, AY);
        IEBitmap.AlphaChannel.Canvas.LineTo(ALastX, ALastY);
        Update;
      end;
    end;
  end;
end;

procedure TForm1.DrawLine;
{ Draw Line. }
var
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iIECanvas: TIECanvas;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      MyUndo(ImageEnView);
      { Draw on the Non-Alpha Canvas }
      iIECanvas := TIECanvas.Create(ImageEnView.IEBitmap.Canvas, Antialias1.Checked, UseGDIPlus1.Checked);
      iPenSize := StrToIntDef(PenSize1.Text, 15);
      iPenColor := PenColor.Color;
      iPenAlpha := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
      iIECanvas.SetCompositingMode(ieCompositingModeSourceOver, ieCompositingQualityHighQuality);
      iIECanvas.SmoothingMode := iesmBestRenderingQuality;
      iIECanvas.Pen.LineJoin := ieljMiter;
      iIECanvas.Pen.Color := iPenColor;
      iIECanvas.Pen.Transparency := iPenAlpha;
      iIECanvas.Pen.Style := psSolid;
      iIECanvas.Pen.Width := iPenSize;
      iIECanvas.Brush.Style := bsClear;
      iIECanvas.MoveTo(AStartX, AStartY);
      iIECanvas.LineTo(ALastX, ALastY);
      iIECanvas.Free();
      { Draw on the Alpha Canvas - do not assign color here... it will overwrite
        the alphachannel }
      ImageEnView.IEBitmap.AlphaChannel.CanvasCurrentAlpha := iPenAlpha;
      iIECanvas := ImageEnView.Layers[ImageEnView.LayersCurrent].Bitmap.AlphaChannel.CreateROICanvas
        (Rect(0, 0, ImageEnView.IEBitmap.Width, ImageEnView.IEBitmap.Height), Antialias1.Checked, UseGDIPlus1.Checked);
      iIECanvas.SetCompositingMode(ieCompositingModeSourceOver, ieCompositingQualityHighQuality);
      iIECanvas.SmoothingMode := iesmBestRenderingQuality;
      iIECanvas.Pen.LineJoin := ieljMiter;
      iIECanvas.Pen.Style := psSolid;
      iIECanvas.Pen.Color := iPenAlpha or (iPenAlpha shl 8) or (iPenAlpha shl 16);
      iIECanvas.Pen.Width := iPenSize;
      iIECanvas.Brush.Style := bsClear;
      iIECanvas.MoveTo(AStartX, AStartY);
      iIECanvas.LineTo(ALastX, ALastY);
      iIECanvas.Free();
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
    end;
  end;
end;

procedure TForm1.DrawRectangle;
{ Draw rectangle. }
var
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  ix1, ix2, iy1, iy2: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      MyUndo(ImageEnView);
      { Draw on the Non-Alpha Canvas }
      iIECanvas1 := TIECanvas.Create(ImageEnView.IEBitmap.Canvas, Antialias1.Checked, UseGDIPlus1.Checked);
      iPenSize := StrToIntDef(PenSize1.Text, 15);
      iPenColor := PenColor.Color;
      iPenAlpha := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
      iIECanvas1.Pen.Color := iPenColor;
      iIECanvas1.Pen.Transparency := iPenAlpha;
      iIECanvas1.Pen.Style := psSolid;
      iIECanvas1.Pen.Width := iPenSize;
      iIECanvas1.Brush.Style := bsClear;
      ix1 := AStartX;
      iy1 := AStartY;
      ix2 := ALastX;
      iy2 := ALastY;
      { Adjust the coordinates based on the direction of the drag }
      if ix2 <= ix1 then
      begin
        ix1 := ix1 + iPenSize;
        if ix2 = 1 then
          ix2 := 0;
      end;
      if iy2 <= iy1 then
      begin
        iy1 := iy1 + iPenSize;
        if iy2 = 1 then
          iy2 := 0;
      end;
      { Order the coordinates, putting the first as top-left }
      OrdCor(ix1, iy1, ix2, iy2);
      iIECanvas1.Rectangle(ix1, iy1, ix2, iy2);
      iIECanvas1.Free();
      { Draw on the Alpha Canvas }
      iIECanvas2 := ImageEnView.IEBitmap.AlphaChannel.CreateROICanvas(Rect(ix1 - iPenSize, iy1 - iPenSize, ix2 + iPenSize,
        iy2 + iPenSize), Antialias1.Checked, UseGDIPlus1.Checked);
      iIECanvas2.Pen.Width := iPenSize;
      iIECanvas2.Pen.Style := psSolid;
      iIECanvas2.Pen.Transparency := iPenAlpha;
      iIECanvas2.Pen.Color := iPenAlpha or (iPenAlpha shl 8) or (iPenAlpha shl 16);
      iIECanvas2.Brush.Style := bsClear;
      iIECanvas2.Rectangle(ix1, iy1, ix2, iy2);
      iIECanvas2.Free();
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
    end;
  end;
end;

procedure TForm1.DrawFilledRectangle;
{ Draw a filled rectangle. }
var
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iBrushColor: TColor;
  iBrushAlpha: Integer;
  ix1, iy1, ix2, iy2: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      { Draw on the Non-Alpha Canvas }
      MyUndo(ImageEnView);
      iIECanvas1 := TIECanvas.Create(ImageEnView.IEBitmap.Canvas, Antialias1.Checked, UseGDIPlus1.Checked);
      iPenSize := StrToIntDef(PenSize1.Text, 15);
      iPenColor := PenColor.Color;
      iPenAlpha := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
      iBrushColor := BrushColor.Color;
      iBrushAlpha := IEOpacityToAlpha(StrToIntDef(BrushOpacity1.Text, 100));
      iIECanvas1.Pen.Color := iPenColor;
      iIECanvas1.Pen.Transparency := iPenAlpha;
      iIECanvas1.Pen.Style := psSolid;
      iIECanvas1.Pen.Width := iPenSize;
      iIECanvas1.Brush.Color := iBrushColor;
      iIECanvas1.Brush.BackColor := iBrushColor;
      iIECanvas1.Brush.Style := bsSolid;
      iIECanvas1.Brush.Transparency := iBrushAlpha;
      iIECanvas1.Brush.BackTransparency := iBrushAlpha;
      ix1 := AStartX - iPenSize;
      iy1 := AStartY - iPenSize;
      ix2 := ALastX + iPenSize;
      iy2 := ALastY + iPenSize;
      iIECanvas1.Rectangle(ix1, iy1, ix2, iy2);
      iIECanvas1.Free();
      { Draw on the Alpha Canvas }
      OrdCor(ix1, iy1, ix2, iy2);
      iIECanvas2 := ImageEnView.IEBitmap.AlphaChannel.CreateROICanvas(Rect(ix1 - iPenSize, iy1 - iPenSize, ix2 + iPenSize,
        iy2 + iPenSize), Antialias1.Checked, UseGDIPlus1.Checked);
      iIECanvas2.Pen.Style := psSolid;
      iIECanvas2.Pen.Color := iPenAlpha or (iPenAlpha shl 8) or (iPenAlpha shl 16);
      iIECanvas2.Pen.Width := iPenSize;
      iIECanvas2.Brush.Style := bsSolid;
      iIECanvas2.Brush.Color := iBrushAlpha or (iBrushAlpha shl 8) or (iBrushAlpha shl 16);
      iIECanvas2.Brush.BackColor := iBrushAlpha or (iBrushAlpha shl 8) or (iBrushAlpha shl 16);
      iIECanvas2.Rectangle(ix1, iy1, ix2, iy2);
      iIECanvas2.Free();
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
    end;
  end;
end;

procedure TForm1.DrawRoundRectangle;
{ Draw Round Rectangle. }
var
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iRoundRectRadius: Integer;
  ix1: Integer;
  iy1: Integer;
  ix2: Integer;
  iy2: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      MyUndo(ImageEnView);
      { Draw on the Non-Alpha Canvas }
      iIECanvas1 := TIECanvas.Create(ImageEnView.IEBitmap.Canvas, Antialias1.Checked, UseGDIPlus1.Checked);
      iPenSize := StrToIntDef(PenSize1.Text, 15);
      iPenColor := PenColor.Color;
      iPenAlpha := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
      iRoundRectRadius := StrToIntDef(RoundRectangleRadius1.Text, 8);
      iIECanvas1.Pen.Color := iPenColor;
      iIECanvas1.Pen.Transparency := iPenAlpha;
      iIECanvas1.Pen.Style := psSolid;
      iIECanvas1.Pen.Width := iPenSize;
      iIECanvas1.Brush.Style := bsClear;
      ix1 := AStartX;
      iy1 := AStartY;
      ix2 := ALastX;
      iy2 := ALastY;
      { Adjust the coordinates based on the direction of the drag }
      if ix2 <= ix1 then
      begin
        ix1 := ix1 + iPenSize;
        if ix2 = 1 then
          ix2 := 0;
      end;
      if iy2 <= iy1 then
      begin
        iy1 := iy1 + iPenSize;
        if iy2 = 1 then
          iy2 := 0;
      end;
      { Order the coordinates, putting the first as top-left }
      OrdCor(ix1, iy1, ix2, iy2);
      iIECanvas1.RoundRect(ix1, iy1, ix2, iy2, iRoundRectRadius, iRoundRectRadius);
      iIECanvas1.Free();
      { Draw on the Alpha Canvas }
      iIECanvas2 := ImageEnView.IEBitmap.AlphaChannel.CreateROICanvas(Rect(ix1 - iPenSize, iy1 - iPenSize, ix2 + iPenSize,
        iy2 + iPenSize), Antialias1.Checked, UseGDIPlus1.Checked);
      iIECanvas2.Pen.Width := iPenSize;
      iIECanvas2.Pen.Style := psSolid;
      iIECanvas2.Pen.Transparency := iPenAlpha;
      iIECanvas2.Pen.Color := iPenAlpha or (iPenAlpha shl 8) or (iPenAlpha shl 16);
      iIECanvas2.Brush.Style := bsClear;
      iIECanvas2.RoundRect(ix1, iy1, ix2, iy2, iRoundRectRadius, iRoundRectRadius);
      iIECanvas2.Free();
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
    end;
  end;
end;

procedure TForm1.DrawEllipse;
{ Draw Ellipse. }
var
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  ix1, ix2, iy1, iy2: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      MyUndo(ImageEnView);
      { Draw on the Non-Alpha Canvas }
      iIECanvas1 := TIECanvas.Create(ImageEnView.IEBitmap.Canvas, Antialias1.Checked, UseGDIPlus1.Checked);
      iPenSize := StrToIntDef(PenSize1.Text, 15);
      iPenColor := PenColor.Color;
      iPenAlpha := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
      iIECanvas1.Pen.Color := iPenColor;
      iIECanvas1.Pen.Transparency := iPenAlpha;
      iIECanvas1.Pen.Style := psSolid;
      iIECanvas1.Pen.Width := iPenSize;
      iIECanvas1.Brush.Style := bsClear;
      ix1 := AStartX;
      iy1 := AStartY;
      ix2 := ALastX;
      iy2 := ALastY;
      { Adjust the coordinates based on the direction of the drag }
      if ix2 <= ix1 then
      begin
        ix1 := ix1 + iPenSize;
        if ix2 = 1 then
          ix2 := 0;
      end;
      if iy2 <= iy1 then
      begin
        iy1 := iy1 + iPenSize;
        if iy2 = 1 then
          iy2 := 0;
      end;
      { Order the coordinates, putting the first as top-left }
      OrdCor(ix1, iy1, ix2, iy2);
      iIECanvas1.Ellipse(ix1, iy1, ix2, iy2);
      iIECanvas1.Free();
      { Draw on the Alpha Canvas }
      iIECanvas2 := ImageEnView.IEBitmap.AlphaChannel.CreateROICanvas(Rect(ix1 - iPenSize, iy1 - iPenSize, ix2 + iPenSize,
        iy2 + iPenSize), Antialias1.Checked, UseGDIPlus1.Checked);
      iIECanvas2.Pen.Width := iPenSize;
      iIECanvas2.Pen.Style := psSolid;
      iIECanvas2.Pen.Transparency := iPenAlpha;
      iIECanvas2.Pen.Color := iPenAlpha or (iPenAlpha shl 8) or (iPenAlpha shl 16);
      iIECanvas2.Brush.Style := bsClear;
      iIECanvas2.Ellipse(ix1, iy1, ix2, iy2);
      iIECanvas2.Free();
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
    end;
  end;
end;

procedure TForm1.DrawFilledEllipse;
{ Draw a filled ellipse. }
var
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iBrushColor: TColor;
  iBrushAlpha: Integer;
  ix1, iy1, ix2, iy2: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      { Draw on the Non-Alpha Canvas }
      MyUndo(ImageEnView);
      iIECanvas1 := TIECanvas.Create(ImageEnView.IEBitmap.Canvas, Antialias1.Checked, UseGDIPlus1.Checked);
      iPenSize := StrToIntDef(PenSize1.Text, 15);
      iPenColor := PenColor.Color;
      iPenAlpha := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
      iBrushColor := BrushColor.Color;
      iBrushAlpha := IEOpacityToAlpha(StrToIntDef(BrushOpacity1.Text, 100));
      iIECanvas1.Pen.Color := iPenColor;
      iIECanvas1.Pen.Transparency := iPenAlpha;
      iIECanvas1.Pen.Style := psSolid;
      iIECanvas1.Pen.Width := iPenSize;
      iIECanvas1.Brush.Color := iBrushColor;
      iIECanvas1.Brush.BackColor := iBrushColor;
      iIECanvas1.Brush.Style := bsSolid;
      iIECanvas1.Brush.Transparency := iBrushAlpha;
      iIECanvas1.Brush.BackTransparency := iBrushAlpha;
      ix1 := AStartX - iPenSize;
      iy1 := AStartY - iPenSize;
      ix2 := ALastX + iPenSize;
      iy2 := ALastY + iPenSize;
      iIECanvas1.Ellipse(ix1, iy1, ix2, iy2);
      iIECanvas1.Free();
      { Draw on the Alpha Canvas }
      OrdCor(ix1, iy1, ix2, iy2);
      iIECanvas2 := ImageEnView.IEBitmap.AlphaChannel.CreateROICanvas(Rect(ix1 - iPenSize, iy1 - iPenSize, ix2 + iPenSize,
        iy2 + iPenSize), Antialias1.Checked, UseGDIPlus1.Checked);
      iIECanvas2.Pen.Style := psSolid;
      iIECanvas2.Pen.Color := iPenAlpha or (iPenAlpha shl 8) or (iPenAlpha shl 16);
      iIECanvas2.Pen.Width := iPenSize;
      iIECanvas2.Brush.Style := bsSolid;
      iIECanvas2.Brush.Color := iBrushAlpha or (iBrushAlpha shl 8) or (iBrushAlpha shl 16);
      iIECanvas2.Brush.BackColor := iBrushAlpha or (iBrushAlpha shl 8) or (iBrushAlpha shl 16);
      iIECanvas2.Ellipse(ix1, iy1, ix2, iy2);
      iIECanvas2.Free();
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
    end;
  end;
end;

procedure TForm1.DuplexEnabled1Click(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.DrawFilledRoundRectangle;
{ Draw a filled round rectangle. }
var
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iBrushColor: TColor;
  iBrushAlpha: Integer;
  iRoundRectRadius: Integer;
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  ix1, iy1, ix2, iy2: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      { Draw on the Non-Alpha Canvas }
      MyUndo(ImageEnView);
      iIECanvas1 := TIECanvas.Create(ImageEnView.IEBitmap.Canvas, Antialias1.Checked, UseGDIPlus1.Checked);
      iPenSize := StrToIntDef(PenSize1.Text, 15);
      iPenColor := PenColor.Color;
      iPenAlpha := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
      iBrushColor := BrushColor.Color;
      iBrushAlpha := IEOpacityToAlpha(StrToIntDef(BrushOpacity1.Text, 100));
      iRoundRectRadius := StrToIntDef(RoundRectangleRadius1.Text, 8);
      iIECanvas1.Pen.Color := iPenColor;
      iIECanvas1.Pen.Transparency := iPenAlpha;
      iIECanvas1.Pen.Style := psSolid;
      iIECanvas1.Pen.Width := iPenSize;
      iIECanvas1.Brush.Color := iBrushColor;
      iIECanvas1.Brush.BackColor := iBrushColor;
      iIECanvas1.Brush.Style := bsSolid;
      iIECanvas1.Brush.Transparency := iBrushAlpha;
      iIECanvas1.Brush.BackTransparency := iBrushAlpha;
      ix1 := AStartX - iPenSize;
      iy1 := AStartY - iPenSize;
      ix2 := ALastX + iPenSize;
      iy2 := ALastY + iPenSize;
      iIECanvas1.RoundRect(ix1, iy1, ix2, iy2, iRoundRectRadius, iRoundRectRadius);
      iIECanvas1.Free();
      { Draw on the Alpha Canvas }
      OrdCor(ix1, iy1, ix2, iy2);
      iIECanvas2 := ImageEnView.IEBitmap.AlphaChannel.CreateROICanvas(Rect(ix1 - iPenSize, iy1 - iPenSize, ix2 + iPenSize,
        iy2 + iPenSize), Antialias1.Checked, UseGDIPlus1.Checked);
      iIECanvas2.Pen.Style := psSolid;
      iIECanvas2.Pen.Color := iPenAlpha or (iPenAlpha shl 8) or (iPenAlpha shl 16);
      iIECanvas2.Pen.Width := iPenSize;
      iIECanvas2.Brush.Style := bsSolid;
      iIECanvas2.Brush.Color := iBrushAlpha or (iBrushAlpha shl 8) or (iBrushAlpha shl 16);
      iIECanvas2.RoundRect(ix1, iy1, ix2, iy2, iRoundRectRadius, iRoundRectRadius);
      iIECanvas2.Free();
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
    end;
  end;
end;

procedure TForm1.DecreaseBrightness1Click(Sender: TObject);
var
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        iNotification := NotificationCenter1.CreateNotification;
        try
          iNotification.Name := 'Notification';
          iNotification.Title := 'Brightness ';
          iNotification.AlertBody := 'Decreasing the image brightness...';
          NotificationCenter1.PresentNotification(iNotification);
        finally
          iNotification.Free;
        end;
        ImageEnView.Proc.SaveUndo('Brightness ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
        Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
        ImageEnView.Proc.AdjustBrightnessContrastSaturation(-10, 0, 0);
        ImageEnView.Update;
        ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage, ImageEnView.IEBitmap);
        ImageEnMView1.Update;
        ImageEnView.IEBitmap.Modified := True;
        ImageEnMView1.IEMBitmap.Modified := True;
        UpdateGUI;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.DeleteFrame1Click(Sender: TObject);
var
  i: Integer;
begin
  if ImageEnMView1.SelectedImage <> -1 then
  begin
    Screen.Cursor := crHourglass;
    try
      PageControl1.ActivePage.Free;
      ImageEnMView1.DeleteImage(ImageEnMView1.SelectedImage);
      if ImageEnMView1.ImageCount > 0 then
      begin
        UpdateFrames;
        UpdatePageControl;
        ImageEnMView1.Update;
        UpdateGUI;
        UpdateLayers;
        UpdateStatusBar
      end
      else if ImageEnMView1.ImageCount = 0 then
      begin
        AFilename := '';
        Layers1.Clear;
        { Close all pages }
        if PageControl1.PageCount > 0 then
          for i := PageControl1.PageCount - 1 downto 0 do
            PageControl1.Pages[i].Free;
        ClearStatusBar;
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TForm1.DisplayGrid1Click(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
    if Assigned(ImageEnView) then
      ImageEnView.DisplayGrid := DisplayGrid1.Checked;
  end;
end;

procedure TForm1.Undo1Click(Sender: TObject);
{ Undo the last change }
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Assigned(ImageEnView.IEBitmap) then
      begin
        ImageEnView.Proc.Undo;
        ImageEnView.Proc.ClearUndo;
        ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
        ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
        ImageEnView.Update;
        ImageEnView.LayersCurrent := 0;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        ImageEnView.IEBitmap.Modified := ImageEnView.Proc.CanUndo;
        ImageEnMView1.IEMBitmap.Modified := ImageEnMView1.Proc.CanUndo;
        UpdateGUI;
        UpdateFrame;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.UnGroupLayers1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      MultipleLayerSelection1.Checked := False;
      ImageEnView.LayerOptions := ImageEnView.LayerOptions - [loAllowMultiSelect];
      ImageEnView.LayersUngroup(True);
      ImageEnView.LayersDeselectAll;
      Layers1.ItemIndex := 0;
      UpdateGUI;
    end;
  end;
end;

procedure TForm1.UpdateFrame;
var
  iDimensions: string;
  iColor: string;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnMView1.SelectedImage <> -1 then
      begin
        ImageEnView.LayersCurrent := 0;
        iDimensions := IntegerToString(ImageEnView.IEBitmap.Width) + ' x ' + IntegerToString(ImageEnView.IEBitmap.Height);
        if ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel = 32 then
          iColor := 'RGBA ' + IntToStr(ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel) + '-Bit'
        else
          iColor := 'RGB ' + IntToStr(ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel) + '-Bit';
        ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions + ' ' + iColor;
        if FileExists(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName) then
          if IEGetFileFramesCount(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName) > 1 then
            ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] := 'Frame ' +
              IntToStr(ImageEnMView1.SelectedImage + 1)
          else
            ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] :=
              ExtractFileName(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName);
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnView.Update;
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Assign(ImageEnView.IO.Params);
      end;
    end;
  end;
end;

procedure TForm1.UpdateFrames;
var
  i: Integer;
  iDimensions: string;
  iColor: string;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnMView1.ImageCount > 0 then
      begin
        for i := 0 to ImageEnMView1.ImageCount - 1 do
        begin
          ImageEnView.LayersCurrent := 0;
          iDimensions := IntegerToString(ImageEnMView1.IEBitmap.Width) + ' x ' +
            IntegerToString(ImageEnMView1.IEBitmap.Height);
          if ImageEnMView1.MIO.Params[i].BitsPerSample * ImageEnMView1.MIO.Params[i].SamplesPerPixel = 32 then
            iColor := 'RGBA ' + IntToStr(ImageEnMView1.MIO.Params[i].BitsPerSample * ImageEnMView1.MIO.Params[i]
              .SamplesPerPixel) + '-Bit'
          else
            iColor := 'RGB ' + IntToStr(ImageEnMView1.MIO.Params[i].BitsPerSample * ImageEnMView1.MIO.Params[i]
              .SamplesPerPixel) + '-Bit';
          ImageEnMView1.ImageTopText[i] := iDimensions + ' ' + iColor;
          if FileExists(ImageEnMView1.MIO.Params[i].FileName) then
            if IEGetFileFramesCount(ImageEnMView1.MIO.Params[i].FileName) > 1 then
              ImageEnMView1.ImageBottomText[i] := 'Frame ' + IntToStr(i + 1)
            else
              ImageEnMView1.ImageBottomText[i] := ExtractFileName(ImageEnMView1.MIO.Params[i].FileName);
        end;
      end;
    end;
  end;
end;

procedure TForm1.UpdatePageControl;
var
  i: Integer;
  iFileName: string;
begin
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    iFileName := ImageEnMView1.MIO.Params[i].FileName;
    if IEGetFileFramesCount(iFileName) > 1 then
      PageControl1.Pages[i].Caption := 'Frame ' + IntToStr(i + 1)
    else
      PageControl1.Pages[i].Caption := ExtractFileName(iFileName);
  end;
end;

procedure TForm1.UpdateLayers;
var
  i: Integer;
  iListItem: TListItem;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Layers1.Items.BeginUpdate;
      try
        Layers1.Clear;
        for i := 0 to ImageEnView.LayersCount - 1 do
        begin
          ImageEnView.LayersCurrent := i;
          iListItem := Layers1.Items.Add;
          if i > 0 then
            iListItem.Caption := IntToStr(iListItem.Index);
          if i > 0 then
            ImageEnView.CurrentLayer.Name := 'Layer ' + IntToStr(i)
          else
            ImageEnView.CurrentLayer.Name := 'Background';
          iListItem.SubItems.Add(GetLayerKindStr(ImageEnView));
          iListItem.SubItems.Add(ImageEnView.CurrentLayer.Name);
          iListItem.SubItems.Add(IntegerToString(ImageEnView.CurrentLayer.PosX));
          iListItem.SubItems.Add(IntegerToString(ImageEnView.CurrentLayer.PosY));
          iListItem.SubItems.Add(IntegerToString(ImageEnView.CurrentLayer.Width));
          iListItem.SubItems.Add(IntegerToString(ImageEnView.CurrentLayer.Height));
          Layers1.ItemIndex := i;
          iListItem.Selected := True;
        end;
        Layers1.ItemIndex := ImageEnView.LayersCurrent;
      finally
        Layers1.Items.EndUpdate;
      end;
    end;
  end;
end;

procedure TForm1.CloseActivePage1Click(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    if Assigned(PageControl1.ActivePage) then
      PageControl1.ActivePage.Free;
    ImageEnMView1.DeleteImage(ImageEnMView1.SelectedImage);
    UpdateFrames;
    UpdateLayers;
    UpdatePageControl;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.CloseAllPages1Click(Sender: TObject);
var
  i: Integer;
begin
  Caption := 'ImageEn 7.0 Multiframe Image Editor';
  { Close all pages }
  for i := Pred(PageControl1.PageCount) downto 0 do
    PageControl1.Pages[i].Free;
  for i := Pred(ImageEnMView1.ImageCount) downto 0 do
    ImageEnMView1.DeleteImage(i);
  ImageEnMView1.Update;
  Layers1.Clear;
  ClearStatusBar;
end;

procedure TForm1.Shape1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEShapeLayer then
        with TIEShapeLayer(ImageEnView.CurrentLayer) do
        begin
          Shape := TIEShape(Shape1.ItemIndex);
          ImageEnView.Update;
        end;
    end;
  end;
end;

procedure TForm1.Shape1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  iShapeColor: TColor;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iShapeColor := $000909D5;
      if ImageEnView.CurrentLayer is TIEShapeLayer then
        iShapeColor := ImageEnView.CurrentLayer.FillColor;
      IEDrawShapeToComboListBoxItem(TComboBox(Control).Canvas, Rect, Control.Enabled, TIEShape(Index), iShapeColor);
    end;
  end;
end;

procedure TForm1.LayerPreviewQuality1Change(Sender: TObject);
const
  _cmbPreviewQuality_Fast = 0;
  _cmbPreviewQuality_Delayed_Best = 1;
  _cmbPreviewQuality_Best = 2;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if LayerPreviewQuality1.ItemIndex = _cmbPreviewQuality_Fast then
      begin
        { FASTEST DISPLAY }
        { Zoom filter }
        ImageEnView.ZoomFilter := rfNone;
        ImageEnView.DelayZoomFilter := False;
        { Rotation anti-alias }
        ImageEnView.LayersRotationFilter := ierBicubic;
        ImageEnView.LayersRotationAntialias := True;
        ImageEnView.LayersRotationUseFilterOnPreview := False;
        { Fast drawing }
        ImageEnView.LayersFastDrawing := iefFast;
      end
      else if LayerPreviewQuality1.ItemIndex = _cmbPreviewQuality_Delayed_Best then
      begin
        { DELAYED HIGH QUALITY }
        { Zoom filter }
        ImageEnView.ZoomFilter := rfLanczos3;
        ImageEnView.DelayZoomFilter := True;
        { Rotation anti-alias }
        ImageEnView.LayersRotationFilter := ierBicubic;
        ImageEnView.LayersRotationAntialias := True;
        ImageEnView.LayersRotationUseFilterOnPreview := True;
        { Fast drawing }
        ImageEnView.LayersFastDrawing := iefDelayed;
      end
      else
      begin
        { HIGH QUALITY }
        { Zoom filter }
        ImageEnView.ZoomFilter := rfLanczos3;
        ImageEnView.DelayZoomFilter := False;
        { Rotation anti-alias }
        ImageEnView.LayersRotationFilter := ierBicubic;
        ImageEnView.LayersRotationAntialias := True;
        ImageEnView.LayersRotationUseFilterOnPreview := True;
        { Fast drawing }
        ImageEnView.LayersFastDrawing := iefNormal;
      end;
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.ClearStatusBar;
var
  i: Integer;
begin
  Caption := 'ImageEn 7.0 Multiframe Image Editor';
  for i := 0 to StatusBar1.Panels.Count - 1 do
    StatusBar1.Panels[i].Text := '';
end;

procedure TForm1.UpdateStatusBar;
{ Display info }
var
  iWidth1: Integer;
  iWidth2: Integer;
  iBitDepth: Integer;
begin
  if (Assigned(PageControl1.ActivePage)) and (ImageEnMView1.SelectedImage <> -1) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Caption := 'ImageEn 7.0 Multiframe Image Editor- ' + AFilename;
      iBitDepth := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel * ImageEnMView1.MIO.Params
        [ImageEnMView1.SelectedImage].BitsPerSample;
      iWidth1 := StatusBar1.Panels[0].Width - 10;
      iWidth2 := StatusBar1.Panels[1].Width - 10;
      StatusBar1.Panels[0].Text := EllipsifyText(True, ExtractFilePath(AFilename), Canvas, iWidth1);
      StatusBar1.Panels[1].Text := EllipsifyText(False, ExtractFileName(AFilename), Canvas, iWidth2);
      if iBitDepth = 32 then
        StatusBar1.Panels[2].Text := 'Color: RGBA' +
          IntToStr(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel * ImageEnMView1.MIO.Params
          [ImageEnMView1.SelectedImage].BitsPerSample) + '-bit'
      else
        StatusBar1.Panels[2].Text := 'Color: RGB' +
          IntToStr(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel * ImageEnMView1.MIO.Params
          [ImageEnMView1.SelectedImage].BitsPerSample) + '-bit';
      StatusBar1.Panels[3].Text := 'Zoom: ' + FloatToStrF(ImageEnView.Zoom, ffFixed, 10, 1) + '%';
      StatusBar1.Panels[4].Text := 'Layers: ' + IntToStr(ImageEnView.LayersCount);
      StatusBar1.Panels[5].Text := 'Layer: ' + IntToStr(ImageEnView.LayersCurrent);
      StatusBar1.Panels[6].Text := 'Layer Name: ' + ImageEnView.Layers[ImageEnView.LayersCurrent].Name;
      StatusBar1.Panels[7].Text := 'Layer Kind: ' + GetLayerKindStr(ImageEnView);
      StatusBar1.Panels[11].Text := 'Frames: ' + IntToStr(ImageEnMView1.ImageCount);
      StatusBar1.Panels[12].Text := 'Frame: ' + IntToStr(ImageEnMView1.SelectedImage + 1);
      StatusBar1.Panels[13].Text := 'Width: ' + IntegerToString(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width);
      StatusBar1.Panels[14].Text := 'Height: ' +
        IntegerToString(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height);
      LabelZoom1.Caption := 'Zoom: ' + IntToStr(Round(ImageEnView.Zoom)) + '%';
      if ImageEnView.IEBitmap.Modified then
        StatusBar1.Panels[15].Text := 'Modified'
      else
        StatusBar1.Panels[15].Text := '';
    end;
  end;
end;

procedure TForm1.Acquire1Click(Sender: TObject);
{ Acquire from selected device }
Var
  iFileName: string;
  iBlankPages: Integer;
  iDimensions: string;
  iBitDepth: Integer;
  iColor: string;
begin
  if ImageEnMView1.MIO.AcquireParams.SelectedSource.API = ieaNone then
  begin
    MessageDlg('You have not specified an acquisition source', mtInformation, [mbOK], 0);
    exit;
  end;
  Abort1.Enabled := True;
  Abort1.Visible := True;
  Acquire1.Enabled := False;
  try
    Screen.Cursor := crHourglass;
    SaveProperties;
    if EnableLogging1.Checked then
      ImageEnMView1.MIO.TwainParams.LogFile := WindowsTempFolder() + 'ietwainlog.txt'
    else
      ImageEnMView1.MIO.TwainParams.LogFile := '';
    ImageEnMView1.MIO.TwainParams.AutoDiscardBlankPages := -1;
    ImageEnMView1.MIO.AcquireParams.VisibleDialog := VisibleDialog1.Checked;
    ImageEnMView1.MIO.Acquire;
    Abort1.Visible := False;
    Acquire1.Enabled := True;
    ImageEnMView1.SelectedImage := 0;
    AddTabsheet;
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        ImageEnMView1.CopyToIEBitmap(ImageEnMView1.SelectedImage, ImageEnView.IEBitmap);
        if ImageEnView.IEBitmap.Width > ImageEnView.IEBitmap.Height then
          ImageEnView.FitToWidth
        else
          ImageEnView.FitToHeight;
        iBlankPages := ImageEnMView1.RemoveBlankPages(0.0, True, True);
        if iBlankPages > 0 then
          ImageEnView.Clear;
        ImageEnView.Update;
        iFileName := DocumentsFolder + 'Untitled' + IntToStr(ImageEnMView1.ImageCount) + '.tif';
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName := iFileName;
        iDimensions := IntegerToString(ImageEnMView1.IEBitmap.Width) + ' x ' +
          IntegerToString(ImageEnMView1.IEBitmap.Height);
        iBitDepth := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel * ImageEnMView1.MIO.Params
          [ImageEnMView1.SelectedImage].BitsPerSample;
        if iBitDepth = 32 then
          iColor := 'RGBA 32-Bit'
        else
          iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
        PageControl1.Pages[ImageEnMView1.SelectedImage].Caption := iFileName;
        ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions + ' ' + iColor;
        ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] := 'Frame ' + IntToStr(ImageEnMView1.ImageCount);
        ImageEnMView1.IEMBitmap.Modified := True;
      end;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
  UpdateGUI;
  UpdateStatusBar;
end;

procedure TForm1.AddFrame1Click(Sender: TObject);
var
  i: Integer;
  iFileName: string;
  iIndex: Integer;
  iDimensions: string;
  iColor: string;
  iZoom: Double;
begin
  OpenPictureDialog1.Filter := GraphicFilter(TGraphic);
  OpenPictureDialog1.FilterIndex := 0;
  OpenPictureDialog1.FileName := '';
  OpenPictureDialog1.DefaultExt := '.jpg';
  if OpenPictureDialog1.Execute then
  begin
    ShowTempHourglass;
    for i := 0 to OpenPictureDialog1.Files.Count - 1 do
      if FileExists(OpenPictureDialog1.Files[i]) then
      begin
        iFileName := OpenPictureDialog1.Files[i];
        iIndex := ImageEnMView1.AppendImage;
        AddTabsheet;
        if Assigned(PageControl1.ActivePage) then
        begin
          ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
          if Assigned(ImageEnView) then
          begin
            ImageEnView.IO.LoadFromFile(iFileName);
            ImageEnMView1.SetImageFromFile(iIndex, iFileName, iIndex);
            ImageEnMView1.MIO.Params[iIndex].Assign(ImageEnView.IO.Params);
            ImageEnMView1.ImageBottomText[iIndex] := 'Frame ' + IntToStr(iIndex + 1);
            iDimensions := IntegerToString(ImageEnMView1.MIO.Params[iIndex].Width) + ' x ' +
              IntegerToString(ImageEnMView1.MIO.Params[iIndex].Height);
            if ImageEnMView1.MIO.Params[iIndex].BitsPerSample * ImageEnMView1.MIO.Params[iIndex].SamplesPerPixel = 32 then
              iColor := 'RGBA ' + IntToStr(ImageEnMView1.MIO.Params[iIndex].BitsPerSample * ImageEnMView1.MIO.Params[iIndex]
                .SamplesPerPixel) + '-Bit'
            else
              iColor := 'RGB ' + IntToStr(ImageEnMView1.MIO.Params[iIndex].BitsPerSample * ImageEnMView1.MIO.Params[iIndex]
                .SamplesPerPixel) + '-Bit';
            ImageEnMView1.ImageTopText[iIndex] := iDimensions + ' ' + iColor;
            if OpenPictureDialog1.Files.Count > 1 then
              ImageEnMView1.SelectedImage := 0;
            ImageEnMView1.Update;
            ImageEnView.IEBitmap.Modified := True;
            ImageEnMView1.IEMBitmap.Modified := True;
            iZoom := ImageEnView.GetIdealZoom - ImageEnView.GetIdealZoom * 0.025;
            ImageEnView.Zoom := iZoom;
            ImageEnMView1.Update;
            UpdateFrames;
            UpdatePageControl;
            UpdateLayers;
            UpdateStatusBar;
          end;
        end;
      end;
  end;
end;

procedure TForm1.AddTextLayer1Click(Sender: TObject);
var
  i: Integer;
  iLayer: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        ImageEnView.LayersCurrent := 0;
        ImageEnView.LayerOptions := ImageEnView.LayerOptions - [loAllowMultiSelect];
        iLayer := ImageEnView.LayersAdd(ielkText);
        ImageEnView.Layers[iLayer].Name := 'Text Layer';
        ImageEnView.Layers[iLayer].PosX := ImageEnView.Layers[iLayer - 1].PosX + 100;
        ImageEnView.Layers[iLayer].PosY := ImageEnView.Layers[iLayer - 1].PosY + 100;
        SelectLayers1.Down := True;
        ImageEnView.MouseInteract := ImageEnView.MouseInteract + [miMoveLayers, miResizeLayers];
        if ImageEnView.Layers[ImageEnView.LayersCurrent].Width > ImageEnView.IEBitmap.Width then
          ImageEnView.Layers[ImageEnView.LayersCurrent].Width := ImageEnView.IEBitmap.Width;
        FillColorBox1.Selected := clNone;
        SetLayerTextParameters;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        if not AutoSize1.Checked then
        begin
          ImageEnView.CurrentLayer.Width := 400;
          ImageEnView.CurrentLayer.Height := 100;
        end;
        SelectLayers1.Down := True;
        UseCurrentLayer1.Checked := True;
        ImageEnView.LockUpdate();
        for i := 0 to ImageEnView.LayersCount - 1 do
        begin
          ImageEnView.Layers[i].GroupIndex := 0;
          ImageEnView.Layers[i].Selected := False;
        end;
        ImageEnView.UnlockUpdate();
        ImageEnView.LayersCurrent := iLayer;
        GetLayerTextParameters;
        UpdateGUI;
        UpdateLayers;
        UpdateStatusBar;
        EnableControls(TabSheet10, True);
        EnableControls(TabSheet9, True);
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.AddImageLayer1Click(Sender: TObject);
var
  iRGB: TRGB;
  iFileName: string;
  iLayer: Integer;
begin
  OpenPictureDialog1.Filter := GraphicFilter(TGraphic);
  OpenPictureDialog1.FilterIndex := 0;
  OpenPictureDialog1.FileName := '';
  OpenPictureDialog1.DefaultExt := '.jpg';
  if OpenPictureDialog1.Execute then
  begin
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.LayersCurrent := 0;
          ImageEnView.LayerOptions := ImageEnView.LayerOptions - [loAllowMultiSelect];
          iLayer := ImageEnView.LayersAdd;
          ImageEnView.Layers[iLayer].Name := 'Image Layer';
          iRGB := ImageEnView.IEBitmap.Pixels[0, ImageEnView.IEBitmap.Height - 1];
          ImageEnView.Proc.SetTransparentColors(iRGB, iRGB, 0);
          iFileName := OpenPictureDialog1.FileName;
          if FileExists(iFileName) then
            ImageEnView.IO.LoadFromFile(iFileName);
          if ImageEnView.IO.Aborting then
          begin
            TaskDialog1.Title := 'Error Saving Image';
            TaskDialog1.Caption := 'Image Not Saved';
            TaskDialog1.Text := 'The image was not saved.';
            TaskDialog1.CommonButtons := [tcbOk];
            TaskDialog1.Flags := [];
            TaskDialog1.MainIcon := tdiError;
            TaskDialog1.FooterText := 'Developed By Adirondack Software & Graphics';
            TaskDialog1.Execute;
            exit;
          end;
          ImageEnView.Update;
          SelectLayers1.Down := True;
          ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
          ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
          ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
          ImageEnMView1.Update;
          GetLayerTextParameters;
          UpdateGUI;
          UpdateLayers;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.AddShapeLayer1Click(Sender: TObject);
var
  iLayer: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        ImageEnView.LayersCurrent := 0;
        ImageEnView.LayerOptions := ImageEnView.LayerOptions - [loAllowMultiSelect];
        iLayer := ImageEnView.LayersAdd(ielkShape);
        ImageEnView.Layers[iLayer].Name := 'Shape Layer';
        ImageEnView.Layers[iLayer].PosX := ImageEnView.Layers[iLayer - 1].PosX + 100;
        ImageEnView.Layers[iLayer].PosY := ImageEnView.Layers[iLayer - 1].PosY + 100;
        if ImageEnView.CurrentLayer is TIEShapeLayer then
          with TIEShapeLayer(ImageEnView.CurrentLayer) do
            Shape := TIEShape(Shape1.ItemIndex);
        SelectLayers1.Down := True;
        ImageEnView.MouseInteract := ImageEnView.MouseInteract + [miMoveLayers, miResizeLayers];
        FillColorBox1.Selected := clRed;
        BorderColorBox1.Selected := clBlack;
        SetLayerShapeParameters;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        GetLayerShapeParameters;
        UpdateGUI;
        UpdateLayers;
        UpdateStatusBar;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.AddLayer1Click(Sender: TObject);
var
  iRGB: TRGB;
  iLayer: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        ImageEnView.LayersCurrent := 0;
        ImageEnView.LayersDeselectAll;
        iLayer := ImageEnView.LayersAdd(ielkImage);
        ImageEnView.Layers[iLayer].Name := 'Layer ' + IntToStr(ImageEnView.LayersCount + 1);
        ImageEnView.Layers[iLayer].Selectable := True;
        ImageEnView.LayersCurrent := iLayer;
        iRGB := ImageEnView.IEBitmap.Pixels[0, ImageEnView.IEBitmap.Height - 1];
        ImageEnView.Proc.SetTransparentColors(iRGB, iRGB, 0);
        ImageEnView.Update;
        UpdateGUI;
        UpdateLayers;
        UpdateStatusBar;
        EnableControls(TabSheet10, True);
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.PencilSketch1Click(Sender: TObject);
var
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iNotification := NotificationCenter1.CreateNotification;
      try
        iNotification.Name := 'Notification';
        iNotification.Title := 'Pencil Sketch ';
        iNotification.AlertBody := 'Applying pencil sketch effect...';
        NotificationCenter1.PresentNotification(iNotification);
      finally
        iNotification.Free;
      end;
      Screen.Cursor := crHourglass;
      try
        ImageEnView.Proc.SaveUndo('Pencil Sketch ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
        Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
        Undo1.Enabled := ImageEnView.Proc.CanUndo;
        ImageEnView.Proc.PencilSketch(Grayscale1.Checked);
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        ImageEnView.Bitmap.Modified := True;
        UpdateFrame;
        UpdateStatusBar;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.PenColor1Change(Sender: TObject);
begin
  PenColor.Color := PenColor1.Selected;
  IEColorPalettePen1.SelectedColor := PenColor1.Selected;
end;

procedure TForm1.ConvertTo24Bit1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Assigned(ImageEnView.IEBitmap) then
      begin
        ImageEnView.IO.Params.BitsPerSample := 8;
        ImageEnView.IO.Params.SamplesPerPixel := 3;
        ImageEnView.LayersCurrent := 0;
        ImageEnView.RemoveAlphaChannel();
        ImageEnView.Update;
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Assign(ImageEnView.IO.Params);
        UpdateGUI;
        UpdateFrame;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.ConvertTo32Bit1Click(Sender: TObject);
{ Convert the image to RGBA32-bit }
var
  i: Integer;
  iRGB: TRGB;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Assigned(ImageEnView.IEBitmap) then
      begin
        ImageEnView.IO.Params.BitsPerSample := 8;
        ImageEnView.IO.Params.SamplesPerPixel := 4;
        ImageEnView.EnableAlphaChannel := True;
        for i := 0 to ImageEnView.LayersCount - 1 do
        begin
          ImageEnView.LayersCurrent := i;
          iRGB := ImageEnView.IEBitmap.Pixels[0, ImageEnView.IEBitmap.Height - 1];
          ImageEnView.Proc.SetTransparentColors(iRGB, iRGB, 0);
        end;
        ImageEnView.Update;
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Assign(ImageEnView.IO.Params);
        UpdateGUI;
        UpdateFrame;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.Crop1Click(Sender: TObject);
var
  iResult: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.Selected then
      begin
        TaskDialog1.Title := 'Multiple Layers';
        TaskDialog1.Caption := 'Multiple Layers';
        TaskDialog1.Text := 'The image has more than one layer.  Merge the layers before cropping?';
        TaskDialog1.CommonButtons := [tcbYes, tcbNo, tcbCancel];
        TaskDialog1.Flags := [tfUseHiconMain, tfAllowDialogCancellation];
        TaskDialog1.MainIcon := tdiNone;
        TaskDialog1.FooterText := 'Developed By Adirondack Software & Graphics';
        TaskDialog1.Execute;
        iResult := TaskDialog1.ModalResult;
        case iResult of
          mrYes:
            begin
              ImageEnView.Proc.SaveUndo('Crop ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
              ImageEnView.LayersMergeAll(True);
              ImageEnView.Proc.CropSel();
              ImageEnView.Update;
              ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
              ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
              ImageEnView.DeSelect;
              ImageEnView.DisplayGridKind := iedgNone;
              MergeLayers1.Enabled := ImageEnView.LayersCount > 1;
              SaveLayers1.Enabled := ImageEnView.LayersCount > 1;
              UseCurrentLayer1.Enabled := ImageEnView.LayersCount > 0;
              UpdateGUI;
              UpdateStatusBar;
            end;
          mrNo:
            begin
              ImageEnView.Proc.SaveUndo('Crop ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
              ImageEnView.LayersCurrent := 0;
              ImageEnView.Proc.CropSel();
              ImageEnView.Update;
              ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
              ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
              ImageEnView.DeSelect;
              ImageEnView.DisplayGridKind := iedgNone;
              MergeLayers1.Enabled := ImageEnView.LayersCount > 1;
              SaveLayers1.Enabled := ImageEnView.LayersCount > 1;
              UseCurrentLayer1.Enabled := ImageEnView.LayersCount > 0;
              UpdateGUI;
              UpdateStatusBar;
            end;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Curves1Click(Sender: TObject);
var
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iNotification := NotificationCenter1.CreateNotification;
      try
        iNotification.Name := 'Notification';
        iNotification.Title := 'Curves ';
        iNotification.AlertBody := 'Applying image curve...';
        NotificationCenter1.PresentNotification(iNotification);
      finally
        iNotification.Free;
      end;
      ImageEnView.Proc.SaveUndo('Curves ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      FormCurves := TFormCurves.Create(Self);
      try
        FormCurves.AImageIEBitmap.Assign(ImageEnView.IEBitmap);
        FormCurves.AImageIEBitmap.PixelFormat := ie24RGB;
        FormCurves.ImageEnView1.IEBitmap.Assign(FormCurves.AImageIEBitmap);
        FormCurves.MakePreviewImage;
        FormCurves.AImageLoaded := True;
        FormCurves.ImageEnView1.Enabled := FormCurves.AImageLoaded;
        FormCurves.GetHist;
        FormCurves.PaintHistogram(0);
        FormCurves.DrawCurve;
        FormCurves.ShowModal;
      finally
        FormCurves.Free;
      end;
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
      ImageEnMView1.Update;
      UpdateGUI;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.Cut1Click(Sender: TObject);
var
  iRGB: TRGB;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Cut ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      { Cut selection to clipboard }
      ImageEnView.Proc.CutToClipboard(iecpSelection);
      ImageEnView.Proc.CastColor(ImageEnView.SelX2 - ImageEnView.SelX1 - 1, ImageEnView.SelY2 - ImageEnView.SelY1 - 1,
        TColor2TRGB(clBlack), 1);
      iRGB := TColor2TRGB(clBlack);
      ImageEnView.Proc.SetTransparentColors(iRGB, iRGB, 0);
      ImageEnView.IEBitmap.Modified := ImageEnView.Proc.UndoCount > 0;
      ImageEnView.Update;
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
      ImageEnMView1.Update;
      UpdateGUI;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.YRes1Change(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.XRes1Change(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.Ellipse1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (Ellipse1.Down) or (Ellipse2.Checked) then
      begin
        { Disable gesture panning which disables drawing }
        ImageEnView.Gestures.Zoom.Enabled := True;
        ImageEnView.Gestures.Pan.Enabled := False;
        SelectNone1.Down := True;
        ImageEnView.MouseInteract := [];
      end
      else
      begin
        { Enable gesture zooming and panning }
        ImageEnView.Gestures.Zoom.Enabled := True;
        ImageEnView.Gestures.Pan.Enabled := True;
      end;
    end;
  end;
end;

procedure TForm1.EnableAlphaChannel1Click(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
    if Assigned(ImageEnView) then
      ImageEnView.EnableAlphaChannel := EnableAlphaChannel1.Checked;
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ExportFrame1Click(Sender: TObject);
var
  iFileName: string;
  iNotification: TNotification;
begin
  if SavePictureDialog1.Execute then
  begin
    Screen.Cursor := crHourglass;
    try
      iFileName := SavePictureDialog1.FileName;
      { Save selected frame }
      ImageEnMView1.MIO.SaveToFile(iFileName, True);
      if ImageEnMView1.MIO.Aborting then
      begin
        iNotification := NotificationCenter1.CreateNotification;
        try
          iNotification.Name := 'ErrorNotification';
          iNotification.Title := 'Error Saving Image';
          iNotification.AlertBody := 'There was an error saving the image.  The image can not be saved.';
          NotificationCenter1.PresentNotification(iNotification);
        finally
          iNotification.Free;
        end;
        exit;
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TForm1.FeederEnabled1Click(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.FillColorBox1Change(Sender: TObject);
begin
  SetLayerTextParameters;
  SetLayerShapeParameters;
end;

procedure TForm1.Fit1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Fit1.Down then
        ImageEnView.Fit()
      else
        ImageEnView.Zoom := 100;
    end;
  end;
end;

procedure TForm1.LoadStyles;
Var
  iFolder: string;
  FileName, StyleName: string;
begin
  iFolder := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))) + 'Styles';
  { Load all found styles }
  for FileName in TDirectory.GetFiles(iFolder, '*' + TStyleEngine.FileExtension) do
    if TStyleManager.IsValidStyle(FileName) then
      TStyleManager.LoadFromFile(FileName);
  { Get registered styles }
  Styles1.Clear();
  for StyleName in TStyleManager.StyleNames do
    Styles1.Items.Add(StyleName);
  Styles1.ItemIndex := 0;
end;

procedure TForm1.Font1Click(Sender: TObject);
var
  iFontDialog: TFontDialog;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iFontDialog := TFontDialog.Create(nil);
      With ImageEnView do
        case CurrentLayer.Kind of
          ielkText:
            begin
              iFontDialog.Font.Assign(TIETextLayer(CurrentLayer).Font);
              if iFontDialog.Execute then
                TIETextLayer(CurrentLayer).Font.Assign(iFontDialog.Font);
            end;
          ielkLine:
            begin
              iFontDialog.Font.Assign(TIELineLayer(CurrentLayer).LabelFont);
              if iFontDialog.Execute then
                TIELineLayer(CurrentLayer).LabelFont.Assign(iFontDialog.Font);
            end;
        end;
      ImageEnView.Update();
      iFontDialog.Free;
    end;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  i: Integer;
  iClipboardHasImage: Boolean;
  iFileName: string;
  iResult: Integer;
  iNotification: TNotification;
  iFrames: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      { Check to see if an image is in the clipboard }
      iClipboardHasImage := ImageEnView.Proc.IsClipboardAvailable;
      if iClipboardHasImage then
      begin
        if MessageBox(0, 'The clipboard contains an image.  Clear the clipboard?', 'The Clipboard Contains An Image',
          MB_ICONQUESTION or MB_YESNO) = mrYes then
        begin
          { Empty the clipboard }
          Winapi.Windows.OpenClipboard(Application.Handle);
          Winapi.Windows.EmptyClipboard;
          Winapi.Windows.CloseClipboard;
        end;
      end;
      if ImageEnMView1.ImageCount > 0 then
      begin
        iFileName := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName;
        iFrames := IEGetFileFramesCount(iFileName);
        { Is a single frame image loaded }
        if (not IsMultiFrameImage) or (iFrames = 1) then
        begin
          for i := 0 to PageControl1.PageCount - 1 do
          begin
            if Assigned(PageControl1.Pages[i]) then
            begin
              ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
              if Assigned(ImageEnView) then
              begin
                CanClose := not ImageEnView.IEBitmap.Modified;
                if not CanClose then
                begin
                  iResult := MessageBox(0, 'The image has been modified and has not been saved.  Save the image?',
                    'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
                  case iResult of
                    mrYes:
                      begin
                        SavePictureDialog1.FileName := '';
                        if SavePictureDialog1.Execute then
                        begin
                          iFileName := SavePictureDialog1.FileName;
                          if System.SysUtils.FileExists(iFileName) then
                          begin
                            if ImageEnView.LayersCount > 1 then
                              ImageEnView.LayersMergeAll(True);
                            ImageEnView.IO.SaveToFile(iFileName);
                            if ImageEnView.IO.Aborting then
                            begin
                              iNotification := NotificationCenter1.CreateNotification;
                              try
                                iNotification.Name := 'ErrorNotification';
                                iNotification.Title := 'Error Saving Image';
                                iNotification.AlertBody :=
                                  'There was an error saving the image.  The image was not be saved.';
                                NotificationCenter1.PresentNotification(iNotification);
                              finally
                                iNotification.Free;
                              end;
                              exit;
                            end;
                            AFilename := iFileName;
                            ImageEnView.IEBitmap.Modified := False;
                            ImageEnMView1.IEMBitmap.Modified := False;
                            CanClose := True;
                          end;
                        end
                        else
                        begin
                          CanClose := True;
                        end;
                      end;
                    mrNo:
                      CanClose := True;
                    mrCancel:
                      CanClose := False;
                  end;
                end;
              end;
            end;
          end;
        end
        else if (IsMultiFrameImage) or (iFrames > 1) then { Multiframe image loaded }
        begin
          for i := 0 to PageControl1.PageCount - 1 do
          begin
            if System.SysUtils.FileExists(iFileName) then
            begin
              ImageEnMView1.SelectedImage := i;
              if ImageEnMView1.IEMBitmap.Modified then
              begin
                iResult := MessageBox(0, 'The image has been modified and has not been saved.  Save the image?',
                  'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
                case iResult of
                  mrYes:
                    begin
                      ImageEnMView1.MIO.SaveToFile(iFileName);
                      if ImageEnMView1.MIO.Aborting then
                      begin
                        iNotification := NotificationCenter1.CreateNotification;
                        try
                          iNotification.Name := 'ErrorNotification';
                          iNotification.Title := 'Error Saving Image';
                          iNotification.AlertBody := 'There was an error saving the image.  The image was not be saved.';
                          NotificationCenter1.PresentNotification(iNotification);
                        finally
                          iNotification.Free;
                        end;
                        exit;
                      end;
                      ImageEnView.IEBitmap.Modified := False;
                      ImageEnMView1.IEMBitmap.Modified := False;
                    end;
                  mrNo:
                    Continue;
                  mrCancel:
                    exit;
                end;
              end;
            end;
          end;
        end
        else
        begin
          if ImageEnMView1.IEMBitmap.Modified then
          begin
            SavePictureDialog1.FileName := '';
            if SavePictureDialog1.Execute then
            begin
              iFileName := SavePictureDialog1.FileName;
              iResult := MessageBox(0, 'The image has been modified and has not been saved.  Save the image?', 'Save Image',
                MB_ICONQUESTION or MB_YESNOCANCEL);
              case iResult of
                mrYes:
                  begin
                    ImageEnMView1.MIO.SaveToFile(iFileName);
                    if ImageEnView.IO.Aborting then
                    begin
                      iNotification := NotificationCenter1.CreateNotification;
                      try
                        iNotification.Name := 'ErrorNotification';
                        iNotification.Title := 'Error Saving Image';
                        iNotification.AlertBody := 'There was an error saving the image.  The image was not be saved.';
                        NotificationCenter1.PresentNotification(iNotification);
                      finally
                        iNotification.Free;
                      end;
                      exit;
                    end;
                    AFilename := iFileName;
                    ImageEnView.IEBitmap.Modified := False;
                    ImageEnMView1.IEMBitmap.Modified := False;
                  end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
  iColor: TColor;
  iNumberOfCpu: Integer;
  iFrame: Integer;
  iShape: TIEShape;
begin
  AInternalChange := True;
  AIniFilename := IncludeTrailingBackslash(AppDataFolder) + 'ASG\PaintBrush\' + 'PaintBrush.ini';
  System.SysUtils.ForceDirectories(IncludeTrailingBackslash(AppDataFolder) + 'ASG\PaintBrush');
  AMostRecentFiles := TStringlist.Create;
  PageControl2.ActivePageIndex := 0;
  ReadIni(AIniFilename);
  { Uncomment to initialize WPCubedPDF plugin }
  { if TIEWPCubedPDF.Initialize then
    TIEWPCubedPDF.RegisterPlugin
    else
    MessageBox(0, 'PDF decoder DLL could not be found.', 'Error', MB_ICONERROR or MB_OK); }
  { Set the file dialogs filters }
  OpenPictureDialog1.Filter := GraphicFilter(TGraphic);
  SavePictureDialog1.Filter := GraphicFilter(TGraphic);
  ImageEnMView1.Gestures.Pan.Enabled := True;
  ImageEnMView1.Gestures.Zoom.Enabled := True;
  ImageEnMView1.SetModernStyling(False, 140, 125);
  { Remove ietxStretchSmallImages form ThumbnailOptionsEx or small thumbnails will be stretched }
  ImageEnMView1.ThumbnailOptionsEx := [ietxShowIconForUnknownFormat, ietxShowIconWhileLoading, ietxEnableInternalIcons];
  ImageEnMView1.ThumbnailClipping := 0;
  ImageEnMView1.SoftShadow.Enabled := False;
  ImageEnMView1.GridWidth := 1;
  ImageEnMView1.Proc.AutoUndo := False;
  ImageEnMView1.SelectedImageAlwaysVisible := True;
  iNumberOfCpu := IEGetCoresCount;
  ImageEnMView1.ThreadPoolSize := max(5, min(12, iNumberOfCpu * 2 - 1));
  if LoadDevicesAtStartup1.Checked then
  begin
    GetPrinterNames;
    Printers1.Items.AddStrings(APrinterNames);
    Printers1.ItemIndex := Printers1.Items.IndexOf(GetDefaultPrinterName);
    Printers1.Enabled := Printers1.Items.Count > 0;
    { Fill sources }
    ImageEnMView1.MIO.AcquireParams.FillListWithSources(Sources1.Items);
    Sources1.ItemIndex := Sources1.Items.IndexOf(AcquireSourceToStr(ImageEnMView1.MIO.AcquireParams.SelectedSource));
    Acquire1.Enabled := Sources1.Items.Count > 0;
    Colors1.Clear;
    for i := ord(Low(Acquire_PixelType)) to ord(High(Acquire_PixelType)) do
      Colors1.Items.Add(Acquire_PixelType[TIEAcquirePixelType(i)]);
    Orientation1.Clear;
    for i := ord(Low(Acquire_Orientation)) to ord(High(Acquire_Orientation)) do
      Orientation1.Items.Add(Acquire_Orientation[TIEAcquireOrientation(i)]);
    Rotation1.Clear;
    for i := ord(Low(Acquire_Rotation)) to ord(High(Acquire_Rotation)) do
      Rotation1.Items.Add(Acquire_Rotation[TIEAcquireRotation(i)]);
    UpdateControlStatus(True);
  end
  else
  begin
    Printers1.Enabled := False;
    Acquire1.Enabled := False;
  end;
  { Display a detailed hint }
  IEColorPalettePen1.HintFormat := IECP_Html_Value + #13 + IECP_Delphi_Value + #13 + 'R: ' + IECP_RGB_R_Value + ', G: ' +
    IECP_RGB_G_Value + ', B: ' + IECP_RGB_B_Value + #13 + 'C: ' + IECP_CMYK_C_Value + ', M: ' + IECP_CMYK_M_Value + ', Y: ' +
    IECP_CMYK_Y_Value + ', K: ' + IECP_CMYK_K_Value + #13 + 'H: ' + IECP_HSL_H_Value + ', S: ' + IECP_HSL_S_Value + ', L: ' +
    IECP_HSL_L_Value + #13 + 'H: ' + IECP_HSV_H_Value + ', S: ' + IECP_HSV_S_Value + ', V: ' + IECP_HSV_V_Value;
  IEColorPaletteBrush1.HintFormat := IECP_Html_Value + #13 + IECP_Delphi_Value + #13 + 'R: ' + IECP_RGB_R_Value + ', G: ' +
    IECP_RGB_G_Value + ', B: ' + IECP_RGB_B_Value + #13 + 'C: ' + IECP_CMYK_C_Value + ', M: ' + IECP_CMYK_M_Value + ', Y: ' +
    IECP_CMYK_Y_Value + ', K: ' + IECP_CMYK_K_Value + #13 + 'H: ' + IECP_HSL_H_Value + ', S: ' + IECP_HSL_S_Value + ', L: ' +
    IECP_HSL_L_Value + #13 + 'H: ' + IECP_HSV_H_Value + ', S: ' + IECP_HSV_S_Value + ', V: ' + IECP_HSV_V_Value;
  IEColorPalettePen1.Colors.Add(ColorToString(clBlack));
  IEColorPalettePen1.Colors.Add(ColorToString(clMaroon));
  IEColorPalettePen1.Colors.Add(ColorToString(clGreen));
  IEColorPalettePen1.Colors.Add(ColorToString(clOlive));
  IEColorPalettePen1.Colors.Add(ColorToString(clNavy));
  IEColorPalettePen1.Colors.Add(ColorToString(clPurple));
  IEColorPalettePen1.Colors.Add(ColorToString(clTeal));
  IEColorPalettePen1.Colors.Add(ColorToString(clSilver));
  IEColorPalettePen1.Colors.Add(ColorToString(clGray));
  IEColorPalettePen1.Colors.Add(ColorToString(clRed));
  IEColorPalettePen1.Colors.Add(ColorToString(clLime));
  IEColorPalettePen1.Colors.Add(ColorToString(clYellow));
  IEColorPalettePen1.Colors.Add(ColorToString(clBlue));
  IEColorPalettePen1.Colors.Add(ColorToString(clFuchsia));
  IEColorPalettePen1.Colors.Add(ColorToString(clAqua));
  IEColorPalettePen1.Colors.Add(ColorToString(clWhite));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clBlack));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clMaroon));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clGreen));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clOlive));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clNavy));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clPurple));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clTeal));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clSilver));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clGray));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clRed));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clLime));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clYellow));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clBlue));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clFuchsia));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clAqua));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clWhite));
  for i := 0 to 169 do
  begin
    iColor := cxColorsByName[i].Color;
    IEColorPalettePen1.Colors.Add(ColorToString(iColor));
    IEColorPaletteBrush1.Colors.Add(ColorToString(iColor));
  end;
  IEColorPalettePen1.SelectedColor := clBlack;
  IEColorPaletteBrush1.SelectedColor := clBlue;
  IEGlobalSettings().DefaultLayerText := 'Double-click to edit text';
  IEGlobalSettings().EnableTheming := True;
  for i := 0 to Screen.Fonts.Count - 1 do
    TextFont1.Items.Add(Screen.Fonts.Strings[i]);
  TextFont1.ItemIndex := TextFont1.Items.IndexOf('Arial');
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ALayerFileName := ChangeFileExt(AFilename, '.lyr');
      { Create the initial IEBtmap }
      ImageEnView.IEBitmap.IEInitialize(1024, 768, clWhite);
      ImageEnView.IO.Params.FileName := WindowsDesktopFolder + 'Untitled.png';
      ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
      ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
      ImageEnView.Layers[0].Name := 'Background Image';
      ImageEnView.IEBitmap.Modified := False;
      iFrame := ImageEnMView1.AppendImage(ImageEnView.IEBitmap);
      ImageEnMView1.UpdateImage(iFrame);
      ImageEnMView1.Update;
      if Fit1.Down then
        ImageEnView.Fit();
      UpdateFrame;
      UpdateLayers;
    end;
  end;
  LoadStyles;
  Shape1.Items.Clear;
  for iShape := Low(TIEShape) to High(TIEShape) do
    Shape1.Items.Add(ShapeToString(iShape));
  Shape1.ItemIndex := 0;
  EnableControls(TabSheet10, False);
  EnableControls(TabSheet9, False);
  UpdateGUI;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  { Post the custom message WM_AFTER_SHOW to our form }
  // PostMessage(Self.Handle, WM_AFTER_SHOW, 0, 0);
end;

procedure TForm1.WmAfterShow(var Msg: TMessage);
{ This event is executed after OnShow. }
begin
  //
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WriteIni(AIniFilename);
  AMostRecentFiles.Free;
  APrinterNames.Free;
end;

procedure TForm1.UpdateControlStatus(ASelectDevice: Boolean = False);
const
  Acquire_Apis: array [ieaTwain .. ieaNone] of string = ('Twain', 'WIA', 'DCIM', 'None');
  Device_Types: array [ieadUnknown .. ieadDrive] of string = ('Unknown', 'Scanner', 'Camera', 'Drive');
  Bool_Types: array [False .. True] of string = ('False', 'True');

  procedure _EnableControls(AControl: TWinControl; AEnable: Boolean);
  var
    i: Integer;
  begin
    AControl.Enabled := AEnable;
    for i := 0 to AControl.ControlCount - 1 do
      AControl.Controls[i].Enabled := AEnable;
  end;

var
  AHaveTrueApiSource: Boolean;
begin
  if ASelectDevice then
  begin
    AInternalChange := True;
    Sources1.ItemIndex := Sources1.Items.IndexOf(AcquireSourceToStr(ImageEnMView1.MIO.AcquireParams.SelectedSource));
    AInternalChange := False;
  end;
  AHaveTrueApiSource := ImageEnMView1.MIO.AcquireParams.SelectedSource.API in [ieaTwain, ieaWIA];
  _EnableControls(grpFrame, AHaveTrueApiSource);
  SaveParameters1.Enabled := AHaveTrueApiSource;
  if ImageEnMView1.MIO.AcquireParams.SelectedSource.API <> ieaNone then
    with ImageEnMView1.MIO do
    begin
      ResX1.Text := FloatToStr(AcquireParams.XResolution);
      ResY1.Text := FloatToStr(AcquireParams.YResolution);
      Colors1.ItemIndex := ord(AcquireParams.PixelType);
      Orientation1.ItemIndex := ord(AcquireParams.Orientation);
      Rotation1.ItemIndex := ord(AcquireParams.Rotation);
      FeederEnabled1.Checked := AcquireParams.FeederEnabled;
      AutoFeed1.Checked := AcquireParams.AutoFeed;
      DuplexEnabled1.Checked := AcquireParams.DuplexEnabled;
      Left1.Text := FloatToStr(AcquireParams.AcquireFrameLeft);
      Top1.Text := FloatToStr(AcquireParams.AcquireFrameTop);
      Right1.Text := FloatToStr(AcquireParams.AcquireFrameRight);
      Bottom1.Text := FloatToStr(AcquireParams.AcquireFrameBottom);
      FrameEnabled1.Checked := AcquireParams.AcquireFrameEnabled;
      VisibleDialog1.Checked := AcquireParams.VisibleDialog;
      DuplexEnabled1.Enabled := AcquireParams.DuplexSupported;
      VisibleDialog1.Enabled := AcquireParams.SelectedSource.API <> ieaDCIM;
      if AcquireParams.SelectedSource.API = ieaWIA then
        FrameEnabled1.Enabled := False;
    end;
end;

{ Write control values to AcquireParams }
procedure TForm1.SaveProperties;
begin
  with ImageEnMView1.MIO do
  begin
    AcquireParams.XResolution := StrToFloat(ResX1.Text);
    AcquireParams.YResolution := StrToFloat(ResY1.Text);
    AcquireParams.PixelType := TIEAcquirePixelType(Colors1.ItemIndex);
    AcquireParams.Orientation := TIEAcquireOrientation(Orientation1.ItemIndex);
    AcquireParams.Rotation := TIEAcquireRotation(Rotation1.ItemIndex);
    AcquireParams.FeederEnabled := FeederEnabled1.Checked;
    AcquireParams.AutoFeed := AutoFeed1.Checked;
    AcquireParams.DuplexEnabled := DuplexEnabled1.Checked;
    AcquireParams.AcquireFrameLeft := StrToFloat(Left1.Text);
    AcquireParams.AcquireFrameTop := StrToFloat(Top1.Text);
    AcquireParams.AcquireFrameRight := StrToFloat(Right1.Text);
    AcquireParams.AcquireFrameBottom := StrToFloat(Bottom1.Text);
    AcquireParams.AcquireFrameEnabled := FrameEnabled1.Checked;
    AcquireParams.VisibleDialog := VisibleDialog1.Checked;
  end;
end;

procedure TForm1.Width1Click(Sender: TObject; Button: TUDBtnType);
begin
  SetLayerTextParameters;
  SetLayerShapeParameters;
end;

procedure TForm1.LoadRecentFiles(const AIniFilename: string; ASection: string);
var
  i: Integer;
  iFileName: string;
  iIni: TIniFile;
  iFileCount: Integer;
  iIndent: string;
begin
  AMostRecentFiles.BeginUpdate;
  try
    AMostRecentFiles.Clear;
    iIni := TIniFile.Create(AIniFilename);
    try
      iFileCount := iIni.ReadInteger('MostRecentFileCount', 'File Count', 0);
      for i := 0 to iFileCount - 1 do
      begin
        iIndent := format('%s%d', ['', i + 1]);
        iFileName := iIni.ReadString(ASection, iIndent, '');
        if iFileName = '' then
          break
        else if AMostRecentFiles.IndexOf(iFileName) < 0 then
          AMostRecentFiles.Append(iFileName);
      end;
    finally
      iIni.Free;
    end;
  finally
    AMostRecentFiles.EndUpdate;
  end;
end;

procedure TForm1.SaveRecentFiles(const AIniFilename: string; ASection: string);
var
  i: Integer;
  iIndex: Integer;
  iIni: TIniFile;
begin
  if AMostRecentFiles.Find('-', iIndex) then
    AMostRecentFiles.Delete(iIndex);
  if AMostRecentFiles.Find('Clear Recent', iIndex) then
    AMostRecentFiles.Delete(iIndex);
  iIni := TIniFile.Create(AIniFilename);
  try
    iIni.WriteInteger('MostRecentFileCount', 'File Count', AMostRecentFiles.Count);
    if iIni.SectionExists(ASection) then
      iIni.EraseSection(ASection);
    for i := 1 to AMostRecentFiles.Count do
      iIni.WriteString(ASection, format('%s%d', ['', i]), AMostRecentFiles[i - 1]);
  finally
    iIni.Free;
  end;
end;

procedure TForm1.ReadIni(IniFilename: string);
var
  iIniFile: TIniFile;
begin
  iIniFile := TIniFile.Create(IniFilename);
  try
    LoadDevicesAtStartup1.Checked := iIniFile.ReadBool('Scanner', 'Load At Startup', False);
    LoadRecentFiles(IniFilename, 'MostRecentFiles');
  finally
    iIniFile.Free;
  end;
end;

procedure TForm1.WriteIni(IniFilename: string);
var
  iIniFile: TIniFile;
begin
  iIniFile := TIniFile.Create(IniFilename);
  try
    iIniFile.WriteBool('Scanner', 'Load At Startup', LoadDevicesAtStartup1.Checked);
    SaveRecentFiles(IniFilename, 'MostRecentFiles');
  finally
    iIniFile.Free;
  end;
end;

procedure TForm1.LoadRecentFile(Sender: TObject);
var
  i: Integer;
  ip: Integer;
  iFileName: string;
  iMenuItem: TMenuItem;
  iFrames: Integer;
  iIndex: Integer;
  iDimensions: string;
  iBitDepth: Integer;
  iColor: string;
  iNotification: TNotification;
begin
  iFileName := '';
  if Sender is TMenuItem then
  begin
    iMenuItem := TMenuItem(Sender);
    iFileName := iMenuItem.Caption;
  end;
  if FileExists(iFileName) then
  begin
    Screen.Cursor := crHourglass;
    try
      iFrames := IEGetFileFramesCount(iFileName);
      { Is a multiframe image loaded or file to be opened a multiframe image }
      if (IsMultiFrameImage) or (iFrames > 1) then
      begin
        { Clear frames }
        ImageEnMView1.Clear;
        ImageEnMView1.Update;
        { Close all pages }
        for ip := PageControl1.PageCount - 1 downto 0 do
          PageControl1.Pages[ip].Free;
      end;
      if iFrames > 1 then
      begin
        ImageEnMView1.MIO.LoadFromFile(iFileName);
        ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
      end
      else
      begin
        ImageEnMView1.AppendImage(iFileName);
        ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
      end;
      if ImageEnMView1.MIO.Aborting then
      begin
        { TaskDialog1.Title := 'Error Loading Image';
          TaskDialog1.Caption := 'Image Not Loaded';
          TaskDialog1.Text := 'An error ocurred.  The image was not loaded.';
          TaskDialog1.CommonButtons := [tcbOk];
          TaskDialog1.Flags := [];
          TaskDialog1.MainIcon := tdiError;
          TaskDialog1.FooterText := 'Developed By Adirondack Software & Graphics';
          TaskDialog1.Execute; }
        iNotification := NotificationCenter1.CreateNotification;
        try
          iNotification.Name := 'ErrorNotification';
          iNotification.Title := 'Image Not Loaded ';
          iNotification.AlertBody := 'An error ocurred.  The image was not loaded...';
          NotificationCenter1.PresentNotification(iNotification);
        finally
          iNotification.Free;
        end;
        ImageEnMView1.DeleteImage(ImageEnMView1.SelectedImage);
        exit;
      end;
      AFilename := iFileName;
      if (iFrames = 1) and (ImageEnMView1.SelectedImage <> -1) then
      begin
        AddTabsheet;
        if Assigned(PageControl1.ActivePage) then
        begin
          ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
          if Assigned(ImageEnView) then
          begin
            ImageEnMView1.CopyToIEBitmap(ImageEnMView1.SelectedImage, ImageEnView.IEBitmap);
            ImageEnView.IO.Params.Assign(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]);
            iDimensions := IntegerToString(ImageEnMView1.IEBitmap.Width) + ' x ' +
              IntegerToString(ImageEnMView1.IEBitmap.Height);
            iBitDepth := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel * ImageEnMView1.MIO.Params
              [ImageEnMView1.SelectedImage].BitsPerSample;
            if iBitDepth = 32 then
              iColor := 'RGBA 32-Bit'
            else
              iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
            ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions + ' ' + iColor;
            ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] := ExtractFileName(iFileName);
            iBitDepth := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel * ImageEnMView1.MIO.Params
              [ImageEnMView1.SelectedImage].BitsPerSample;
            if iBitDepth = 32 then
            begin
              iColor := 'RGBA 32-Bit';
              ImageEnView.BackgroundStyle := iebsChessboard;
            end
            else
            begin
              iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
              ImageEnView.BackgroundStyle := iebsSolid;
            end;
            ImageEnView.Update;
            ImageEnView.IEBitmap.Modified := False;
            PageControl1.Pages[ImageEnMView1.SelectedImage].Caption := iFileName;
            ImageEnView.Fit;
          end;
        end;
      end
      else
      begin
        for i := 0 to iFrames - 1 do
        begin
          AddTabsheet;
          ImageEnView.IO.Params.Assign(ImageEnMView1.MIO.Params[i]);
          iDimensions := IntegerToString(ImageEnMView1.MIO.Params[i].Width) + ' x ' +
            IntegerToString(ImageEnMView1.MIO.Params[i].Height);
          iBitDepth := ImageEnMView1.MIO.Params[i].SamplesPerPixel * ImageEnMView1.MIO.Params[i].BitsPerSample;
          if iBitDepth = 32 then
          begin
            iColor := 'RGBA 32-Bit';
            ImageEnView.BackgroundStyle := iebsChessboard;
          end
          else
          begin
            iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
            ImageEnView.BackgroundStyle := iebsSolid;
          end;
          ImageEnMView1.ImageTopText[i] := iDimensions + ' ' + iColor;
          if iFrames > 1 then
          begin
            ImageEnMView1.ImageBottomText[i] := 'Frame ' + IntToStr(i + 1);
            ImageEnMView1.CopyToIEBitmap(i, ImageEnView.IEBitmap);
            ImageEnView.IEBitmap.Modified := False;
            ImageEnView.Update;
            PageControl1.Pages[i].Caption := 'Frame ' + IntToStr(i + 1);
          end
          else
          begin
            ImageEnMView1.ImageBottomText[i] := ExtractFileName(iFileName);
            ImageEnMView1.CopyToIEBitmap(i, ImageEnView.IEBitmap);
            ImageEnView.Update;
            ImageEnView.IEBitmap.Modified := False;
            PageControl1.Pages[i].Caption := iFileName;
          end;
          ImageEnView.Fit;
        end;
      end;
      if iFrames = 1 then
      begin
        ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
        PageControl1.ActivePageIndex := PageControl1.PageCount - 1;
        ImageEnView.Fit;
      end
      else
      begin
        ImageEnMView1.SelectedImage := 0;
        PageControl1.ActivePageIndex := 0;
        ImageEnView.Fit;
      end;
      UpdateGUI;
      UpdateLayers;
      UpdateStatusBar;
    finally
      Screen.Cursor := crDefault;
    end;
  end
  else
  begin
    TaskDialog1.Title := 'Image Does not Exist';
    TaskDialog1.Caption := 'Image Not Loaded';
    TaskDialog1.Text := 'The file ' + ExtractFileName(iFileName) + ' does not exist.  Remove the file from the list?';
    TaskDialog1.CommonButtons := [tcbYes, tcbNo];
    TaskDialog1.Flags := [tfUseHiconMain];
    TaskDialog1.FooterText := 'Developed By Adirondack Software & Graphics';
    if TaskDialog1.Execute then
      if TaskDialog1.ModalResult = mrYes then
      begin
        iIndex := TMenuItem(Sender).MenuIndex;
        AMostRecentFiles.Delete(iIndex);
        exit;
      end;
  end;
end;

procedure TForm1.ClearRecentFiles(Sender: TObject);
begin
  AMostRecentFiles.Clear;
end;

procedure TForm1.IEColorPaletteBrush1GetHintText(AColor: TColor; Index: Integer; var HintStr: string);
var
  iR: Byte;
  iG: Byte;
  iB: Byte;
  iHSLH: Byte;
  iHSLS: Byte;
  iHSLL: Byte;
  iHSVH, iHSVS, iHSVV: Integer;
  iName: string;
begin
  AColorToRGB(AColor, iR, iG, iB);
  ColorToHSL(AColor, iHSLH, iHSLS, iHSLL);
  ColorToHSV(AColor, iHSVH, iHSVS, iHSVV);
  iName := cxColorsByName[Index].Name;
  if cxNameByColor(AColor, iName) then
    HintStr := 'Color: ' + ColorToString(AColor) + #13 + 'Name: ' + ColorToPrettyName(AColor) + #13 + 'Dx Name: ' + iName +
      #13 + 'Hex: ' + ColorToHex(AColor) + #13 + 'RGB: (R) ' + IntToStr(iR) + ' (G) ' + IntToStr(iG) + ' (B) ' + IntToStr(iB)
      + #13 + 'HSL: (H) ' + IntToStr(iHSLH) + ' (S) ' + IntToStr(iHSLS) + ' (L) ' + IntToStr(iHSLL) + #13 + 'HSV: (H) ' +
      IntToStr(iHSVH) + ' (S) ' + IntToStr(iHSVS) + ' (V) ' + IntToStr(iHSVV)
  else
    HintStr := 'Color: ' + ColorToString(AColor) + #13 + 'Name: ' + ColorToPrettyName(AColor) + #13 + 'Hex: ' +
      ColorToHex(AColor) + #13 + 'RGB: (R) ' + IntToStr(iR) + ' (G) ' + IntToStr(iG) + ' (B) ' + IntToStr(iB) + #13 +
      'HSL: (H) ' + IntToStr(iHSLH) + ' (S) ' + IntToStr(iHSLS) + ' (L) ' + IntToStr(iHSLL) + #13 + 'HSV: (H) ' +
      IntToStr(iHSVH) + ' (S) ' + IntToStr(iHSVS) + ' (V) ' + IntToStr(iHSVV);
end;

procedure TForm1.IEColorPaletteBrush1SelectedColorChange(Sender: TObject);
begin
  BrushColor1.Selected := IEColorPaletteBrush1.SelectedColor;
  BrushColor.Color := BrushColor1.Selected;
end;

procedure TForm1.IEColorPalettePen1GetHintText(AColor: TColor; Index: Integer; var HintStr: string);
var
  iR: Byte;
  iG: Byte;
  iB: Byte;
  iHSLH: Byte;
  iHSLS: Byte;
  iHSLL: Byte;
  iHSVH, iHSVS, iHSVV: Integer;
  iName: string;
begin
  AColorToRGB(AColor, iR, iG, iB);
  ColorToHSL(AColor, iHSLH, iHSLS, iHSLL);
  ColorToHSV(AColor, iHSVH, iHSVS, iHSVV);
  iName := cxColorsByName[Index].Name;
  if cxNameByColor(AColor, iName) then
    HintStr := 'Color: ' + ColorToString(AColor) + #13 + 'Name: ' + ColorToPrettyName(AColor) + #13 + 'Dx Name: ' + iName +
      #13 + 'Hex: ' + ColorToHex(AColor) + #13 + 'RGB: (R) ' + IntToStr(iR) + ' (G) ' + IntToStr(iG) + ' (B) ' + IntToStr(iB)
      + #13 + 'HSL: (H) ' + IntToStr(iHSLH) + ' (S) ' + IntToStr(iHSLS) + ' (L) ' + IntToStr(iHSLL) + #13 + 'HSV: (H) ' +
      IntToStr(iHSVH) + ' (S) ' + IntToStr(iHSVS) + ' (V) ' + IntToStr(iHSVV)
  else
    HintStr := 'Color: ' + ColorToString(AColor) + #13 + 'Name: ' + ColorToPrettyName(AColor) + #13 + 'Hex: ' +
      ColorToHex(AColor) + #13 + 'RGB: (R) ' + IntToStr(iR) + ' (G) ' + IntToStr(iG) + ' (B) ' + IntToStr(iB) + #13 +
      'HSL: (H) ' + IntToStr(iHSLH) + ' (S) ' + IntToStr(iHSLS) + ' (L) ' + IntToStr(iHSLL) + #13 + 'HSV: (H) ' +
      IntToStr(iHSVH) + ' (S) ' + IntToStr(iHSVS) + ' (V) ' + IntToStr(iHSVV);
end;

procedure TForm1.IEColorPalettePen1SelectedColorChange(Sender: TObject);
begin
  PenColor1.Selected := IEColorPalettePen1.SelectedColor;
  PenColor.Color := PenColor1.Selected;
end;

procedure TForm1.ImageEnMView1ImageSelect(Sender: TObject; idx: Integer);
begin
  if Assigned(PageControl1.ActivePage) and (idx <> -1) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      PageControl1.ActivePageIndex := idx;
      AFilename := ImageEnView.IO.Params.FileName;
      UpdateGUI;
      UpdateLayers;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.PickAlpha(X: Integer; Y: Integer);
var
  iAlpha: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iAlpha := ImageEnView.Layers[ImageEnView.LayersCurrent].Bitmap.Alpha[X, Y];
      if iAlpha = 0 then
        iAlpha := ImageEnView.Layers[0].Bitmap.Alpha[X, Y]
      else
        iAlpha := ImageEnView.IEBitmap.Alpha[X, Y];
      PenOpacity1.Text := IntToStr(IEAlphaToOpacity(iAlpha));
      ImageEnView.Cursor := crDefault;
    end;
  end;
end;

procedure TForm1.PickColor(X: Integer; Y: Integer);
var
  iColor: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Cursor := crIEEyeDropper;
      iColor := ImageEnView.IEBitmap.Canvas.Pixels[X, Y];
      PenColor1.Selected := iColor;
      PenColor1.Items.Add(ColorToString(iColor));
      IEColorPalettePen1.AddColor(iColor);
      IEColorPalettePen1.SelectedColor := iColor;
      ColorUnderCursor1.Brush.Color := IEColorPalettePen1.SelectedColor;
      PickColor1.Down := False;
      ImageEnView.Cursor := crIECross;
    end;
  end;
end;

{ procedure TForm1.ImageEnViewDrawLayer(Sender: TObject; dest: TIEBitmap; LayerIndex: Integer);
  begin
  end;

  procedure TForm1.ImageEnViewLayerSelectionChange(Sender: TObject);
  begin
  end; }

procedure TForm1.ImageEnViewDrawBackBuffer(Sender: TObject);
var
  x1, y1, x2, y2: Integer;
  iz: Double;
  iBX: Integer;
  iBY: Integer;
  iPenWidth: Integer;
  iisImageLayer: Boolean;
begin
  iisImageLayer := IsImageLayer(ImageEnView);
  if (iisImageLayer) and (PaintBrush1.Down) then
  begin
    iBX := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvXScr2Bmp(ABX);
    iBY := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvYScr2Bmp(ABY);
    if (iBX >= 0) and (iBX <= ImageEnView.IEBitmap.Width - 1) and (iBY >= 0) and (iBY <= ImageEnView.IEBitmap.Height - 1) and
      (PaintBrush1.Down) then
    begin
      iPenWidth := StrToIntDef(PenSize1.Text, 20);
      ImageEnView.BackBuffer.Canvas.Pen.Mode := pmNotXor;
      ImageEnView.BackBuffer.Canvas.Pen.Color := clBlack;
      Brush.Style := bsClear;
      iz := ImageEnView.Zoom / 100;
      x1 := Round(ABX - iPenWidth / 2 * iz);
      y1 := Round(ABY - iPenWidth / 2 * iz);
      x2 := Round(ABX + iPenWidth / 2 * iz);
      y2 := Round(ABY + iPenWidth / 2 * iz);
      if iPenWidth = 1 then
        ImageEnView.BackBuffer.Canvas.Rectangle(x1, y1, x2, y2)
      else
        ImageEnView.BackBuffer.Canvas.Ellipse(x1, y1, x2, y2);
    end;
  end;
end;

procedure TForm1.ImageEnViewImageChange(Sender: TObject);
begin
  UpdateStatusBar;
end;

procedure TForm1.ImageEnViewViewChange(Sender: TObject; Change: Integer);
begin
  TrackBarZoom1.Position := Round(ImageEnView.Zoom);
  UpdateStatusBar;
end;

procedure TForm1.ImageEnViewDrawLayerBox(Sender: TObject; ABitmap: TBitmap; layer: Integer);
begin
  // Note: If OnDrawLayerBox is used, then the internal drawing of the layer box (dashed line) is not performed
  // Draw green line around layer
  with ABitmap.Canvas do
  begin
    Pen.Style := psSolid;
    Pen.Width := 1;
    Pen.Mode := pmCopy;
    Pen.Color := clGreen;
    Brush.Style := bsClear;
    with ImageEnView.Layers[layer].ClientAreaBox do
      Rectangle(Left - 1, Top - 1, Right + 1, Bottom + 1);
  end;
end;

procedure TForm1.ImageEnViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_DELETE:
      begin
        ImageEnView.LayersRemove(ImageEnView.LayersCurrent);
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        ImageEnView.Proc.ClearAllUndo;
        UpdateGUI;
        EnableControls(TabSheet9, False);
        EnableControls(TabSheet10, False);
        UpdateLayers;
        UpdateStatusBar;
      end;
  end;
end;

procedure TForm1.ImageEnViewNewLayer(Sender: TObject; LayerIdx: Integer; LayerKind: TIELayerKind);
begin
  if LayerKind = ielkImage then
    EnableControls(TabSheet10, True);
  if LayerKind = ielkText then
  begin
    EnableControls(TabSheet9, True);
    SetLayerTextParameters;
  end;
  if LayerKind = ielkShape then
  begin
    EnableControls(TabSheet10, True);
    SetLayerShapeParameters;
  end;
end;

procedure TForm1.ImageEnViewLayerNotify(Sender: TObject; layer: Integer; Event: TIELayerEvent);
var
  iListItem: TListItem;
begin
  if (Event = ielSelected) then
  begin
    if Layers1.ItemIndex <> layer then
      Layers1.ItemIndex := layer;
    iListItem := Layers1.Items.Item[layer];
    if Assigned(iListItem) then
    begin
      iListItem.SubItems[0] := GetLayerKindStr(ImageEnView);
      iListItem.SubItems[1] := ImageEnView.CurrentLayer.Name;
      iListItem.SubItems[2] := IntegerToString(ImageEnView.CurrentLayer.PosX);
      iListItem.SubItems[3] := IntegerToString(ImageEnView.CurrentLayer.PosY);
      iListItem.SubItems[4] := IntegerToString(ImageEnView.CurrentLayer.Width);
      iListItem.SubItems[5] := IntegerToString(ImageEnView.CurrentLayer.Height);
    end;
    if IsImageLayer(ImageEnView) then
      EnableControls(TabSheet10, True)
    else if IsTextLayer(ImageEnView) then
    begin
      EnableControls(TabSheet9, False);
      GetLayerTextParameters;
    end
    else if IsShapeLayer(ImageEnView) then
    begin
      EnableControls(TabSheet10, True);
      GetLayerShapeParameters;
      if ImageEnView.Layers[layer].Width > ImageEnView.IEBitmap.Width then
        ImageEnView.Layers[layer].Width := ImageEnView.IEBitmap.Width;
    end
    else
    begin
      EnableControls(TabSheet9, False);
      EnableControls(TabSheet10, False);
    end;
    ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
    ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
    ImageEnMView1.Update;
    UpdateGUI;
    UpdateStatusBar;
  end
  else if Event = ielBeginResizing then
  begin
    AutoSize1.Checked := False;
    UpdateGUI;
    UpdateStatusBar;
  end
  else if (Event = ielMoving) or (Event = ielResizing) then
  begin
    if IsTextLayer(ImageEnView) then
      if ImageEnView.Layers[layer].Width > ImageEnView.IEBitmap.Width then
        ImageEnView.Layers[layer].Width := ImageEnView.IEBitmap.Width;
    ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
    ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
    ImageEnMView1.Update;
  end
  else if Event = ielRotated then
  begin
    ImageEnView.LayersFixRotations(layer);
    ImageEnMView1.IEMBitmap.Modified := True;
    if Assigned(ImageEnMView1.IEBitmap) then
    begin
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnView.Update;
      ImageEnMView1.Update;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.ImageEnViewMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  iX: Integer;
  iY: Integer;
  iPenWidth: Integer;
  iPenColor: TColor;
  iTransparency: Integer;
  iisImageLayer: Boolean;
  iisTextLayer: Boolean;
  iPoint: TPoint;
begin
  iX := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvXScr2Bmp(X);
  iY := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvYScr2Bmp(Y);
  iisImageLayer := IsImageLayer(ImageEnView);
  if (iisImageLayer) and (Button = mbRight) then
  begin
    iPoint := mouse.CursorPos;
    PopupMenuImageEnView1.Popup(iPoint.X, iPoint.Y);
  end;
  iisTextLayer := IsTextLayer(ImageEnView);
  if (iisTextLayer) and (Button = mbRight) then
  begin
    iPoint := mouse.CursorPos;
    PopupMenuLayers1.Popup(iPoint.X, iPoint.Y);
  end;
  if (iisImageLayer) and (iX >= 0) and (iX <= ImageEnView.IEBitmap.Width - 1) and (iY >= 0) and
    (iY <= ImageEnView.IEBitmap.Height - 1) then
  begin
    AStartX := iX;
    AStartY := iY;
    iPenWidth := StrToIntDef(PenSize1.Text, 20);
    iPenColor := PenColor.Color;
    if (PaintBrush1.Down) and (iPenWidth = 1) and (ImageEnView.MouseCapture) then
    begin
      { Paint point or 1 pixel }
      iTransparency := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
      ImageEnView.Proc.SaveUndo('Paint ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      ImageEnView.IEBitmap.Canvas.Pixels[iX, iY] := iPenColor;
      ImageEnView.IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or (iTransparency shl 8) or
        (iTransparency shl 16);
      ImageEnView.IEBitmap.AlphaChannel.Canvas.Brush.Color := $02000000 or (iTransparency) or (iTransparency shl 8) or
        (iTransparency shl 16);
      ImageEnView.IEBitmap.AlphaChannel.Canvas.Pixels[iX, iY] := iPenColor;
      ImageEnView.IEBitmap.Alpha[iX, iY] := iTransparency;
      ImageEnView.IEBitmap.Canvas.Pen.Color := iPenColor;
      ImageEnView.IEBitmap.Canvas.Pen.Width := iPenWidth;
      ImageEnView.IEBitmap.Canvas.Pixels[iX, iY] := iPenColor;
      ImageEnView.IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or (iTransparency shl 8) or
        (iTransparency shl 16);
      ImageEnView.IEBitmap.AlphaChannel.Canvas.Pen.Width := 1;
      ImageEnView.IEBitmap.AlphaChannel.Canvas.Pixels[iX, iY] := iPenColor;
      ImageEnView.IEBitmap.Alpha[iX, iY] := iTransparency;
      ImageEnView.Update;
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
      ImageEnMView1.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
      UpdateGUI;
    end
    else if (PaintBrush1.Down) and (iPenWidth > 1) and (ImageEnView.MouseCapture) then
    begin
      { Paint Brush }
      ImageEnView.Proc.SaveUndo('Paint ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      iX := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvXScr2Bmp(X);
      iY := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvYScr2Bmp(Y);
      PaintBrush(iX, iY);
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
      ImageEnMView1.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
      ALastX := iX;
      ALastY := iY;
    end
    else if (Line1.Down) and (ImageEnView.MouseCapture) then
    begin
      ImageEnView.Proc.SaveUndo('Line ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
    end
    else if (Rectangle1.Down) and (ImageEnView.MouseCapture) then
    begin
      ImageEnView.Proc.SaveUndo('Rectangle ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
    end
    else if (RoundRectangle1.Down) and (ImageEnView.MouseCapture) then
    begin
      ImageEnView.Proc.SaveUndo('Round Rectangle ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
    end
    else if (Ellipse1.Down) and (ImageEnView.MouseCapture) then
    begin
      ImageEnView.Proc.SaveUndo('Ellipse ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
    end
    else if CastAlpha1.Down then
    begin
      ImageEnView.Proc.SaveUndo('Cast alpha ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      ImageEnView.Proc.CastAlpha(iX, iY, IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100)),
        StrToIntDef(FillTolerance1.Text, 15));
      ImageEnView.Update;
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
      UpdateGUI;
    end
    else if CastColor1.Down then
    begin
      ImageEnView.Proc.SaveUndo('Cast color ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      ImageEnView.Proc.CastColor(iX, iY, TColor2TRGB(PenColor1.Color), StrToIntDef(FillTolerance1.Text, 15));
      ImageEnView.Update;
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
      UpdateGUI;
    end
    else if Cast1.Down then
    begin
      ImageEnView.Proc.SaveUndo('Cast color and alpha ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      ImageEnView.Proc.CastAlpha(iX, iY, IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100)),
        StrToIntDef(FillTolerance1.Text, 15));
      ImageEnView.Proc.CastColor(iX, iY, TColor2TRGB(PenColor1.Color), StrToIntDef(FillTolerance1.Text, 15));
      ImageEnView.Update;
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.IEMBitmap.Modified := True;
      UpdateGUI;
    end
    else if (Pick1.Down) and (ImageEnView.MouseCapture) then
    begin
      PickColor(iX, iY);
      PickAlpha(iX, iY);
      Pick1.Down := False;
    end
    else if (PickColor1.Down) and (ImageEnView.MouseCapture) then
    begin
      PickColor(iX, iY);
      PickColor1.Down := False;
    end
    else if (PickAlpha1.Down) and (ImageEnView.MouseCapture) then
    begin
      PickAlpha(iX, iY);
      PickAlpha1.Down := False;
    end;
    UpdateGUI;
    UpdateStatusBar;
  end;
end;

procedure TForm1.ImageEnViewMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  iX: Integer;
  iY: Integer;
  iAlpha: Integer;
  iOpacity: Integer;
  iRGB: TRGB;
  iRGBString: string;
  iColor: TColor;
  iPenWidth: Integer;
  iPenColor: TColor;
  iTransparency: Integer;
  iisImageLayer: Boolean;
  iBitDepth: Integer;
begin
  { Variables for Backbuffer drawing }
  ABX := X;
  ABY := Y;
  { Display X, Y and Opacity }
  iX := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvXScr2Bmp(X);
  iY := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvYScr2Bmp(Y);
  iisImageLayer := IsImageLayer(ImageEnView);
  if (iisImageLayer) and (iX >= 0) and (iX <= ImageEnView.IEBitmap.Width - 1) and (iY >= 0) and
    (iY <= ImageEnView.IEBitmap.Height - 1) then
  begin
    { Display X, Y position }
    LabelX1.Caption := 'Column: ' + IntegerToString(iX + 1);
    LabelY1.Caption := 'Row: ' + IntegerToString(iY + 1);
    if (ImageEnView.Selected) and (ImageEnView.IsPointInsideSelection(X, Y)) then
    begin
      StatusBar1.Panels[8].Width := 125;
      StatusBar1.Panels[9].Width := 125;
      StatusBar1.Panels[8].Text := 'Selected Width: ' + IntegerToString(ImageEnView.SelectedRect.Width);
      StatusBar1.Panels[9].Text := 'Selected Height: ' + IntegerToString(ImageEnView.SelectedRect.Height);
    end
    else
    begin
      StatusBar1.Panels[8].Width := 75;
      StatusBar1.Panels[9].Width := 75;
      StatusBar1.Panels[8].Text := 'X: ' + IntegerToString(iX);
      StatusBar1.Panels[9].Text := 'Y: ' + IntegerToString(iY);
    end;
    StatusBar1.Update;
    { Get color and alpha }
    if not UseCurrentLayer1.Checked then
      iAlpha := ImageEnView.Layers[0].Bitmap.Alpha[iX, iY]
    else
      iAlpha := ImageEnView.Layers[ImageEnView.LayersCurrent].Bitmap.Alpha[iX, iY];
    if not UseCurrentLayer1.Checked then
      ColorUnderCursor1.Brush.Color := TRGB2TColor(ImageEnView.Layers[0].Bitmap.Pixels[iX, iY])
    else
      ColorUnderCursor1.Brush.Color := TRGB2TColor(ImageEnView.Layers[ImageEnView.LayersCurrent].Bitmap.Pixels[iX, iY]);
    AlphaUnderCursor1.Caption := 'Alpha: ' + IntToStr(iAlpha);
    OpacityUnderCursor1.Caption := 'Opacity: ' + IntToStr(IEAlphaToOpacity(iAlpha)) + '%';

    { Display RGB }
    if UseCurrentLayer1.Checked then
      iRGB := ImageEnView.CurrentLayer.Bitmap.Pixels[iX, iY]
    else
      iRGB := ImageEnView.Layers[0].Bitmap.Pixels[iX, iY];
    iColor := TRGB2TColor(iRGB);
    iRGBString := 'RGB: ' + IntToStr(iRGB.r) + '.' + IntToStr(iRGB.g) + '.' + IntToStr(iRGB.b);

    LabelRGB1.Caption := iRGBString;
    LabelRGB1.Update;
    { Display Color }
    LabelColor1.Caption := 'Color: ' + ColorToPrettyName(iColor);
    LabelColor1.Update;

    iBitDepth := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel;
    if (iBitDepth <> 32) and (iAlpha = 0) then
      iAlpha := 255;
    { Dither the color under the cursor to simulate the true color with alpha channel }
    ColorUnderCursor1.Brush.Color := DitherColor(iColor, iAlpha);
    iOpacity := IEAlphaToOpacity(iAlpha);
    { Display Alpha and Opacity }
    AlphaUnderCursor1.Caption := 'Alpha: ' + IntToStr(iAlpha);
    OpacityUnderCursor1.Caption := 'Opacity: ' + IntToStr(iOpacity) + '%';
    StatusBar1.Panels[10].Text := 'Opacity: ' + IntToStr(IEAlphaToOpacity(iAlpha)) + '%';
    UpdateGUI;
    UpdateStatusBar;
    { Refresh the backbuffer - this will execute the onbackbuffer event just by moving the mouse even if not painting }
    ImageEnView.Update;
  end;
  if (PaintBrush1.Down) and (ImageEnView.MouseCapture) then
  begin
    iPenWidth := StrToIntDef(PenSize1.Text, 20);
    iPenColor := PenColor.Color;
    iTransparency := IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100));
    ImageEnView.IEBitmap.Canvas.Pen.Width := iPenWidth;
    ImageEnView.IEBitmap.Canvas.Pen.Color := iPenColor;
    ImageEnView.IEBitmap.IECanvas.Brush.BackColor := iPenColor;
    ImageEnView.IEBitmap.IECanvas.Brush.BackTransparency := iTransparency;
    ImageEnView.IEBitmap.Canvas.MoveTo(iX, iY);
    ImageEnView.IEBitmap.Canvas.LineTo(ALastX, ALastY);
    ImageEnView.IEBitmap.AlphaChannel.Canvas.Brush.Color := iPenColor or (iTransparency) or (iTransparency shl 8) or
      (iTransparency shl 16);
    ImageEnView.IEBitmap.AlphaChannel.CanvasCurrentAlpha := iTransparency;
    ImageEnView.IEBitmap.AlphaChannel.Canvas.Pen.Width := iPenWidth;
    ImageEnView.IEBitmap.AlphaChannel.IECanvas.Brush.BackTransparency := iTransparency;
    ImageEnView.IEBitmap.AlphaChannel.Canvas.MoveTo(iX, iY);
    ImageEnView.IEBitmap.AlphaChannel.Canvas.LineTo(ALastX, ALastY);
    ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
    ImageEnView.Update;
    ImageEnView.IEBitmap.Modified := True;
    ImageEnMView1.IEMBitmap.Modified := True;
    UpdateGUI;
    UpdateStatusBar;
    { Refresh the backbuffer - this will execute the onbackbuffer event just by moving the mouse even if not painting }
    ImageEnView.Update;
  end
  else if (Line1.Down) and (ImageEnView.MouseCapture) then
  begin
    { Draw a Line }
    DrawLine;
  end
  else if (Rectangle1.Down) and (not DrawFilled1.Checked) and (ImageEnView.MouseCapture) then
  begin
    { Draw a Rectangle }
    DrawRectangle;
  end
  else if (Rectangle1.Down) and (DrawFilled1.Checked) and (ImageEnView.MouseCapture) then
  begin
    { Draw a Filled Rectangle }
    DrawFilledRectangle;
  end
  else if (RoundRectangle1.Down) and (not DrawFilled1.Checked) and (ImageEnView.MouseCapture) then
  begin
    { Draw a Round Rectangle }
    DrawRoundRectangle;
  end
  else if (RoundRectangle1.Down) and (DrawFilled1.Checked) and (ImageEnView.MouseCapture) then
  begin
    { Draw a Filled Round Rectangle }
    DrawFilledRoundRectangle;
  end
  else if (Ellipse1.Down) and (not DrawFilled1.Checked) and (ImageEnView.MouseCapture) then
  begin
    { Draw a Ellipse }
    DrawEllipse;
  end
  else if (Ellipse1.Down) and (DrawFilled1.Checked) and (ImageEnView.MouseCapture) then
  begin
    { Draw a Filled Ellipse }
    DrawFilledEllipse;
  end;
  ALastX := iX;
  ALastY := iY;
end;

procedure TForm1.ImageEnViewMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  iX: Integer;
  iY: Integer;
  iisImageLayer: Boolean;
begin
  iisImageLayer := IsImageLayer(ImageEnView);
  if iisImageLayer then
  begin
    iX := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvXScr2Bmp(X);
    iY := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvYScr2Bmp(Y);
    if (Rectangle1.Down) or (RoundRectangle1.Down) or (Ellipse1.Down) then
      ImageEnView.DeSelect;
    ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
    ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
    ImageEnMView1.Update;
    ALastX := iX;
    ALastY := iY;
    UpdateGUI;
    UpdateStatusBar;
  end;
end;

procedure TForm1.ImageEnViewSelectionChange(Sender: TObject);
begin
  UpdateGUI;
end;

procedure TForm1.ImageEnViewSelectionChanging(Sender: TObject);
begin
  UpdateGUI;
end;

procedure TForm1.ImageEnViewSpecialKey(Sender: TObject; CharCode: Word; Shift: TShiftState; var Handled: Boolean);
{ Change the layer position with the arrow keys }
begin
  if ImageEnView.LayersCurrent = 0 then
    exit;
  case CharCode of
    { Adjust the layer position by one }
    VK_LEFT:
      begin
        ImageEnView.CurrentLayer.PosX := ImageEnView.CurrentLayer.PosX - 1;
        ImageEnView.Update;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        Handled := True;
      end;
    VK_RIGHT:
      begin
        ImageEnView.CurrentLayer.PosX := ImageEnView.CurrentLayer.PosX + 1;
        ImageEnView.Update;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        Handled := True;
      end;
    VK_UP:
      begin
        ImageEnView.CurrentLayer.PosY := ImageEnView.CurrentLayer.PosY - 1;
        ImageEnView.Update;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        Handled := True;
      end;
    VK_DOWN:
      begin
        ImageEnView.CurrentLayer.PosY := ImageEnView.CurrentLayer.PosY + 1;
        ImageEnView.Update;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        Handled := True;
      end;
  end;
  { Adjust the layer position by 10 }
  if (ssShift in Shift) then
  begin
    case CharCode of
      VK_LEFT:
        begin
          ImageEnView.CurrentLayer.PosX := ImageEnView.CurrentLayer.PosX - 10;
          ImageEnView.Update;
          ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
          ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
          ImageEnMView1.Update;
          Handled := True;
        end;
      VK_RIGHT:
        begin
          ImageEnView.CurrentLayer.PosX := ImageEnView.CurrentLayer.PosX + 10;
          ImageEnView.Update;
          ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
          ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
          ImageEnMView1.Update;
          Handled := True;
        end;
      VK_UP:
        begin
          ImageEnView.CurrentLayer.PosY := ImageEnView.CurrentLayer.PosY - 10;
          ImageEnView.Update;
          ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
          ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
          ImageEnMView1.Update;
          Handled := True;
        end;
      VK_DOWN:
        begin
          ImageEnView.CurrentLayer.PosY := ImageEnView.CurrentLayer.PosY + 10;
          ImageEnView.Update;
          ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
          ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
          ImageEnMView1.Update;
          Handled := True;
        end;
    end;
  end;
  { Adjust the layer height and width }
  if (ssCtrl in Shift) then
  begin
    case CharCode of
      VK_LEFT:
        begin
          ImageEnView.CurrentLayer.Width := ImageEnView.CurrentLayer.Width - 10;
          ImageEnView.Update;
          ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
          ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
          ImageEnMView1.Update;
          Handled := True;
        end;
      VK_RIGHT:
        begin
          ImageEnView.CurrentLayer.Width := ImageEnView.CurrentLayer.Width + 10;
          ImageEnView.Update;
          ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
          ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
          ImageEnMView1.Update;
          Handled := True;
        end;
      VK_UP:
        begin
          ImageEnView.CurrentLayer.Height := ImageEnView.CurrentLayer.Height - 10;
          ImageEnView.Update;
          ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
          ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
          ImageEnMView1.Update;
          Handled := True;
        end;
      VK_DOWN:
        begin
          ImageEnView.CurrentLayer.Height := ImageEnView.CurrentLayer.Height + 10;
          ImageEnView.Update;
          ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
          ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
          ImageEnMView1.Update;
          Handled := True;
        end;
    end;
  end;
end;

procedure TForm1.IncreaseBrightness1Click(Sender: TObject);
var
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        iNotification := NotificationCenter1.CreateNotification;
        try
          iNotification.Name := 'Notification';
          iNotification.Title := 'Brightness ';
          iNotification.AlertBody := 'Increasing the image brightness...';
          NotificationCenter1.PresentNotification(iNotification);
        finally
          iNotification.Free;
        end;
        ImageEnView.Proc.SaveUndo('Brightness ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
        Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
        ImageEnView.Proc.AdjustBrightnessContrastSaturation(10, 0, 0);
        ImageEnView.Update;
        ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage, ImageEnView.IEBitmap);
        ImageEnMView1.Update;
        ImageEnView.IEBitmap.Modified := True;
        ImageEnMView1.IEMBitmap.Modified := True;
        UpdateGUI;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.Layers1SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Selected then
        ImageEnView.LayersCurrent := Layers1.ItemIndex;
    end;
  end;
end;

procedure TForm1.Left1Change(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.Line1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (Line1.Down) or (Line2.Checked) then
      begin
        { Disable gesture panning which disables drawing }
        ImageEnView.Gestures.Zoom.Enabled := True;
        ImageEnView.Gestures.Pan.Enabled := False;
        SelectNone1.Down := True;
        ImageEnView.MouseInteract := [];
      end
      else
      begin
        { Enable gesture zooming and panning }
        ImageEnView.Gestures.Zoom.Enabled := True;
        ImageEnView.Gestures.Pan.Enabled := True;
      end;
    end;
  end;
end;

procedure TForm1.LoadLayers1Click(Sender: TObject);
begin
  OpenPictureDialog1.Filter := 'Layers file (*.lyr)|*.lyr';
  OpenPictureDialog1.FilterIndex := 0;
  OpenPictureDialog1.FileName := '*.lyr';
  OpenPictureDialog1.DefaultExt := '.lyr';
  if OpenPictureDialog1.Execute then
  begin
    if Assigned(PageControl1.ActivePage) then
    begin
      Screen.Cursor := crHourglass;
      try
        ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
        if Assigned(ImageEnView) then
        begin
          ALayerFileName := OpenPictureDialog1.FileName;
          AFilename := ChangeFileExt(ALayerFileName, '.jpg');
          ImageEnView.IO.Params.FileName := AFilename;
          ImageEnView.LayersLoadFromFile(OpenPictureDialog1.FileName);
          ImageEnView.Fit();
          UpdateLayers;
          UpdateStatusBar;
          MergeLayers1.Enabled := ImageEnView.LayersCount > 1;
          SaveLayers1.Enabled := ImageEnView.LayersCount > 1;
          UseCurrentLayer1.Enabled := ImageEnView.LayersCount > 0;
        end;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.MergeLayers1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        ImageEnView.LayersMergeAll(True);
        ImageEnView.DisplayGridKind := iedgNone;
        UpdateGUI;
        UpdateLayers;
        UpdateStatusBar;
      finally
        Screen.Cursor := crDefault
      end;
    end;
  end;
end;

procedure TForm1.UpdateTabSheets;
var
  i: Integer;
  iFileName: string;
begin
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    iFileName := ImageEnMView1.MIO.Params[i].FileName;
    if IEGetFileFramesCount(iFileName) > 1 then
      PageControl1.Pages[i].Caption := 'Frame ' + IntToStr(i + 1)
    else
      PageControl1.Pages[i].Caption := ExtractFileName(iFileName);
  end;
end;

procedure TForm1.MoveDown1Click(Sender: TObject);
var
  iIndex: Integer;
  iFileName: string;
begin
  iIndex := ImageEnMView1.SelectedImage + 2;
  if ImageEnMView1.SelectedImage <> ImageEnMView1.ImageCount - 1 then
  begin
    ImageEnMView1.MoveSelectedImagesTo(iIndex);
    ImageEnMView1.SelectedImage := iIndex;
    PageControl1.ActivePage.PageIndex := PageControl1.ActivePage.PageIndex + 1;
    ImageEnMView1.SelectedImage := ImageEnMView1.SelectedImage - 1;
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        ImageEnView.IEBitmap.Modified := True;
        ImageEnMView1.IEBitmap.Modified := True;
      end;
    end;
    iFileName := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName;
    UpdateGUI;
    UpdateFrames;
    UpdateTabSheets;
    UpdateStatusBar;
  end;
end;

procedure TForm1.MoveUp1Click(Sender: TObject);
var
  iIndex: Integer;
  iFileName: string;
begin
  iFileName := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName;
  iIndex := ImageEnMView1.SelectedImage - 1;
  if ImageEnMView1.SelectedImage <> 0 then
  begin
    ImageEnMView1.MoveSelectedImagesTo(iIndex);
    ImageEnMView1.SelectedImage := iIndex;
    PageControl1.ActivePage.PageIndex := PageControl1.ActivePage.PageIndex - 1;
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        ImageEnView.IEBitmap.Modified := True;
        ImageEnMView1.IEBitmap.Modified := True;
      end;
    end;
    UpdateGUI;
    UpdateFrames;
    UpdateTabSheets;
    UpdateStatusBar;
  end
end;

procedure TForm1.MultipleLayerSelection1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if MultipleLayerSelection1.Checked then
        ImageEnView.LayerOptions := ImageEnView.LayerOptions + [loAllowMultiSelect]
      else
        ImageEnView.LayerOptions := ImageEnView.LayerOptions - [loAllowMultiSelect];
    end;
  end;
end;

procedure TForm1.New1Click(Sender: TObject);
var
  iIEBitmap: TIEBitmap;
  iIntegerColor: TColor;
  iWidth: Integer;
  iHeight: Integer;
  iDimensions: string;
  iImageEnProc: TImageEnProc;
  iBitDepth: Integer;
  iColor: string;
  iLayer: Integer;
  iFrame: Integer;
begin
  FormNewImage := TFormNewImage.Create(Self);
  try
    if FormNewImage.ShowModal = mrOk then
    begin
      Screen.Cursor := crHourglass;
      try
        AFilename := WindowsDesktopFolder + 'Untitled' + FormNewImage.AFileExt;
        AddTabsheet;
        if Assigned(PageControl1.ActivePage) then
        begin
          ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
          if Assigned(ImageEnView) then
          begin
            ImageEnView.Clear;
            ImageEnView.LayersClear;
            ImageEnView.Proc.ClearAllUndo;
            ImageEnView.IO.Params.FileName := AFilename;
            iIntegerColor := FormNewImage.ColorBox1.Selected;
            iWidth := FormNewImage.AImageWidth;
            iHeight := FormNewImage.AImageHeight;
            ImageEnView.IO.Params.BMP_HandleTransparency := True;
            iIEBitmap := TIEBitmap.Create;
            try
              iIEBitmap.Width := iWidth;
              iIEBitmap.Height := iHeight;
              iIEBitmap.PixelFormat := ie24RGB;
              iIEBitmap.Fill(iIntegerColor);
              case FormNewImage.BitDepth of
                32:
                  begin
                    ImageEnView.IO.Params.BitsPerSample := 8;
                    ImageEnView.IO.Params.SamplesPerPixel := 4;
                    iImageEnProc := TImageEnProc.CreateFromBitmap(iIEBitmap);
                    try
                      iImageEnProc.AttachedIEBitmap := iIEBitmap;
                      { Add alphachannel }
                      iIEBitmap.AlphaChannel;
                      { Set transparent color }
                      iImageEnProc.SetTransparentColors(TColor2TRGB(iIntegerColor), TColor2TRGB(iIntegerColor));
                    finally
                      iImageEnProc.Free;
                    end;
                  end;
                24:
                  begin
                    ImageEnView.IO.Params.BitsPerSample := 8;
                    ImageEnView.IO.Params.SamplesPerPixel := 3;
                  end;
                8:
                  begin
                    ImageEnView.IO.Params.BitsPerSample := 8;
                    ImageEnView.IO.Params.SamplesPerPixel := 1;
                  end;
                4:
                  begin
                    ImageEnView.IO.Params.BitsPerSample := 4;
                    ImageEnView.IO.Params.SamplesPerPixel := 1;
                  end;
                1:
                  begin
                    ImageEnView.IO.Params.BitsPerSample := 1;
                    ImageEnView.IO.Params.SamplesPerPixel := 1;
                  end;
              end;
              ImageEnView.IEBitmap.Assign(iIEBitmap);
              ImageEnView.Update;
              ALayerFileName := ChangeFileExt(AFilename, '.lyr');
              ImageEnView.IO.Params.FileName := AFilename;
              ImageEnView.IO.Params.Width := iWidth;
              ImageEnView.IO.Params.Height := iHeight;
              ImageEnView.Layers[0].Name := 'Background Image';
              { Add a layer }
              iLayer := ImageEnView.LayersAdd;
              ImageEnView.Layers[iLayer].Name := 'Drawing Layer';
              ImageEnView.IEBitmap.Fill(clBlack);
              ImageEnView.Proc.SetTransparentColors(TColor2TRGB(clBlack), TColor2TRGB(clBlack), 0);
              ImageEnView.Fit();
              ImageEnView.Update;
              iFrame := ImageEnMView1.AppendImage;
              ImageEnMView1.SelectedImage := iFrame;
              ImageEnView.IEBitmap.Assign(iIEBitmap);
              ImageEnView.Update;
              ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage, ImageEnView.IEBitmap);
              ImageEnMView1.Update;
              ImageEnMView1.MIO.Params[iFrame].Width := iWidth;
              ImageEnMView1.MIO.Params[iFrame].Height := iHeight;
              ImageEnMView1.MIO.Params[iFrame].FileName := AFilename;
              ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel := ImageEnView.IO.Params.BitsPerSample;
              ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := ImageEnView.IO.Params.SamplesPerPixel;
              iDimensions := IntegerToString(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width) + ' x ' +
                IntegerToString(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height);
              iBitDepth := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel * ImageEnMView1.MIO.Params
                [ImageEnMView1.SelectedImage].BitsPerSample;
              if iBitDepth = 32 then
                iColor := 'RGBA 32-Bit'
              else
                iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
              ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions + ' ' + iColor;
              ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] := ExtractFileName(AFilename);
              PageControl1.Pages[ImageEnMView1.SelectedImage].Caption := AFilename;
              ConvertTo32Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 32;
              ConvertTo24Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 24;
              ConvertTo8Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 8;
              ConvertTo4Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 4;
              UpdateGUI;
              UpdateLayers;
              UpdateStatusBar;
            finally
              iIEBitmap.Free;
            end;
          end;
        end;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  finally
    FormNewImage.Free;
  end;
end;

procedure TForm1.NewFrame1Click(Sender: TObject);
var
  iIndex: Integer;
  iIEBitmap: TIEBitmap;
  iDimensions: string;
  iColor: string;
  iBitDepth: Integer;
  iWidth: Integer;
  iHeight: Integer;
  iBitmapPixelFormat: TIEPixelFormat;
  iBitmapColor: TColor;
begin
  FormNewImage := TFormNewImage.Create(Self);
  try
    if FormNewImage.ShowModal = mrOk then
    begin
      AddTabsheet;
      if Assigned(PageControl1.ActivePage) then
      begin
        ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
        if Assigned(ImageEnView) then
        begin
          iWidth := StrToInt(FormNewImage.Width1.Text);
          iHeight := StrToInt(FormNewImage.Height1.Text);
          iBitmapColor := FormNewImage.ColorBox1.Selected;
          iBitmapPixelFormat := ie24RGB;
          iIEBitmap := TIEBitmap.Create(iWidth, iHeight, iBitmapPixelFormat);
          try
            iIEBitmap.Fill(iBitmapColor);
            iIndex := ImageEnMView1.AppendImage(iIEBitmap);
            ImageEnMView1.SelectedImage := iIndex;
            ImageEnMView1.MIO.Params[iIndex].FileType := ioICO;
            ImageEnMView1.MIO.Params[iIndex].Width := iWidth;
            ImageEnMView1.MIO.Params[iIndex].Height := iHeight;
            case FormNewImage.ColorDepth1.ItemIndex of
              0:
                begin
                  iBitDepth := 32;
                  ConvertTo32Bit;
                end;
              1:
                begin
                  iBitDepth := 24;
                  ConvertTo24Bit;
                end;
              2:
                begin
                  iBitDepth := 8;
                  ConvertTo8Bit;
                end;
              3:
                begin
                  iBitDepth := 4;
                  ConvertTo4Bit;
                end;
            else
              begin
                iBitDepth := 24;
                ConvertTo24Bit;
              end;
            end;
            iDimensions := IntegerToString(iWidth) + ' x ' + IntegerToString(iHeight);
            ImageEnMView1.MIO.Params[iIndex].ICO_BitCount[iIndex] := iBitDepth;
            if iBitDepth = 32 then
              iColor := 'RGBA 32-Bit'
            else
              iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
            ImageEnMView1.ImageTopText[iIndex] := iDimensions + ' ' + iColor;
            ImageEnMView1.ImageBottomText[iIndex] := 'Frame ' + IntToStr(iIndex + 1);
          finally
            iIEBitmap.Free;
          end;
          if AFilename = '' then
            AFilename := WindowsDesktopFolder + 'Untitled.png';
          ImageEnMView1.CopyToIEBitmap(iIndex, ImageEnView.IEBitmap);
          ImageEnView.IO.Params.Assign(ImageEnMView1.MIO.Params[iIndex]);
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          ImageEnMView1.IEMBitmap.Modified := True;
          if Fit1.Down then
            ImageEnView.Fit;
          ImageEnMView1.Update;
          UpdateLayers;
          UpdateStatusBar;
        end;
      end;
    end;
  finally
    FormNewImage.Free;
  end;
end;

procedure TForm1.SaveLayers1Click(Sender: TObject);
var
  iFileName: string;
  iIndex: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      SavePictureDialog1.Filter := 'Layers file (*.lyr)|*.lyr';
      if FileExists(ALayerFileName) then
      begin
        SavePictureDialog1.FileName := ALayerFileName;
        SavePictureDialog1.DefaultExt := '.lyr';
        { Set the filter index of popular file formats }
        iIndex := FilterIndex(SavePictureDialog1.Filter, iFileName);
        SavePictureDialog1.FilterIndex := iIndex;
      end
      else
        SavePictureDialog1.FileName := '*.lyr';
      if SavePictureDialog1.Execute then
      begin
        ImageEnView.LayersSaveToFile(SavePictureDialog1.FileName);
      end;
    end;
  end;
end;

procedure TForm1.AlignLayers1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      for i := 1 to ImageEnView.LayersCount - 1 do
      begin
        ImageEnView.Layers[i].PosX := 0;
        ImageEnView.Layers[i].PosY := 0;
        ImageEnView.Layers[i].Width := ImageEnView.Layers[0].Bitmap.Width;
        ImageEnView.Layers[i].Height := ImageEnView.Layers[0].Bitmap.Height;
      end;
      ImageEnView.Update;
      ImageEnView.DisplayGridKind := iedgNone;
    end;
  end;
end;

procedure TForm1.AutoFeed1Click(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.AutoSize1Click(Sender: TObject);
begin
  SetLayerTextParameters;
end;

procedure TForm1.GetLayerTextParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if IsTextLayer(ImageEnView) then
      begin
        BorderColorBox1.Selected := TIETextLayer(ImageEnView.CurrentLayer).BorderColor;
        FillColorBox1.Selected := TIETextLayer(ImageEnView.CurrentLayer).FillColor;
        GradientColorBox1.Selected := TIETextLayer(ImageEnView.CurrentLayer).FillColor2;
        Width1.Position := TIETextLayer(ImageEnView.CurrentLayer).BorderWidth;
        TextFont1.ItemIndex := TextFont1.Items.IndexOf(TIETextLayer(ImageEnView.CurrentLayer).Font.Name);
        TextFontSize1.Position := TIETextLayer(ImageEnView.CurrentLayer).Font.Size;
        TextFontColorBox1.Selected := TIETextLayer(ImageEnView.CurrentLayer).Font.Color;
        AutoSize1.Checked := TIETextLayer(ImageEnView.CurrentLayer).AutoSize;
      end;
    end;
  end;
end;

procedure TForm1.SetLayerTextParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if IsTextLayer(ImageEnView) then
      begin
        TIETextLayer(ImageEnView.CurrentLayer).BorderColor := BorderColorBox1.Selected;
        TIETextLayer(ImageEnView.CurrentLayer).FillColor := FillColorBox1.Selected;
        TIETextLayer(ImageEnView.CurrentLayer).FillColor2 := GradientColorBox1.Selected;
        TIETextLayer(ImageEnView.CurrentLayer).BorderWidth := Width1.Position;
        TIETextLayer(ImageEnView.CurrentLayer).Font.Name := TextFont1.Items[TextFont1.ItemIndex];
        TIETextLayer(ImageEnView.CurrentLayer).Font.Size := TextFontSize1.Position;
        TIETextLayer(ImageEnView.CurrentLayer).Font.Color := TextFontColorBox1.Selected;
        TIETextLayer(ImageEnView.CurrentLayer).AutoSize := AutoSize1.Checked;
        ImageEnView.Update;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
      end;
    end;
  end;
end;

procedure TForm1.GetLayerShapeParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if IsShapeLayer(ImageEnView) then
      begin
        BorderColorBox1.Selected := TIEShapeLayer(ImageEnView.CurrentLayer).BorderColor;
        FillColorBox1.Selected := TIEShapeLayer(ImageEnView.CurrentLayer).FillColor;
        GradientColorBox1.Selected := TIEShapeLayer(ImageEnView.CurrentLayer).FillColor2;
        Width1.Position := TIEShapeLayer(ImageEnView.CurrentLayer).BorderWidth;
      end;
    end;
  end;
end;

procedure TForm1.SetLayerShapeParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if IsShapeLayer(ImageEnView) then
      begin
        TIEShapeLayer(ImageEnView.CurrentLayer).BorderColor := BorderColorBox1.Selected;
        TIEShapeLayer(ImageEnView.CurrentLayer).FillColor := FillColorBox1.Selected;
        TIEShapeLayer(ImageEnView.CurrentLayer).FillColor2 := GradientColorBox1.Selected;
        TIEShapeLayer(ImageEnView.CurrentLayer).BorderWidth := Width1.Position;
        ImageEnView.Update;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
      end;
    end;
  end
  else
  begin
    Shape1.Repaint;
  end;
end;

procedure TForm1.BorderColorBox1Change(Sender: TObject);
begin
  SetLayerTextParameters;
  SetLayerShapeParameters;
end;

procedure TForm1.Bottom1Change(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.BrushColor1Change(Sender: TObject);
begin
  BrushColor.Color := BrushColor1.Selected;
  IEColorPaletteBrush1.SelectedColor := BrushColor1.Selected;
end;

procedure TForm1.BrushColorClick(Sender: TObject);
begin
  ColorDialog1.Color := BrushColor.Color;
  if ColorDialog1.Execute then
  begin
    BrushColor.Color := ColorDialog1.Color;
    BrushColor1.Selected := BrushColor.Color;
  end;
end;

procedure TForm1.BrushOpacity1Change(Sender: TObject);
begin
  TrackBarBrushOpacity1.Position := StrToIntDef(BrushOpacity1.Text, 100);
  BrushColor.Color := DitherColor(BrushColor1.Selected, IEOpacityToAlpha(StrToIntDef(BrushOpacity1.Text, 100)));
end;

procedure TForm1.DeSkew1Click(Sender: TObject);
{ DeSkew. }
var
  i: Double;
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iNotification := NotificationCenter1.CreateNotification;
      try
        iNotification.Name := 'Notification';
        iNotification.Title := 'DeSkew snd Crop ';
        iNotification.AlertBody := 'DeSkew and crop the image...';
        NotificationCenter1.PresentNotification(iNotification);
      finally
        iNotification.Free;
      end;
      ImageEnView.Proc.SaveUndo('DeSkew ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      i := ImageEnView.Proc.SkewDetection;
      ImageEnView.Proc.RotateAndCrop(i);
      ImageEnView.Update;
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
      ImageEnMView1.Update;
      UpdateGUI;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.RemoveRedEyes1Click(Sender: TObject);
var
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iNotification := NotificationCenter1.CreateNotification;
      try
        iNotification.Name := 'Notification';
        iNotification.Title := 'Remove RedEye ';
        iNotification.AlertBody := 'Remove redeye...';
        NotificationCenter1.PresentNotification(iNotification);
      finally
        iNotification.Free;
      end;
      ImageEnView.Proc.SaveUndo('RemoveRedEye ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      ImageEnView.Proc.RemoveRedEyes;
      ImageEnView.Update;
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
      ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
      ImageEnMView1.Update;
      UpdateGUI;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.SaveParameters1Click(Sender: TObject);
begin
  SaveProperties;
  { Verify Twain properties... }
  if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
    ImageEnMView1.MIO.TwainParams.Update;
  { Read back: Some properties may have altered due to TwainParams.Update }
  UpdateControlStatus;
end;

procedure TForm1.DeselectLayers1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.LayersDeselectAll;
      Layers1.ItemIndex := 0;
    end;
  end;
end;

procedure TForm1.LayerCaching1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if LayerCaching1.Checked then
        ImageEnView.LayersCaching := -1
      else
        ImageEnView.LayersCaching := 0;
    end;
  end;
end;

procedure TForm1.GetPrinterNames1Click(Sender: TObject);
begin
  GetPrinterNames;
  Printers1.Items.AddStrings(APrinterNames);
  if APrinterNames.Count > 0 then
  begin
    Printers1.ItemIndex := Printers1.Items.IndexOf(GetDefaultPrinterName);
    Printers1.Enabled := Printers1.Items.Count > 0;
  end
  else
    Printers1.Enabled := False;
end;

procedure TForm1.GetScannerNames1Click(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    Sources1.Clear;
    { Fill sources }
    ImageEnMView1.MIO.AcquireParams.FillListWithSources(Sources1.Items);
    Sources1.ItemIndex := Sources1.Items.IndexOf(AcquireSourceToStr(ImageEnMView1.MIO.AcquireParams.SelectedSource));
    Acquire1.Enabled := Sources1.Items.Count > 0;
    UpdateControlStatus;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.Cast1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Cast1.Down then
      begin
        ImageEnView.Cursor := crIEPaintFill;
        ImageEnView.Gestures.Pan.Enabled := False;
        ImageEnView.Gestures.Zoom.Enabled := False;
      end
      else
      begin
        ImageEnView.Cursor := crDefault;
        ImageEnView.Gestures.Pan.Enabled := True;
        ImageEnView.Gestures.Zoom.Enabled := True;
      end;
      ImageEnView.Update;
      UpdateGUI;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.CastAlpha1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if CastAlpha1.Down then
      begin
        ImageEnView.Cursor := crIEPaintFill;
        ImageEnView.Gestures.Pan.Enabled := False;
        ImageEnView.Gestures.Zoom.Enabled := False;
      end
      else
      begin
        ImageEnView.Cursor := crDefault;
        ImageEnView.Gestures.Pan.Enabled := True;
        ImageEnView.Gestures.Zoom.Enabled := True;
      end;
      ImageEnView.Update;
      UpdateGUI;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.CastColor1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if CastColor1.Down then
      begin
        ImageEnView.Cursor := crIEPaintFill;
        ImageEnView.Gestures.Pan.Enabled := False;
        ImageEnView.Gestures.Zoom.Enabled := False;
      end
      else
      begin
        ImageEnView.Cursor := crDefault;
        ImageEnView.Gestures.Pan.Enabled := True;
        ImageEnView.Gestures.Zoom.Enabled := True;
      end;
      ImageEnView.Update;
      UpdateGUI;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.CheckParameters1Click(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.Clear1Click(Sender: TObject);
var
  iLayer: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        AFilename := WindowsDesktopFolder + 'Untitled.jpg';
        ALayerFileName := ChangeFileExt(AFilename, '.lyr');
        ImageEnView.Clear;
        ImageEnView.LayersClear;
        ImageEnView.Proc.ClearAllUndo;
        ImageEnView.IEBitmap.IEInitialize(1024, 768, clWhite);
        ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Width;
        ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Height;
        ImageEnView.Layers[0].Name := 'Background Image';
        iLayer := ImageEnView.LayersAdd;
        ImageEnView.Layers[iLayer].Name := 'Drawing Layer';
        ImageEnView.IEBitmap.Fill(clBlack);
        ImageEnView.Proc.SetTransparentColors(TColor2TRGB(clBlack), TColor2TRGB(clBlack), 0);
        ImageEnView.Update;
        ImageEnView.Proc.ClearAllUndo;
        ImageEnView.IO.Params.BitsPerSample := 8;
        ImageEnView.IO.Params.SamplesPerPixel := 3;
        MergeLayers1.Enabled := ImageEnView.LayersCount > 1;
        SaveLayers1.Enabled := ImageEnView.LayersCount > 1;
        ConvertTo32Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 32;
        ConvertTo24Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 24;
        ConvertTo8Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 8;
        ConvertTo4Bit1.Enabled := ImageEnView.IO.Params.BitsPerSample * ImageEnView.IO.Params.SamplesPerPixel <> 4;
        ImageEnView.Fit();
        UpdateGUI;
        UpdateLayers;
        UpdateStatusBar;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.CloseAll1Click(Sender: TObject);
var
  i: Integer;
begin
  { Clear Layers }
  Layers1.Clear;
  { Close all pages }
  for i := Pred(PageControl1.PageCount) downto 0 do
    PageControl1.Pages[i].Free;
  { Clear frames }
  ImageEnMView1.Clear;
  LabelX1.Caption := 'X:';
  LabelY1.Caption := 'Y:';
  LabelColor1.Caption := 'Color:';
  LabelRGB1.Caption := 'RGB:';
  OpacityUnderCursor1.Caption := 'Opacity:';
  AlphaUnderCursor1.Caption := 'Alpha:';
  UpdateGUI;
  ClearStatusBar;
end;

procedure TForm1.PenOpacity1Change(Sender: TObject);
begin
  TrackBarPenOpacity1.Position := StrToIntDef(PenOpacity1.Text, 100);
  PenColor.Color := DitherColor(PenColor1.Selected, IEOpacityToAlpha(StrToIntDef(PenOpacity1.Text, 100)));
end;

function TForm1.IsMultiFrameImage: Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := ImageEnMView1.ImageCount - 1 downto 0 do
  begin
    if ImageEnMView1.MIO.Params[i].ImageCount > 1 then
    begin
      Result := True;
      break;
    end;
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
var
  i: Integer;
  ip: Integer;
  iFrames: Integer;
  iFileName: string;
  iDimensions: string;
  iBitDepth: Integer;
  iColor: string;
  iIndex: Integer;
  iNotification: TNotification;
begin
  OpenPictureDialog1.Filter := GraphicFilter(TGraphic);
  { To add PDF files IO  install wpcubedPDF and unremark the following }
  OpenPictureDialog1.Filter := OpenPictureDialog1.Filter + '|Adobe Portable Document Format (*.pdf)|*.pdf';
  OpenPictureDialog1.FilterIndex := 0;
  OpenPictureDialog1.FileName := '';
  OpenPictureDialog1.DefaultExt := '.jpg';
  if OpenPictureDialog1.Execute then
  begin
    if System.SysUtils.FileExists(OpenPictureDialog1.FileName) then
    begin
      Screen.Cursor := crHourglass;
      try
        iFileName := OpenPictureDialog1.FileName;
        if AMostRecentFiles.IndexOf(iFileName) < 0 then
          AMostRecentFiles.Append(iFileName);
        iFrames := IEGetFileFramesCount(iFileName);
        { Is a multiframe image loaded or file to be opened a multiframe image }
        if (IsMultiFrameImage) or (iFrames > 1) then
        begin
          { Clear frames }
          ImageEnMView1.Clear;
          ImageEnMView1.Update;
          { Close all pages }
          for ip := PageControl1.PageCount - 1 downto 0 do
            PageControl1.Pages[ip].Free;
        end;
        if iFrames > 1 then
        begin
          ImageEnMView1.MIO.LoadFromFile(iFileName);
          ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
        end
        else
        begin
          ImageEnMView1.AppendImage(iFileName);
          ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
        end;
        if ImageEnMView1.MIO.Aborting then
        begin
          { TaskDialog1.Title := 'Error Loading Image';
            TaskDialog1.Caption := 'Image Not Loaded';
            TaskDialog1.Text := 'An error ocurred.  The image was not loaded.';
            TaskDialog1.CommonButtons := [tcbOk];
            TaskDialog1.Flags := [];
            TaskDialog1.MainIcon := tdiError;
            TaskDialog1.FooterText := 'Developed By Adirondack Software & Graphics';
            TaskDialog1.Execute; }
          iNotification := NotificationCenter1.CreateNotification;
          try
            iNotification.Name := 'ErrorNotification';
            iNotification.Title := 'Image Not Loaded ';
            iNotification.AlertBody := 'An error ocurred.  The image was not loaded...';
            NotificationCenter1.PresentNotification(iNotification);
          finally
            iNotification.Free;
          end;
          ImageEnMView1.DeleteImage(ImageEnMView1.SelectedImage);
          exit;
          AFilename := iFileName;
        end;
        if (iFrames = 1) and (ImageEnMView1.SelectedImage <> -1) then
        begin
          AddTabsheet;
          ImageEnView := TImageEnView(PageControl1.Pages[ImageEnMView1.SelectedImage].Controls[0]);
          ImageEnMView1.CopyToIEBitmap(ImageEnMView1.SelectedImage, ImageEnView.IEBitmap);
          ImageEnView.IO.Params.Assign(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]);
          iDimensions := IntegerToString(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width) + ' x ' +
            IntegerToString(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height);
          iBitDepth := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel * ImageEnMView1.MIO.Params
            [ImageEnMView1.SelectedImage].BitsPerSample;
          if iBitDepth = 32 then
            iColor := 'RGBA 32-Bit'
          else
            iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
          ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions + ' ' + iColor;
          ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] := ExtractFileName(iFileName);
          iBitDepth := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].SamplesPerPixel * ImageEnMView1.MIO.Params
            [ImageEnMView1.SelectedImage].BitsPerSample;
          if iBitDepth = 32 then
            ImageEnView.BackgroundStyle := iebsChessboard
          else
            ImageEnView.BackgroundStyle := iebsSolid;
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := False;
          PageControl1.Pages[ImageEnMView1.SelectedImage].Caption := iFileName;
          ImageEnView.Fit;
        end
        else
        begin
          for i := 0 to iFrames - 1 do
          begin
            AddTabsheet;
            ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
            ImageEnView.IO.Params.Assign(ImageEnMView1.MIO.Params[i]);
            iDimensions := IntegerToString(ImageEnMView1.MIO.Params[i].Width) + ' x ' +
              IntegerToString(ImageEnMView1.MIO.Params[i].Height);
            iBitDepth := ImageEnMView1.MIO.Params[i].SamplesPerPixel * ImageEnMView1.MIO.Params[i].BitsPerSample;
            if iBitDepth = 32 then
              iColor := 'RGBA 32-Bit'
            else
              iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
            ImageEnMView1.ImageTopText[i] := iDimensions + ' ' + iColor;
            if iFrames > 1 then
            begin
              ImageEnMView1.ImageBottomText[i] := 'Frame ' + IntToStr(i + 1);
              ImageEnMView1.CopyToIEBitmap(i, ImageEnView.IEBitmap);
              iBitDepth := ImageEnMView1.MIO.Params[i].SamplesPerPixel * ImageEnMView1.MIO.Params[i].BitsPerSample;
              if iBitDepth = 32 then
                ImageEnView.BackgroundStyle := iebsChessboard
              else
                ImageEnView.BackgroundStyle := iebsSolid;
              ImageEnView.IEBitmap.Modified := False;
              ImageEnView.Update;
              PageControl1.Pages[i].Caption := 'Frame ' + IntToStr(i + 1);
            end
            else
            begin
              ImageEnMView1.ImageBottomText[i] := ExtractFileName(iFileName);
              ImageEnMView1.CopyToIEBitmap(i, ImageEnView.IEBitmap);
              ImageEnView.Update;
              ImageEnView.IEBitmap.Modified := False;
              PageControl1.Pages[i].Caption := iFileName;
            end;
            ImageEnView.Fit;
          end;
        end;
        if iFrames = 1 then
        begin
          ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
          PageControl1.ActivePageIndex := PageControl1.PageCount - 1;
        end
        else
        begin
          ImageEnMView1.SelectedImage := 0;
          PageControl1.ActivePageIndex := 0;
        end;
        UpdateGUI;
        UpdateLayers;
        UpdateStatusBar;
      finally
        Screen.Cursor := crDefault;
      end;
    end
    else
    begin
      TaskDialog1.Title := 'Image Does not Exist';
      TaskDialog1.Caption := 'Image Not Loaded';
      TaskDialog1.Text := 'The file ' + ExtractFileName(iFileName) + ' does not exist.  Remove the file from the list?';
      TaskDialog1.CommonButtons := [tcbYes, tcbNo];
      TaskDialog1.Flags := [tfUseHiconMain];
      TaskDialog1.FooterText := 'Developed By Adirondack Software & Graphics';
      if TaskDialog1.Execute then
        if TaskDialog1.ModalResult = mrYes then
        begin
          iIndex := TMenuItem(Sender).MenuIndex;
          AMostRecentFiles.Delete(iIndex);
          exit;
        end;
    end;
  end;
end;

procedure TForm1.Orientation1Change(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.DisplayGrid := DisplayGrid1.Checked;
      AFilename := ImageEnView.IO.Params.FileName;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.PageControl1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ImageEnMView1.SelectedImage := PageControl1.ActivePageIndex;
end;

procedure TForm1.PageControl2Change(Sender: TObject);
begin
  TabSheet9.Enabled := True;
  TabSheet10.Enabled := True;
  UpdateGUI;
end;

procedure TForm1.PaintBrush1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (PaintBrush1.Down) or (PaintBrush2.Checked) then
      begin
        { Disable gesture panning which disables drawing }
        ImageEnView.Gestures.Zoom.Enabled := False;
        ImageEnView.Gestures.Pan.Enabled := False;
        if SelectLayers1.Down then
          SelectLayers1.Down := False;
        SelectNone1.Down := True;
        ImageEnView.MouseInteract := [];
      end
      else
      begin
        { Enable gesture zooming and panning }
        ImageEnView.Gestures.Zoom.Enabled := True;
        ImageEnView.Gestures.Pan.Enabled := True;
      end;
    end;
  end;
end;

procedure TForm1.PenColorClick(Sender: TObject);
begin
  ColorDialog1.Color := PenColor.Color;
  if ColorDialog1.Execute then
  begin
    PenColor.Color := ColorDialog1.Color;
    PenColor1.Selected := PenColor.Color;
  end;
end;

procedure TForm1.PenSize1Change(Sender: TObject);
begin
  TrackBarPenSize1.Position := StrToIntDef(PenSize1.Text, 20);
end;

procedure TForm1.Pick1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Pick1.Down then
        ImageEnView.Cursor := crIEEyeDropper
      else
        ImageEnView.Cursor := crDefault;
    end;
  end;
end;

procedure TForm1.PickAlpha1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if PickAlpha1.Down then
        ImageEnView.Cursor := crIEEyeDropper
      else
        ImageEnView.Cursor := crDefault;
    end;
  end;
end;

procedure TForm1.PickColor1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if PickColor1.Down then
        ImageEnView.Cursor := crIEEyeDropper
      else
        ImageEnView.Cursor := crDefault;
    end;
  end;
end;

procedure TForm1.Polygon1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Polygon1.Down then
      begin
        ImageEnView.MouseInteract := [miSelectPolygon];
        PaintBrush1.Down := False;
        Line1.Down := False;
        Rectangle1.Down := False;
        RoundRectangle1.Down := False;
        Ellipse1.Down := False;
      end
      else
      begin
        ImageEnView.MouseInteract := [];
        SelectNone1.Down := True;
      end;
    end;
  end;
end;

procedure TForm1.PopupMenuFrames1Popup(Sender: TObject);
begin
  DeleteFrame2.Enabled := (ImageEnMView1.ImageCount > 0) and (ImageEnMView1.SelectedImage <> -1);
end;

procedure TForm1.PopupMenuLayers1Popup(Sender: TObject);
begin
  UpdateGUI;
end;

procedure TForm1.PopupMenuMRF1Popup(Sender: TObject);
{ Fill downdown menu with recent files list }
var
  i: Integer;
  iMenuItem: TMenuItem;
begin
  PopupMenuMRF1.Items.Clear;
  if AMostRecentFiles.Count > 0 then
  begin
    for i := 0 to AMostRecentFiles.Count - 1 do
    begin
      iMenuItem := TMenuItem.Create(PopupMenuMRF1);
      iMenuItem.Tag := i;
      iMenuItem.Caption := AMostRecentFiles[i];
      iMenuItem.OnClick := LoadRecentFile;
      PopupMenuMRF1.Items.Add(iMenuItem);
    end;
    iMenuItem := TMenuItem.Create(PopupMenuMRF1);
    PopupMenuMRF1.Items.Add(iMenuItem);
    iMenuItem.Caption := '-';
    iMenuItem := TMenuItem.Create(PopupMenuMRF1);
    PopupMenuMRF1.Items.Add(iMenuItem);
    iMenuItem.Caption := 'Clear Recent';
    iMenuItem.OnClick := ClearRecentFiles;
  end;
end;

procedure TForm1.Print1Click(Sender: TObject);
var
  iPrinterIndex: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iPrinterIndex := GetDefaultPrinterIndex;
      Printer.PrinterIndex := iPrinterIndex;
      if ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width > ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height
      then
        Printer.Orientation := poLandscape
      else
        Printer.Orientation := poPortrait;
      ImageEnMView1.MIO.PrintPreviewParams.PrintSelected := True;
      ImageEnMView1.MIO.DoPrintPreviewDialog('Print', True, 'Print Preview', False);
    end;
  end;
end;

procedure TForm1.Printers1Change(Sender: TObject);
begin
  SetPrinter(Printers1.Items.Strings[Printers1.ItemIndex]);
end;

procedure TForm1.Rectangle1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (Rectangle1.Down) or (Rectangle2.Checked) then
      begin
        { Disable gesture panning which disables drawing }
        ImageEnView.Gestures.Zoom.Enabled := True;
        ImageEnView.Gestures.Pan.Enabled := False;
        SelectNone1.Down := True;
        ImageEnView.MouseInteract := [];
      end
      else
      begin
        { Enable gesture zooming and panning }
        ImageEnView.Gestures.Zoom.Enabled := True;
        ImageEnView.Gestures.Pan.Enabled := True;
      end;
    end;
  end;
end;

procedure TForm1.RemoveLayer1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.LayersCurrent > 0 then
      begin
        ImageEnView.LayersRemove(ImageEnView.LayersCurrent);
        ImageEnView.Proc.ClearAllUndo;
        ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap);
        ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
        ImageEnMView1.Update;
        UpdateGUI;
        UpdateLayers;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.Resample1Click(Sender: TObject);
var
  iIEBitmap: TIEBitmap;
  iWidth: Integer;
  iHeight: Integer;
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      FormResample := TFormResample.Create(Self);
      try
        Screen.Cursor := crHourglass;
        try
          iIEBitmap := TIEBitmap.Create;
          try
            iIEBitmap.Assign(ImageEnView.IEBitmap);
            FormResample.ImageEnView1.IEBitmap.Assign(iIEBitmap);
            FormResample.ImageEnView1.IO.Params.Assign(ImageEnView.IO.Params);
            FormResample.ImageEnView2.IEBitmap.Assign(iIEBitmap);
            FormResample.ImageEnView2.IO.Params.Assign(ImageEnView.IO.Params);
            FormResample.ImageEnView1.Update;
            FormResample.ImageEnView2.Update;
          finally
            iIEBitmap.Free;
          end;
        finally
          Screen.Cursor := crDefault;
        end;
        if FormResample.ShowModal = mrOk then
          if not FormResample.Applied then
          begin
            Screen.Cursor := crHourglass;
            try
              iNotification := NotificationCenter1.CreateNotification;
              try
                iNotification.Name := 'Notification';
                iNotification.Title := 'Resample ';
                iNotification.AlertBody := 'Resampling the image...';
                NotificationCenter1.PresentNotification(iNotification);
              finally
                iNotification.Free;
              end;
              ImageEnView.Proc.SaveUndo('Resample ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
              Undo1.Enabled := ImageEnView.Proc.CanUndo;
              iWidth := FormResample.ImageEnView2.IEBitmap.Width;
              iHeight := FormResample.ImageEnView2.IEBitmap.Height;
              ImageEnView.Proc.Resample(iWidth, iHeight, TResampleFilter(FormResample.ComboBoxResampleFilter1.ItemIndex),
                FormResample.Proportional1.Checked);
              ImageEnView.Update;
              ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
              ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
              ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage, ImageEnView.IEBitmap);
              ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width := ImageEnView.IEBitmap.Width;
              ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height := ImageEnView.IEBitmap.Height;
              ImageEnMView1.Update;
              ImageEnView.IEBitmap.Modified := True;
              UpdateFrame;
              UpdateStatusBar;
            finally
              Screen.Cursor := crDefault;
            end;
          end;
      finally
        FormResample.Free;
      end;
    end;
  end;
end;

procedure TForm1.Resize1Click(Sender: TObject);
var
  iIEBitmap: TIEBitmap;
  iWidth: Integer;
  iHeight: Integer;
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      FormResize := TFormResize.Create(Self);
      try
        Screen.Cursor := crHourglass;
        try
          iIEBitmap := TIEBitmap.Create;
          try
            iIEBitmap.Assign(ImageEnView.IEBitmap);
            FormResize.ImageEnView1.IEBitmap.Assign(iIEBitmap);
            FormResize.ImageEnView1.IO.Params.Assign(ImageEnView.IO.Params);
            FormResize.ImageEnView2.IEBitmap.Assign(iIEBitmap);
            FormResize.ImageEnView2.IO.Params.Assign(ImageEnView.IO.Params);
            FormResize.ImageEnView1.Update;
            FormResize.ImageEnView2.Update;
          finally
            iIEBitmap.Free;
          end;
        finally
          Screen.Cursor := crDefault;
        end;
        if FormResize.ShowModal = mrOk then
          if not FormResize.Applied then
          begin
            Screen.Cursor := crHourglass;
            try
              iNotification := NotificationCenter1.CreateNotification;
              try
                iNotification.Name := 'Notification';
                iNotification.Title := 'Resize ';
                iNotification.AlertBody := 'Resizing the image canvas...';
                NotificationCenter1.PresentNotification(iNotification);
              finally
                iNotification.Free;
              end;
              ImageEnView.Proc.SaveUndo('Resize ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
              Undo1.Enabled := ImageEnView.Proc.CanUndo;
              iWidth := FormResize.ImageEnView2.IEBitmap.Width;
              iHeight := FormResize.ImageEnView2.IEBitmap.Height;
              ImageEnView.Proc.ImageResize(iWidth, iHeight, TIEHAlign(FormResize.ComboBoxVerticalAlignment1.ItemIndex),
                TIEVAlign(FormResize.ComboBoxVerticalAlignment1.ItemIndex));
              ImageEnView.Update;
              ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
              ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
              ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage, ImageEnView.IEBitmap);
              ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width := ImageEnView.IEBitmap.Width;
              ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height := ImageEnView.IEBitmap.Height;
              ImageEnMView1.Update;
              ImageEnView.IEBitmap.Modified := True;
              UpdateFrame;
              UpdateStatusBar;
            finally
              Screen.Cursor := crDefault;
            end;
          end;
      finally
        FormResize.Free;
      end;
    end;
  end;
end;

procedure TForm1.ResizeAllLayers1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Resize All Layers ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      { Halve the size of all layers }
      ImageEnView.LayersSizeAll(0.5, 0.5);
    end;
  end;
end;

procedure TForm1.ResizeSelectedLayers1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Resize Selected Layers ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      ImageEnView.LockUpdate;
      for i := 0 to ImageEnView.LayersCount - 1 do
        if ImageEnView.Layers[i].Selected then
        begin
          ImageEnView.Layers[i].Width := ImageEnView.Layers[i].Width div 2;
          ImageEnView.Layers[i].Height := ImageEnView.Layers[i].Height div 2;
          ImageEnView.LayersFixSizes(i);
        end;
      ImageEnView.UnlockUpdate;
    end;
  end;
end;

procedure TForm1.Right1Change(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.RotateLayers1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (RotateLayers1.Down) or (RotateLayers2.Checked) then
      begin
        ImageEnView.MouseInteract := [miRotateLayers];
        IEGlobalSettings().GuidelineCount := 4;
        IEGlobalSettings().GridPen.Color := clSilver;
        IEGlobalSettings().GridPen.Style := psDot;
        IEGlobalSettings().GridPen.Mode := pmCopy;
        ImageEnView.DisplayGridKind := iedgGuideLines;
        IEGlobalSettings().GridMajorStep := 10;
        PaintBrush1.Down := False;
        Line1.Down := False;
        Rectangle1.Down := False;
        RoundRectangle1.Down := False;
        Ellipse1.Down := False;
      end;
    end;
  end;
end;

procedure TForm1.RotateSelectedLayers1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Rotate Selected Layers ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      ImageEnView.LockUpdate;
      for i := 0 to ImageEnView.LayersCount - 1 do
        if ImageEnView.Layers[i].Selected then
          ImageEnView.Layers[i].Rotate := 90;
      ImageEnView.LayersFixRotations(LYR_SELECTED_LAYERS);
      ImageEnView.UnlockUpdate;
    end;
  end;
end;

procedure TForm1.Rotation1Change(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  try
    SaveProperties;
    { Verify Twain properties }
    if ImageEnMView1.MIO.SelectedAcquireSource.API = ieaTwain then
      ImageEnMView1.MIO.TwainParams.Update;
    { Read back: Some properties may have altered due to TwainParams.Update }
    UpdateControlStatus;
    Acquire1.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.RoundRectangle1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (RoundRectangle1.Down) or (RoundRectangle2.Checked) then
      begin
        { Disable gesture panning which disables drawing }
        ImageEnView.Gestures.Zoom.Enabled := True;
        ImageEnView.Gestures.Pan.Enabled := False;
        SelectNone1.Down := True;
        ImageEnView.MouseInteract := [];
      end
      else
      begin
        { Enable gesture zooming and panning }
        ImageEnView.Gestures.Zoom.Enabled := True;
        ImageEnView.Gestures.Pan.Enabled := True;
      end;
    end;
  end;
end;

procedure TForm1.Save1Click(Sender: TObject);
var
  iFileName: string;
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if FileExists(ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName) then
      begin
        Screen.Cursor := crHourglass;
        try
          iFileName := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName;
          if IsMultiFrameImage then
          begin
            ImageEnMView1.MIO.SaveToFile(iFileName);
            if ImageEnMView1.MIO.Aborting then
            begin
              iNotification := NotificationCenter1.CreateNotification;
              try
                iNotification.Name := 'ErrorNotification';
                iNotification.Title := 'Error Saving Image';
                iNotification.AlertBody := 'There was an error saving the image.  The image can not be saved.';
                NotificationCenter1.PresentNotification(iNotification);
              finally
                iNotification.Free;
              end;
              exit;
            end;
          end
          else
          begin
            ImageEnView.IO.SaveToFile(iFileName);
            if ImageEnView.IO.Aborting then
            begin
              iNotification := NotificationCenter1.CreateNotification;
              try
                iNotification.Name := 'ErrorNotification';
                iNotification.Title := 'Error Saving Image';
                iNotification.AlertBody := 'There was an error saving the image.  The image was not be saved.';
                NotificationCenter1.PresentNotification(iNotification);
              finally
                iNotification.Free;
              end;
              exit;
            end;
          end;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
var
  iFileName: string;
  iFileType: TIOFileType;
  iExtension: string;
  iNotification: TNotification;
  iIndex: Integer;
  iLayerCount: Integer;
  iResult: TModalResult;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iFileName := ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].FileName;
      if FileExists(iFileName) then
      begin
        SavePictureDialog1.Filter := GraphicFilter(TGraphic);
        { To add PDF files IO install wpcubedPDF and unremark the following }
        { SavePictureDialog1.Filter := SavePictureDialog1.Filter + '|Adobe Portable Document Format (*.pdf)|*.pdf'; }
        iFileType := IEExtToFileFormat(ExtractFileExt(iFileName));
        iExtension := GetFileExtensionsOfType(iFileType);
        { Delete first character - dot "." to set the DefaultExt }
        Delete(iExtension, 1, 1);
        SavePictureDialog1.DefaultExt := iExtension;
        { Set the filter index of popular file formats }
        iIndex := FilterIndex(SavePictureDialog1.Filter, iFileName);
        SavePictureDialog1.FilterIndex := iIndex;
        SavePictureDialog1.FileName := ExtractFileName(iFileName);
      end
      else
        SavePictureDialog1.FileName := '';
      SavePictureDialog1.DefaultExt := '.tif';
      iLayerCount := ImageEnView.LayersCount;
      if iLayerCount > 1 then
      begin
        TaskDialog1.Title := 'Merge Layers';
        TaskDialog1.MainIcon := tdiNone;
        TaskDialog1.Caption := 'Save Image';
        TaskDialog1.Text := 'The image contains layers.  Do you want to merge layers before saving the image?';
        TaskDialog1.CommonButtons := [tcbYes, tcbNo, tcbCancel];
        TaskDialog1.FooterText := 'Developed By Adirondack Software & Graphics';
        TaskDialog1.Flags := [tfUseHiconMain, tfAllowDialogCancellation];
        iResult := -1;
        if TaskDialog1.Execute then
          iResult := TaskDialog1.ModalResult;
        if iResult = mrYes then
        begin
          ImageEnView.LayersMergeAll(True);
          MergeLayers1.Enabled := ImageEnView.LayersCount > 1;
          SaveLayers1.Enabled := ImageEnView.LayersCount > 1;
          UpdateGUI;
          UpdateStatusBar;
        end;
      end;
      if Assigned(PageControl1.ActivePage) then
      begin
        ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
        if Assigned(ImageEnView) then
        begin
          if SavePictureDialog1.Execute then
          begin
            Screen.Cursor := crHourglass;
            try
              iFileName := SavePictureDialog1.FileName;
              if System.SysUtils.FileExists(iFileName) then
              begin
                { if (MessageBox(0, 'The file exists, overwrite the existing file?',
                  'File Exists', MB_ICONQUESTION or MB_YESNO) = idNo) then }
                TaskDialog1.Title := 'File Exists';
                TaskDialog1.Caption := 'The File Exists';
                TaskDialog1.Text := 'The file ' + ExtractFileName(iFileName) + ' exists.  Overwrite the existing file?';
                TaskDialog1.MainIcon := tdiNone;
                TaskDialog1.Flags := [tfUseHiconMain, tfAllowDialogCancellation];
                TaskDialog1.CommonButtons := [tcbYes, tcbNo];
                TaskDialog1.FooterText := 'Developed By Adirondack Software & Graphics';
                iResult := mrNone;
                if TaskDialog1.Execute then
                  iResult := TaskDialog1.ModalResult;
                if iResult = mrNo then
                  exit;
              end;
              if IsMultiFrameImage then
              begin
                ImageEnMView1.MIO.SaveToFile(iFileName);
                if ImageEnMView1.MIO.Aborting then
                begin
                  iNotification := NotificationCenter1.CreateNotification;
                  try
                    iNotification.Name := 'ErrorNotification';
                    iNotification.Title := 'Error Saving Image';
                    iNotification.AlertBody := 'There was an error saving the image.  The image can not be saved.';
                    NotificationCenter1.PresentNotification(iNotification);
                  finally
                    iNotification.Free;
                  end;
                  exit;
                end;
              end
              else
              begin
                ImageEnView.IO.SaveToFile(iFileName);
                if ImageEnView.IO.Aborting then
                begin
                  iNotification := NotificationCenter1.CreateNotification;
                  try
                    iNotification.Name := 'ErrorNotification';
                    iNotification.Title := 'Error Saving Image';
                    iNotification.AlertBody := 'There was an error saving the image.  The image was not be saved.';
                    NotificationCenter1.PresentNotification(iNotification);
                  finally
                    iNotification.Free;
                  end;
                  exit;
                end;
              end;
            finally
              Screen.Cursor := crDefault;
            end;
          end;
          Caption := 'ImageEn 7.0 MultiFrame Editor - ' + iFileName;
          if AMostRecentFiles.IndexOf(iFileName) < 0 then
            AMostRecentFiles.Append(iFileName);
          ImageEnMView1.IEMBitmap.Modified := False;
          ImageEnView.Proc.ClearAllUndo;
          UpdateGUI;
          UpdateStatusBar;
        end;
      end;
    end;
  end;
end;

procedure TForm1.SelectCrop1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.MouseInteract := [miCropTool];
    end;
  end;
end;

procedure TForm1.SelectEllipse1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if SelectEllipse1.Down then
      begin
        ImageEnView.MouseInteract := [miSelectCircle];
        PaintBrush1.Down := False;
        Line1.Down := False;
        Rectangle1.Down := False;
        RoundRectangle1.Down := False;
        Ellipse1.Down := False;
      end
      else
      begin
        ImageEnView.MouseInteract := [];
        SelectNone1.Down := True;
      end;
    end;
  end;
end;

procedure TForm1.Selection1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (Selection1.Down) or (Selection2.Checked) then
      begin
        ImageEnView.MouseInteract := [miSelect];
        PaintBrush1.Down := False;
        Line1.Down := False;
        Rectangle1.Down := False;
        RoundRectangle1.Down := False;
        Ellipse1.Down := False;
      end
      else
      begin
        ImageEnView.MouseInteract := [];
        SelectNone1.Down := True;
      end;
    end;
  end;
end;

procedure TForm1.SelectLayers1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (SelectLayers1.Down) or (SelectLayers2.Checked) then
      begin
        ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
        PaintBrush1.Down := False;
        Line1.Down := False;
        Rectangle1.Down := False;
        RoundRectangle1.Down := False;
        Ellipse1.Down := False;
      end;
    end;
  end;
end;

procedure TForm1.SelectNone1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (SelectNone1.Down) or (SelectNone2.Checked) then
      begin
        ImageEnView.MouseInteract := [];
        ImageEnView.Cursor := 1784;
        ImageEnView.DisplayGridKind := iedgNone;
        ImageEnView.DeSelect;
        PaintBrush1.Down := False;
        Line1.Down := False;
        Rectangle1.Down := False;
        RoundRectangle1.Down := False;
        Ellipse1.Down := False;
      end;
    end;
  end;
end;

procedure TForm1.TrackBarBrushOpacity1Change(Sender: TObject);
begin
  BrushOpacity1.Text := IntToStr(TrackBarBrushOpacity1.Position);
end;

procedure TForm1.TrackBarPenOpacity1Change(Sender: TObject);
begin
  PenOpacity1.Text := IntToStr(TrackBarPenOpacity1.Position);
end;

procedure TForm1.TrackBarPenSize1Change(Sender: TObject);
begin
  PenSize1.Text := IntToStr(TrackBarPenSize1.Position);
end;

procedure TForm1.TrackBarZoom1Change(Sender: TObject);
var
  iPoint: TPoint;
  iOffset: Integer;
  iSpace: Integer;
begin
  if TrackBarZoom1.MouseInClient then
  begin
    { Set position to mouse cursor position }
    iPoint := mouse.CursorPos;
    iSpace := 11; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - TrackBarZoom1.Left - iSpace;
    with TrackBarZoom1 do
      Position := Round(min + iOffset / (Width - 2 * iSpace) * (max - min));
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        ImageEnView.Zoom := TrackBarZoom1.Position;
        UpdateStatusBar;
      end;
    end;
  end;
end;

{ To add PDF file IO support install wpcubedPDF and unremark the following }

(*

  {$I PDFLicense.INC}

  initialization

  glWPViewPDF_DLLName := WPViewPDF_DLLName;
  glWPViewPDF_DLLName64 := WPViewPDF_DLLName64;
  glWPViewPDF_LicName := WPViewPDF_LicName;
  glWPViewPDF_LicKey := WPViewPDF_LicKey;
  glWPViewPDF_LicCode := WPViewPDF_LicCode;

*)

end.
